# -*- coding: utf-8 -*-
# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.1
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _numerics
else:
    import _numerics

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


SICONOS_CXXVERSION = _numerics.SICONOS_CXXVERSION
ALLOC_CTRL_I = _numerics.ALLOC_CTRL_I
ALLOC_CTRL_P = _numerics.ALLOC_CTRL_P

def NM_clean_cs(m: "CSparseMatrix *", alloc_ctrl: "int") -> "void":
    return _numerics.NM_clean_cs(m, alloc_ctrl)

def NM_clean(M: "NumericsMatrix", alloc_ctrl: "int") -> "int":
    return _numerics.NM_clean(M, alloc_ctrl)

def sane_pyseq_check(o: "PyObject *") -> "bool":
    return _numerics.sane_pyseq_check(o)

def _sn_check_nnz(mat: "PyObject **", M: "CSparseMatrix *") -> "void":
    return _numerics._sn_check_nnz(mat, M)

def _sn_check_shape(mat: "PyObject **", M: "CSparseMatrix *") -> "void":
    return _numerics._sn_check_shape(mat, M)

def is_Pyobject_scipy_sparse_matrix(o: "PyObject *", scipy_mod: "PyObject *") -> "bool":
    return _numerics.is_Pyobject_scipy_sparse_matrix(o, scipy_mod)

def linearComplementarity_driver(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_driver(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    General interface to solvers for Linear Complementarity Problems.  

    Parameters
    ----------

    problem :  
        the LinearComplementarityProblem structure which handles the problem (M,q)  

    z :  
        a n-vector of doubles which contains the solution of the problem.  

    w :  
        a n-vector of doubles which contains the solution of the problem.  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    info termination value  

    *   0 : successful  
    *   >0 : otherwise see each solver for more information about the log info  

    """
    return _numerics.linearComplementarity_driver(problem, z, w, options)

def mlcp_driver(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    mlcp_driver(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    General interface to solver for MLCP problems.  

    Parameters
    ----------

    problem :  
        the MixedLinearComplementarityProblem structure which handles the problem
        (M,q)  

    z :  
        a m+n-vector of doubles which contains the solution of the problem.  

    w :  
        a m+n-vector of doubles which contains the solution of the problem.  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    info termination value  

    *   0 : successful  
    *   >0 : otherwise see each solver for more information about the log info  

    """
    return _numerics.mlcp_driver(problem, z, w, options)

def fc2d_driver(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int":
    r"""
    fc2d_driver(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, SolverOptions *options) -> int

    General interface to solvers for friction-contact 2D problem.  

    Parameters
    ----------

    problem :  
        the structure which handles the Friction-Contact problem  

    reaction :  
        global vector (n)  

    velocity :  
        global vector (n)  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    result (0 if successful otherwise 1).  

    """
    return _numerics.fc2d_driver(problem, reaction, velocity, options)

def fc3d_driver(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int":
    r"""
    fc3d_driver(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, SolverOptions *options) -> int

    General interface to solvers for friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the structure which handles the Friction-Contact problem  

    reaction :  
        global vector (n)  

    velocity :  
        global vector (n)  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    result (0 if successful otherwise 1).  

    """
    return _numerics.fc3d_driver(problem, reaction, velocity, options)

def gfc3d_driver(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int":
    r"""
    gfc3d_driver(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, SolverOptions *options) -> int

    General interface to solvers for global friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the structure which handles the Friction-Contact problem  

    reaction :  
        global vector (n)  

    velocity :  
        global vector (n)  

    globalVelocity :  
        global vector  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    result (0 if successful otherwise 1).  

    """
    return _numerics.gfc3d_driver(problem, reaction, velocity, globalVelocity, options)

def variationalInequality_driver(problem: "VI", x: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    variationalInequality_driver(VariationalInequality *problem, array_like (np.float64, 1D)x, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    General interface to solvers for friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the structure which handles the Friction-Contact problem  

    x :  
        global vector (n)  

    w :  
        global vector (n)  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    result (0 if successful otherwise 1).  

    """
    return _numerics.variationalInequality_driver(problem, x, w, options)

def avi_driver(problem: "AVI", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    avi_driver(AffineVariationalInequalities *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    General interface to solvers for Affine Variational Inequalities (AVI)  

    Parameters
    ----------

    problem :  
        the AffineVariationalInequalities structure which handles the problem (M,q)  

    z :  
        a n-vector of doubles which contains the solution of the problem.  

    w :  
        a n-vector of doubles which contains the solution of the problem.  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    info termination value  

    *   0 : successful  
    *   >0 : otherwise see each solver for more information about the log info  

    """
    return _numerics.avi_driver(problem, z, w, options)

def mcp_driver(problem: "MCP", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    mcp_driver(MixedComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    General interface to solver for MCP problems.  

    Parameters
    ----------

    problem :  
        the MixedComplementarityProblem structure which handles the problem  

    z :  
        a m+n-vector of doubles which contains the solution of the problem.  

    w :  
        a m+n-vector of doubles which contains the solution of the problem.  

    options :  
        structure used to define the solver(s) and its(their) parameters  

    Returns
    -------
    info termination value 0 : successful, else error.  

    """
    return _numerics.mcp_driver(problem, z, w, options)

def mcp_driver2(problem: "MixedComplementarityProblem2", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    mcp_driver2(MixedComplementarityProblem2 *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    General interface to solver for MCP problems -- new version.  

    Parameters
    ----------

    problem :  
        the MixedComplementarityProblem2 structure which handles the problem  

    z :  
        a m+n-vector of doubles which contains the solution of the problem.  

    w :  
        a m+n-vector of doubles which contains the solution of the problem.  

    options :  
        structure used to define the solver(s) and its(their) parameters  

    Returns
    -------
    info termination value 0 : successful, else error.  

    """
    return _numerics.mcp_driver2(problem, z, w, options)

def ncp_driver(problem: "NCP", z: "double *", F: "double *", options: "SolverOptions") -> "int":
    r"""
    ncp_driver(NonlinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)F, SolverOptions *options) -> int

    General interface to solver for NCP problems.  

    Parameters
    ----------

    problem :  
        the NonlinearComplementarityProblem structure which handles the problem  

    z :  
        a n-vector of doubles which contains the solution of the problem.  

    F :  
        a n-vector of doubles which contains value of the function evaluated at the
        solution of the problem.  

    options :  
        structure used to define the solver(s) and its(their) parameters  

    Returns
    -------
    info termination value 0 : successful, else error  

    """
    return _numerics.ncp_driver(problem, z, F, options)

def soclcp_driver(problem: "SecondOrderConeLinearComplementarityProblem", r: "double *", v: "double *", options: "SolverOptions") -> "int":
    r"""
    soclcp_driver(SecondOrderConeLinearComplementarityProblem *problem, array_like (np.float64, 1D)r, array_like (np.float64, 1D)v, SolverOptions *options) -> int

    General interface to solvers for SOCLCP problem.  

    Parameters
    ----------

    problem :  
        the structure which handles the Friction-Contact problem  

    r :  
        global vector (n)  

    v :  
        global vector (n)  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    result (0 if successful otherwise 1).  

    """
    return _numerics.soclcp_driver(problem, r, v, options)

def fc3d_LmgcDriver(reaction: "double *", velocity: "double *", q: "double *", mu: "double *", W: "double *", row: "unsigned int *", column: "unsigned int *", nc: "unsigned int", nb: "unsigned int", solver_id: "int", tolerance: "double", itermax: "int", verbose: "int", outputFile: "int", freq_output: "int", ndof: "int") -> "int":
    r"""
    fc3d_LmgcDriver(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)q, array_like (np.float64, 1D)mu, array_like (np.float64, 1D)W,  int *row,  int *column,  int nc,  int nb, int solver_id, double tolerance, int itermax, int verbose, int outputFile, int freq_output, int ndof) -> int

    LMGC interface to solvers for friction-contact 3D problem.  

    Parameters
    ----------

    reaction :  
        global vector (nc*3)  

    velocity :  
        global vector (nc*3)  

    q :  
        global vector (nc*3)  

    mu :  
        global vector (nc)  

    W :  
        the block matrix in coordinate format  

    row :  
        block row indices  

    column :  
        block column indices  

    nc :  
        number of contacts  

    nb :  
        number of blocks  

    solver_id :  
        id an int to be mapped to actual solver in Numerics  

    tolerance :  
        threshold used to validate the solution: if the error is less than this
        value, the solution is accepted  

    itermax :  
        the maximum number of iteration  

    verbose :  
        level 0 : nothing, 1: mid level 2: high level  

    outputFile :  
        outputFile option 0 : nothing 1 : dat file 2: FCLIB HDF5 file if FCLIB is
        found  

    freq_output :  

    ndof :  
        the numbe of dof in the dynamical systems involved in contact (for output in
        file.)  

    Returns
    -------
    result (0 if successful otherwise 1).  

    """
    return _numerics.fc3d_LmgcDriver(reaction, velocity, q, mu, W, row, column, nc, nb, solver_id, tolerance, itermax, verbose, outputFile, freq_output, ndof)

def gfc3d_LmgcDriver(reaction: "double *", velocity: "double *", globalVelocity: "double *", q: "double *", b: "double *", mu: "double *", Mdata: "double *", nzM: "unsigned int", rowM: "unsigned int *", colM: "unsigned int *", Hdata: "double *", nzH: "unsigned int", rowH: "unsigned int *", colH: "unsigned int *", n: "unsigned int", nc: "unsigned int", solver_id: "int", isize: "int", iparam: "int *", dsize: "int", dparam: "double *", verbose: "int", outputFile: "int", freq_output: "int") -> "int":
    r"""
    gfc3d_LmgcDriver(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, array_like (np.float64, 1D)q, array_like (np.float64, 1D)b, array_like (np.float64, 1D)mu, array_like (np.float64, 1D)Mdata,  int nzM,  int *rowM,  int *colM, array_like (np.float64, 1D)Hdata,  int nzH,  int *rowH,  int *colH,  int n,  int nc, int solver_id, int isize, int *iparam, int dsize, array_like (np.float64, 1D)dparam, int verbose, int outputFile, int freq_output) -> int

    LMGC interface to solvers for global friction-contact 3D problem.  

    Parameters
    ----------

    reaction :  
        global vector (nc*3)  

    velocity :  
        global vector (nc*3)  

    globalVelocity :  
        global velocity vector (n)  

    q :  
        global vector (n)  

    b :  
        global vector (nc*3)  

    mu :  
        global vector (nc)  

    Mdata :  
        the sparse matrix in coordinate format  

    nzM :  
        number of non zeros in Mdata  

    rowM :  
        row indices of M  

    colM :  
        column indices of M  

    Hdata :  
        the sparse matrix in coordinate format  

    nzH :  
        number of non zeros in Hdata  

    rowH :  
        row indices of H  

    colH :  
        column indices of H  

    n :  
        size of global velocity  

    nc :  
        number of contacts  

    solver_id :  
        id an int to be mapped to actual solver in Numerics  

    isize :  
        sive of integer parameters array  

    iparam :  
        integer parameters array  

    dsize :  
        sive of double parameters array  

    dparam :  
        double parameters array  

    verbose :  
        level 0 : nothing, 1: mid level 2: high level  

    outputFile :  
        outputFile option 0 : nothing 1 : C file , 1 : dat file 3: FCLIB HDF5 file
        if FCLIB is found  

    freq_output :  

    Returns
    -------
    result (0 if successful otherwise 1).  

    """
    return _numerics.gfc3d_LmgcDriver(reaction, velocity, globalVelocity, q, b, mu, Mdata, nzM, rowM, colM, Hdata, nzH, rowH, colH, n, nc, solver_id, isize, iparam, dsize, dparam, verbose, outputFile, freq_output)

def relay_driver(problem: "RelayProblem *", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    relay_driver(RelayProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    General interface to solver for relay problems.  

    Parameters
    ----------

    problem :  
        the RelayProblem structure which handles the problem (M,q)  

    z :  
        a n-vector of doubles which contains the solution of the problem.  

    w :  
        a n-vector of doubles which contains the solution of the problem.  

    options :  
        structure used to define the solver(s) and its (their) parameters  

    Returns
    -------
    info termination value  

    *   0 : successful  
    *   >0 : otherwise see each solver for more information about the log info  

    """
    return _numerics.relay_driver(problem, z, w, options)
class Callback(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    env = property(_numerics.Callback_env_get, _numerics.Callback_env_set)
    collectStatsIteration = property(_numerics.Callback_collectStatsIteration_get, _numerics.Callback_collectStatsIteration_set)

    def __init__(self):
        _numerics.Callback_swiginit(self, _numerics.new_Callback())
    __swig_destroy__ = _numerics.delete_Callback

# Register Callback in _numerics:
_numerics.Callback_swigregister(Callback)

class SolverOptions(object):
    r"""

    Attributes
    ----------
     callback : `Callback *`  
        callback a pointer to user Callback  

     dparam : `array_like (np.float64, 1D)`  
        dparam a list of double parameters (depends on each solver, see solver doc)  

     dSize : `int`  
        dSize size of vector dparam  

     dWork : `array_like (np.float64, 1D)`  
        dWork is a pointer on a working memory zone (for doubles) reserved for the
        solver .  

     dWorkSize : `int`  
        dWorkSize size of vector iWork  

     filterOn : `int`  
        filterOn 1 to check solution validity after the driver call, else 0.  

        Default = 1. (For example if filterOn = 1 for a LCP, lcp_compute_error()
        will be called at the end of the process)  

     internalSolvers : `struct SolverOptions *`  
        internalSolvers pointer to sub-solvers  

     iparam : `int *`  
        iparam a list of int parameters (depends on each solver, see solver doc)  

     iSize : `int`  
        iSize size of vector iparam  

     isSet : `int`  
        isSet int equal to false(0) if the parameters below have not been set (ie
        need to read default values) else true(1)  

     iWork : `int *`  
        iWork is a pointer on a working memory zone (for integers) reserved for the
        solver .  

     iWorkSize : `int`  
        iWorkSize size of vector iWork  

     numberOfInternalSolvers : `int`  
        numberOfInternalSolvers the number of internal or local 'sub-solvers' used
        by the solver  

     solverData : `None *`  
        additional data specific to the solver  

     solverId : `int`  
        solverId Id of the solver (see )  

     solverParameters : `None *`  
        additional parameters specific to the solver  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    solverId = property(_numerics.SolverOptions_solverId_get, _numerics.SolverOptions_solverId_set)
    isSet = property(_numerics.SolverOptions_isSet_get, _numerics.SolverOptions_isSet_set)
    iSize = property(_numerics.SolverOptions_iSize_get, _numerics.SolverOptions_iSize_set)
    iparam = property(_numerics.SolverOptions_iparam_get, _numerics.SolverOptions_iparam_set)
    dSize = property(_numerics.SolverOptions_dSize_get, _numerics.SolverOptions_dSize_set)
    dparam = property(_numerics.SolverOptions_dparam_get, _numerics.SolverOptions_dparam_set)
    filterOn = property(_numerics.SolverOptions_filterOn_get, _numerics.SolverOptions_filterOn_set)
    dWorkSize = property(_numerics.SolverOptions_dWorkSize_get, _numerics.SolverOptions_dWorkSize_set)
    dWork = property(_numerics.SolverOptions_dWork_get, _numerics.SolverOptions_dWork_set)
    iWorkSize = property(_numerics.SolverOptions_iWorkSize_get, _numerics.SolverOptions_iWorkSize_set)
    iWork = property(_numerics.SolverOptions_iWork_get, _numerics.SolverOptions_iWork_set)
    numberOfInternalSolvers = property(_numerics.SolverOptions_numberOfInternalSolvers_get, _numerics.SolverOptions_numberOfInternalSolvers_set)
    internalSolvers = property(_numerics.SolverOptions_internalSolvers_get, _numerics.SolverOptions_internalSolvers_set)
    callback = property(_numerics.SolverOptions_callback_get, _numerics.SolverOptions_callback_set)
    solverParameters = property(_numerics.SolverOptions_solverParameters_get, _numerics.SolverOptions_solverParameters_set)
    solverData = property(_numerics.SolverOptions_solverData_get, _numerics.SolverOptions_solverData_set)

    def __init__(self, *args):
        r"""

        Attributes
        ----------
         callback : `Callback *`  
            callback a pointer to user Callback  

         dparam : `array_like (np.float64, 1D)`  
            dparam a list of double parameters (depends on each solver, see solver doc)  

         dSize : `int`  
            dSize size of vector dparam  

         dWork : `array_like (np.float64, 1D)`  
            dWork is a pointer on a working memory zone (for doubles) reserved for the
            solver .  

         dWorkSize : `int`  
            dWorkSize size of vector iWork  

         filterOn : `int`  
            filterOn 1 to check solution validity after the driver call, else 0.  

            Default = 1. (For example if filterOn = 1 for a LCP, lcp_compute_error()
            will be called at the end of the process)  

         internalSolvers : `struct SolverOptions *`  
            internalSolvers pointer to sub-solvers  

         iparam : `int *`  
            iparam a list of int parameters (depends on each solver, see solver doc)  

         iSize : `int`  
            iSize size of vector iparam  

         isSet : `int`  
            isSet int equal to false(0) if the parameters below have not been set (ie
            need to read default values) else true(1)  

         iWork : `int *`  
            iWork is a pointer on a working memory zone (for integers) reserved for the
            solver .  

         iWorkSize : `int`  
            iWorkSize size of vector iWork  

         numberOfInternalSolvers : `int`  
            numberOfInternalSolvers the number of internal or local 'sub-solvers' used
            by the solver  

         solverData : `None *`  
            additional data specific to the solver  

         solverId : `int`  
            solverId Id of the solver (see )  

         solverParameters : `None *`  
            additional parameters specific to the solver  

        """
        _numerics.SolverOptions_swiginit(self, _numerics.new_SolverOptions(*args))
    __swig_destroy__ = _numerics.delete_SolverOptions

# Register SolverOptions in _numerics:
_numerics.SolverOptions_swigregister(SolverOptions)

SICONOS_NUMERICS_PROBLEM_LCP = _numerics.SICONOS_NUMERICS_PROBLEM_LCP
SICONOS_NUMERICS_PROBLEM_MLCP = _numerics.SICONOS_NUMERICS_PROBLEM_MLCP
SICONOS_NUMERICS_PROBLEM_EQUALITY = _numerics.SICONOS_NUMERICS_PROBLEM_EQUALITY
SICONOS_NUMERICS_PROBLEM_FC2D = _numerics.SICONOS_NUMERICS_PROBLEM_FC2D
SICONOS_NUMERICS_PROBLEM_FC3D = _numerics.SICONOS_NUMERICS_PROBLEM_FC3D
SICONOS_NUMERICS_PROBLEM_NCP = _numerics.SICONOS_NUMERICS_PROBLEM_NCP
SICONOS_NUMERICS_PROBLEM_MCP = _numerics.SICONOS_NUMERICS_PROBLEM_MCP
SICONOS_NUMERICS_PROBLEM_VI = _numerics.SICONOS_NUMERICS_PROBLEM_VI
SICONOS_NUMERICS_PROBLEM_AVI = _numerics.SICONOS_NUMERICS_PROBLEM_AVI
SICONOS_NUMERICS_PROBLEM_RELAY = _numerics.SICONOS_NUMERICS_PROBLEM_RELAY
SICONOS_IPARAM_MAX_ITER = _numerics.SICONOS_IPARAM_MAX_ITER
SICONOS_IPARAM_ITER_DONE = _numerics.SICONOS_IPARAM_ITER_DONE
SICONOS_IPARAM_PREALLOC = _numerics.SICONOS_IPARAM_PREALLOC
SICONOS_IPARAM_PIVOT_RULE = _numerics.SICONOS_IPARAM_PIVOT_RULE
SICONOS_IPARAM_PATHSEARCH_STACKSIZE = _numerics.SICONOS_IPARAM_PATHSEARCH_STACKSIZE
SICONOS_IPARAM_LSA_NONMONOTONE_LS = _numerics.SICONOS_IPARAM_LSA_NONMONOTONE_LS
SICONOS_IPARAM_LSA_NONMONOTONE_LS_M = _numerics.SICONOS_IPARAM_LSA_NONMONOTONE_LS_M
SICONOS_IPARAM_LSA_FORCE_ARCSEARCH = _numerics.SICONOS_IPARAM_LSA_FORCE_ARCSEARCH
SICONOS_IPARAM_LSA_SEARCH_CRITERION = _numerics.SICONOS_IPARAM_LSA_SEARCH_CRITERION
SICONOS_IPARAM_GOLDSTEIN_ITERMAX = _numerics.SICONOS_IPARAM_GOLDSTEIN_ITERMAX
SICONOS_IPARAM_NMS_WATCHDOG_TYPE = _numerics.SICONOS_IPARAM_NMS_WATCHDOG_TYPE
SICONOS_IPARAM_NMS_PROJECTED_GRADIENT_TYPE = _numerics.SICONOS_IPARAM_NMS_PROJECTED_GRADIENT_TYPE
SICONOS_IPARAM_NMS_N_MAX = _numerics.SICONOS_IPARAM_NMS_N_MAX
SICONOS_DPARAM_TOL = _numerics.SICONOS_DPARAM_TOL
SICONOS_DPARAM_RESIDU = _numerics.SICONOS_DPARAM_RESIDU
SICONOS_DPARAM_LSA_ALPHA_MIN = _numerics.SICONOS_DPARAM_LSA_ALPHA_MIN
SICONOS_DPARAM_GOLDSTEIN_C = _numerics.SICONOS_DPARAM_GOLDSTEIN_C
SICONOS_DPARAM_GOLDSTEIN_ALPHAMAX = _numerics.SICONOS_DPARAM_GOLDSTEIN_ALPHAMAX
SICONOS_DPARAM_NMS_DELTA = _numerics.SICONOS_DPARAM_NMS_DELTA
SICONOS_DPARAM_NMS_DELTA_VAR = _numerics.SICONOS_DPARAM_NMS_DELTA_VAR
SICONOS_DPARAM_NMS_SIGMA = _numerics.SICONOS_DPARAM_NMS_SIGMA
SICONOS_DPARAM_NMS_ALPHA_MIN_WATCHDOG = _numerics.SICONOS_DPARAM_NMS_ALPHA_MIN_WATCHDOG
SICONOS_DPARAM_NMS_ALPHA_MIN_PGRAD = _numerics.SICONOS_DPARAM_NMS_ALPHA_MIN_PGRAD
SICONOS_DPARAM_NMS_MERIT_INCR = _numerics.SICONOS_DPARAM_NMS_MERIT_INCR

def solver_options_print(options: "SolverOptions") -> "void":
    r"""
    solver_options_print(SolverOptions *options) -> None

    screen display of solver parameters  

    Parameters
    ----------

    options :  
        the structure to be displayed  

    """
    return _numerics.solver_options_print(options)

def solver_options_delete(options: "SolverOptions") -> "void":
    r"""
    solver_options_delete(SolverOptions *options) -> None

    free some SolverOptions fields;  

    Parameters
    ----------

    options :  
        the structure to clean  

    """
    return _numerics.solver_options_delete(options)

def solver_options_nullify(options: "SolverOptions") -> "void":
    r"""
    solver_options_nullify(SolverOptions *options) -> None

    """
    return _numerics.solver_options_nullify(options)

def solver_options_fill(options: "SolverOptions", solverId: "int", iSize: "int", dSize: "int", iter_max: "int", tol: "double") -> "void":
    r"""
    solver_options_fill(SolverOptions *options, int solverId, int iSize, int dSize, int iter_max, double tol) -> None

    fill a SolverOptions struct: set fields, allocate memory and set common values  

    Parameters
    ----------

    options :  
        struct to fill  

    solverId :  
        identity of the solver  

    iSize :  
        size of the iparam field (integer parameters)  

    dSize :  
        size of the dparam field (double parameters)  

    iter_max :  
        maximum number of iterations before the solver stops if this does not make
        sense or is unwanted, give inf as value  

    tol :  
        tolerance for the solution. if this does not make sense or is unwanted, give
        inf as value  

    """
    return _numerics.solver_options_fill(options, solverId, iSize, dSize, iter_max, tol)

def solver_options_set(options: "SolverOptions", solverId: "int") -> "void":
    r"""
    solver_options_set(SolverOptions *options, int solverId) -> None

    set parameters in SolverOption.  

    This function should be used instead of rewrittent each time a new function for
    setting the parameters  

    Parameters
    ----------

    options :  
        the struct to set  

    solverId :  
        the id of the solver  

    """
    return _numerics.solver_options_set(options, solverId)

def solver_options_name_to_id(pName: "char *") -> "int":
    r"""
    solver_options_name_to_id(char *pName) -> int

    return the id of a solver based on its name  

    Parameters
    ----------

    pName :  
        the name of the solver  

    Returns
    -------
    the id of the solver or 0 if it failed  

    """
    return _numerics.solver_options_name_to_id(pName)

def solver_options_id_to_name(Id: "int") -> "char const *":
    r"""
    solver_options_id_to_name(int Id) ->  char *

    return the name of a solver given its id  

    Parameters
    ----------

    Id :  
        the id of the solver  

    Returns
    -------
    the name of the solver  

    """
    return _numerics.solver_options_id_to_name(Id)

def ns_problem_id_to_name(id: "int") -> "char const *":
    r"""
    ns_problem_id_to_name(int id) ->  char *

    return the name of a problem type (LCP, NCP, VI, ...) based on its id  

    Parameters
    ----------

    id :  
        the id of the problem  

    Returns
    -------
    the name of the problem  

    """
    return _numerics.ns_problem_id_to_name(id)

def solver_options_free_solver_specific_data(options: "SolverOptions") -> "void":
    r"""
    solver_options_free_solver_specific_data(SolverOptions *options) -> None

    free the solverData structure  

    Parameters
    ----------

    options :  
        the structure to free  

    """
    return _numerics.solver_options_free_solver_specific_data(options)

def solver_options_copy(options_ori: "SolverOptions", options: "SolverOptions") -> "void":
    r"""
    solver_options_copy(SolverOptions *options_ori, SolverOptions *options) -> None

    copy SolverOptions  

    Parameters
    ----------

    options_ori :  
        the structure to copy  

    options :  
        the output structure  

    """
    return _numerics.solver_options_copy(options_ori, options)

def solver_options_get_internal_solver(options: "SolverOptions", n: "int") -> "SolverOptions *":
    r"""
    solver_options_get_internal_solver(SolverOptions *options, int n) -> SolverOptions *

    """
    return _numerics.solver_options_get_internal_solver(options, n)
NUMERICS_LOG_TO_SCREEN = _numerics.NUMERICS_LOG_TO_SCREEN
NUMERICS_LOG_TO_FILE = _numerics.NUMERICS_LOG_TO_FILE
NUMERICS_EXTERNAL_LOGGER = _numerics.NUMERICS_EXTERNAL_LOGGER

def numerics_set_verbose(newVerboseMode: "int") -> "void":
    r"""
    numerics_set_verbose(int newVerboseMode) -> None

    """
    return _numerics.numerics_set_verbose(newVerboseMode)

def numerics_error(*args) -> "void":
    return _numerics.numerics_error(*args)

def numerics_error_nonfatal(*args) -> "void":
    return _numerics.numerics_error_nonfatal(*args)

def numerics_warning(*args) -> "void":
    return _numerics.numerics_warning(*args)

def numerics_printf(*args) -> "void":
    return _numerics.numerics_printf(*args)

def numerics_printf_verbose(*args) -> "void":
    return _numerics.numerics_printf_verbose(*args)

def isqrt(n: "unsigned int") -> "unsigned int":
    return _numerics.isqrt(n)

def compiled_in_debug_mode() -> "int":
    return _numerics.compiled_in_debug_mode()

def set_cstruct(p_env: "uintptr_t", p_struct: "void *") -> "void":
    return _numerics.set_cstruct(p_env, p_struct)
class CSparseMatrix_lu_factors(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    n = property(_numerics.CSparseMatrix_lu_factors_n_get, _numerics.CSparseMatrix_lu_factors_n_set)
    S = property(_numerics.CSparseMatrix_lu_factors_S_get, _numerics.CSparseMatrix_lu_factors_S_set)
    N = property(_numerics.CSparseMatrix_lu_factors_N_get, _numerics.CSparseMatrix_lu_factors_N_set)

    def __init__(self):
        _numerics.CSparseMatrix_lu_factors_swiginit(self, _numerics.new_CSparseMatrix_lu_factors())
    __swig_destroy__ = _numerics.delete_CSparseMatrix_lu_factors

# Register CSparseMatrix_lu_factors in _numerics:
_numerics.CSparseMatrix_lu_factors_swigregister(CSparseMatrix_lu_factors)
cvar = _numerics.cvar
SICONOS_NUMERICS_PROBLEM_LCP_STR = cvar.SICONOS_NUMERICS_PROBLEM_LCP_STR
SICONOS_NUMERICS_PROBLEM_MLCP_STR = cvar.SICONOS_NUMERICS_PROBLEM_MLCP_STR
SICONOS_NUMERICS_PROBLEM_NCP_STR = cvar.SICONOS_NUMERICS_PROBLEM_NCP_STR
SICONOS_NUMERICS_PROBLEM_MCP_STR = cvar.SICONOS_NUMERICS_PROBLEM_MCP_STR
SICONOS_NUMERICS_PROBLEM_EQUALITY_STR = cvar.SICONOS_NUMERICS_PROBLEM_EQUALITY_STR
SICONOS_NUMERICS_PROBLEM_FC2D_STR = cvar.SICONOS_NUMERICS_PROBLEM_FC2D_STR
SICONOS_NUMERICS_PROBLEM_FC3D_STR = cvar.SICONOS_NUMERICS_PROBLEM_FC3D_STR
SICONOS_NUMERICS_PROBLEM_VI_STR = cvar.SICONOS_NUMERICS_PROBLEM_VI_STR
SICONOS_NUMERICS_PROBLEM_AVI_STR = cvar.SICONOS_NUMERICS_PROBLEM_AVI_STR
SICONOS_NUMERICS_PROBLEM_RELAY_STR = cvar.SICONOS_NUMERICS_PROBLEM_RELAY_STR


def CSparsematrix_lu_factorization(order: "long", A: "CSparseMatrix const *", tol: "double", cs_lu_A: "CSparseMatrix_lu_factors") -> "int":
    r"""
    CSparsematrix_lu_factorization(CS_INT order,  CSparseMatrix *A, double tol, CSparseMatrix_lu_factors *cs_lu_A) -> int

    compute a LU factorization of A and store it in a workspace  

    Parameters
    ----------

    order :  
        control if ordering is used  

    A :  
        the sparse matrix  

    tol :  
        the tolerance  

    cs_lu_A :  
        the parameter structure that eventually holds the factors  

    Returns
    -------
    1 if the factorization was successful, 1 otherwise  

    """
    return _numerics.CSparsematrix_lu_factorization(order, A, tol, cs_lu_A)

def CSparseMatrix_solve(cs_lu_A: "CSparseMatrix_lu_factors", x: "double *", b: "double *") -> "long":
    r"""
    CSparseMatrix_solve(CSparseMatrix_lu_factors *cs_lu_A, array_like (np.float64, 1D)x, array_like (np.float64, 1D)b) -> CS_INT

    reuse a LU factorization (stored in the cs_lu_A) to solve a linear system Ax = b  

    Parameters
    ----------

    cs_lu_A :  
        contains the LU factors of A, permutation information  

    x :  
        workspace  

    b :  
        on input RHS of the linear system; on output the solution  

    Returns
    -------
    0 if failed, 1 otherwise  

    """
    return _numerics.CSparseMatrix_solve(cs_lu_A, x, b)

def CSparseMatrix_free_lu_factors(cs_lu_A: "CSparseMatrix_lu_factors") -> "void":
    r"""
    CSparseMatrix_free_lu_factors(CSparseMatrix_lu_factors *cs_lu_A) -> None

    Free a workspace related to a LU factorization.  

    Parameters
    ----------

    cs_lu_A :  
        the structure to free  

    """
    return _numerics.CSparseMatrix_free_lu_factors(cs_lu_A)

def CSparseMatrix_aaxpby(alpha: "double const", A: "CSparseMatrix const *", x: "double const *", beta: "double const", y: "double *") -> "int":
    r"""
    CSparseMatrix_aaxpby( double alpha,  CSparseMatrix *A,  array_like (np.float64, 1D)x,  double beta, array_like (np.float64, 1D)y) -> int

    Matrix vector multiplication : y = alpha*A*x+beta*y.  

    Parameters
    ----------

    alpha :  
        matrix coefficient  

    A :  
        the sparse matrix  

    x :  
        pointer on a dense vector of size A->n  

    beta :  
        vector coefficient  

    y :  
        pointer on a dense vector of size A->n  

    Returns
    -------
    0 if A x or y is NULL else 1  

    """
    return _numerics.CSparseMatrix_aaxpby(alpha, A, x, beta, y)

def CSparseMatrix_alloc_for_copy(m: "CSparseMatrix const *const") -> "CSparseMatrix *":
    r"""
    CSparseMatrix_alloc_for_copy( CSparseMatrix * m) -> CSparseMatrix *

    Allocate a CSparse matrix for future copy (as in NSM_copy)  

    Parameters
    ----------

    m :  
        the matrix used as model  

    Returns
    -------
    an newly allocated matrix  

    """
    return _numerics.CSparseMatrix_alloc_for_copy(m)

def CSparseMatrix_to_dense(A: "CSparseMatrix const *const", B: "double *") -> "long":
    r"""
    CSparseMatrix_to_dense( CSparseMatrix * A, array_like (np.float64, 1D)B) -> CS_INT

    """
    return _numerics.CSparseMatrix_to_dense(A, B)

def CSparseMatrix_print_in_file(A: "CSparseMatrix const *", brief: "int", file: "FILE *") -> "int":
    r"""
    CSparseMatrix_print_in_file( CSparseMatrix *A, int brief, FILE *file) -> int

    print a matrix to a text file  

    Parameters
    ----------

    A :  
        matrix to print  

    brief :  
        if positive, print only a portion of the matrix  

    file :  
        file descriptor  

    """
    return _numerics.CSparseMatrix_print_in_file(A, brief, file)

def CSparseMatrix_new_from_file(file: "FILE *") -> "CSparseMatrix *":
    r"""
    CSparseMatrix_new_from_file(FILE *file) -> CSparseMatrix *

    """
    return _numerics.CSparseMatrix_new_from_file(file)

def CSparseMatrix_zentry(T: "CSparseMatrix *", i: "long", j: "long", x: "double") -> "long":
    r"""
    CSparseMatrix_zentry(CSparseMatrix *T, CS_INT i, CS_INT j, double x) -> CS_INT

    Add an entry to a triplet matrix only if the absolute value is greater than
    DBL_EPSILON.  

    Parameters
    ----------

    T :  
        the sparse matrix  

    i :  
        row index  

    j :  
        column index  

    x :  
        the value  

    Returns
    -------
    integer value : 1 if the absolute value is less than DBL_EPSILON, otherwise the
    return value of cs_entry.  

    """
    return _numerics.CSparseMatrix_zentry(T, i, j, x)

def CSparseMatrix_check_triplet(T: "CSparseMatrix *") -> "int":
    r"""
    CSparseMatrix_check_triplet(CSparseMatrix *T) -> int

    Check if the given triplet matrix is properly constructed (col and row indices
    are correct)  

    Parameters
    ----------

    T :  
        the sparse matrix to check  

    Returns
    -------
    0 if the matrix is fine, 1 otherwise  

    """
    return _numerics.CSparseMatrix_check_triplet(T)

def CSparseMatrix_check_csc(T: "CSparseMatrix *") -> "int":
    r"""
    CSparseMatrix_check_csc(CSparseMatrix *T) -> int

    Check if the given triplet matrix is properly constructed (col and row indices
    are correct)  

    Parameters
    ----------

    T :  
        the sparse matrix to check  

    Returns
    -------
    0 if the matrix is fine, 1 otherwise  

    """
    return _numerics.CSparseMatrix_check_csc(T)

def CSparseMatrix_spfree_on_stack(A: "CSparseMatrix *") -> "CSparseMatrix *":
    r"""
    CSparseMatrix_spfree_on_stack(CSparseMatrix *A) -> CSparseMatrix *

    Free space allocated for a SparseMatrix.  

    note : cs_spfree also free the cs_struct this fails when the struct is allocated
    on the stack.  

    Parameters
    ----------

    A :  
        the sparse matrix  

    Returns
    -------
    NULL on success  

    """
    return _numerics.CSparseMatrix_spfree_on_stack(A)

def CSparseMatrix_copy(A: "CSparseMatrix const *const", B: "CSparseMatrix *") -> "void":
    r"""
    CSparseMatrix_copy( CSparseMatrix * A, CSparseMatrix *B) -> None

    Copy a CSparseMatrix inside another CSparseMatrix.  

    Reallocations are performed if B cannot hold a copy of A  

    Parameters
    ----------

    A :  
        a CSparseMatrix  

    B :  
        a CSparseMatrix  

    """
    return _numerics.CSparseMatrix_copy(A, B)
class SparseBlockStructuredMatrix(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    nbblocks = property(_numerics.SparseBlockStructuredMatrix_nbblocks_get, _numerics.SparseBlockStructuredMatrix_nbblocks_set)
    block = property(_numerics.SparseBlockStructuredMatrix_block_get, _numerics.SparseBlockStructuredMatrix_block_set)
    blocknumber0 = property(_numerics.SparseBlockStructuredMatrix_blocknumber0_get, _numerics.SparseBlockStructuredMatrix_blocknumber0_set)
    blocknumber1 = property(_numerics.SparseBlockStructuredMatrix_blocknumber1_get, _numerics.SparseBlockStructuredMatrix_blocknumber1_set)
    blocksize0 = property(_numerics.SparseBlockStructuredMatrix_blocksize0_get, _numerics.SparseBlockStructuredMatrix_blocksize0_set)
    blocksize1 = property(_numerics.SparseBlockStructuredMatrix_blocksize1_get, _numerics.SparseBlockStructuredMatrix_blocksize1_set)
    filled1 = property(_numerics.SparseBlockStructuredMatrix_filled1_get, _numerics.SparseBlockStructuredMatrix_filled1_set)
    filled2 = property(_numerics.SparseBlockStructuredMatrix_filled2_get, _numerics.SparseBlockStructuredMatrix_filled2_set)
    index1_data = property(_numerics.SparseBlockStructuredMatrix_index1_data_get, _numerics.SparseBlockStructuredMatrix_index1_data_set)
    index2_data = property(_numerics.SparseBlockStructuredMatrix_index2_data_get, _numerics.SparseBlockStructuredMatrix_index2_data_set)
    diagonal_blocks = property(_numerics.SparseBlockStructuredMatrix_diagonal_blocks_get, _numerics.SparseBlockStructuredMatrix_diagonal_blocks_set)
    __swig_destroy__ = _numerics.delete_SparseBlockStructuredMatrix

    def __init__(self):
        _numerics.SparseBlockStructuredMatrix_swiginit(self, _numerics.new_SparseBlockStructuredMatrix())

# Register SparseBlockStructuredMatrix in _numerics:
_numerics.SparseBlockStructuredMatrix_swigregister(SparseBlockStructuredMatrix)

class SparseBlockCoordinateMatrix(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    nbblocks = property(_numerics.SparseBlockCoordinateMatrix_nbblocks_get, _numerics.SparseBlockCoordinateMatrix_nbblocks_set)
    blocknumber0 = property(_numerics.SparseBlockCoordinateMatrix_blocknumber0_get, _numerics.SparseBlockCoordinateMatrix_blocknumber0_set)
    blocknumber1 = property(_numerics.SparseBlockCoordinateMatrix_blocknumber1_get, _numerics.SparseBlockCoordinateMatrix_blocknumber1_set)
    block = property(_numerics.SparseBlockCoordinateMatrix_block_get, _numerics.SparseBlockCoordinateMatrix_block_set)
    blocksize0 = property(_numerics.SparseBlockCoordinateMatrix_blocksize0_get, _numerics.SparseBlockCoordinateMatrix_blocksize0_set)
    blocksize1 = property(_numerics.SparseBlockCoordinateMatrix_blocksize1_get, _numerics.SparseBlockCoordinateMatrix_blocksize1_set)
    row = property(_numerics.SparseBlockCoordinateMatrix_row_get, _numerics.SparseBlockCoordinateMatrix_row_set)
    column = property(_numerics.SparseBlockCoordinateMatrix_column_get, _numerics.SparseBlockCoordinateMatrix_column_set)

    def __init__(self):
        _numerics.SparseBlockCoordinateMatrix_swiginit(self, _numerics.new_SparseBlockCoordinateMatrix())
    __swig_destroy__ = _numerics.delete_SparseBlockCoordinateMatrix

# Register SparseBlockCoordinateMatrix in _numerics:
_numerics.SparseBlockCoordinateMatrix_swigregister(SparseBlockCoordinateMatrix)

class SparseBlockStructuredMatrixPred(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    nbbldiag = property(_numerics.SparseBlockStructuredMatrixPred_nbbldiag_get, _numerics.SparseBlockStructuredMatrixPred_nbbldiag_set)
    indic = property(_numerics.SparseBlockStructuredMatrixPred_indic_get, _numerics.SparseBlockStructuredMatrixPred_indic_set)
    indicop = property(_numerics.SparseBlockStructuredMatrixPred_indicop_get, _numerics.SparseBlockStructuredMatrixPred_indicop_set)
    submatlcp = property(_numerics.SparseBlockStructuredMatrixPred_submatlcp_get, _numerics.SparseBlockStructuredMatrixPred_submatlcp_set)
    submatlcpop = property(_numerics.SparseBlockStructuredMatrixPred_submatlcpop_get, _numerics.SparseBlockStructuredMatrixPred_submatlcpop_set)
    ipiv = property(_numerics.SparseBlockStructuredMatrixPred_ipiv_get, _numerics.SparseBlockStructuredMatrixPred_ipiv_set)
    sizesublcp = property(_numerics.SparseBlockStructuredMatrixPred_sizesublcp_get, _numerics.SparseBlockStructuredMatrixPred_sizesublcp_set)
    sizesublcpop = property(_numerics.SparseBlockStructuredMatrixPred_sizesublcpop_get, _numerics.SparseBlockStructuredMatrixPred_sizesublcpop_set)
    subq = property(_numerics.SparseBlockStructuredMatrixPred_subq_get, _numerics.SparseBlockStructuredMatrixPred_subq_set)
    bufz = property(_numerics.SparseBlockStructuredMatrixPred_bufz_get, _numerics.SparseBlockStructuredMatrixPred_bufz_set)
    newz = property(_numerics.SparseBlockStructuredMatrixPred_newz_get, _numerics.SparseBlockStructuredMatrixPred_newz_set)
    workspace = property(_numerics.SparseBlockStructuredMatrixPred_workspace_get, _numerics.SparseBlockStructuredMatrixPred_workspace_set)

    def __init__(self):
        _numerics.SparseBlockStructuredMatrixPred_swiginit(self, _numerics.new_SparseBlockStructuredMatrixPred())
    __swig_destroy__ = _numerics.delete_SparseBlockStructuredMatrixPred

# Register SparseBlockStructuredMatrixPred in _numerics:
_numerics.SparseBlockStructuredMatrixPred_swigregister(SparseBlockStructuredMatrixPred)

class SBM_index_by_column(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    filled3 = property(_numerics.SBM_index_by_column_filled3_get, _numerics.SBM_index_by_column_filled3_set)
    filled4 = property(_numerics.SBM_index_by_column_filled4_get, _numerics.SBM_index_by_column_filled4_set)
    index3_data = property(_numerics.SBM_index_by_column_index3_data_get, _numerics.SBM_index_by_column_index3_data_set)
    index4_data = property(_numerics.SBM_index_by_column_index4_data_get, _numerics.SBM_index_by_column_index4_data_set)
    blockMap = property(_numerics.SBM_index_by_column_blockMap_get, _numerics.SBM_index_by_column_blockMap_set)

    def __init__(self):
        _numerics.SBM_index_by_column_swiginit(self, _numerics.new_SBM_index_by_column())
    __swig_destroy__ = _numerics.delete_SBM_index_by_column

# Register SBM_index_by_column in _numerics:
_numerics.SBM_index_by_column_swigregister(SBM_index_by_column)

NUMERICS_SBM_FREE_BLOCK = _numerics.NUMERICS_SBM_FREE_BLOCK
NUMERICS_SBM_FREE_SBM = _numerics.NUMERICS_SBM_FREE_SBM

def SBM_new() -> "SparseBlockStructuredMatrix *":
    r"""
    SBM_new(None) -> SparseBlockStructuredMatrix *

    Creation of an empty Sparse Block Matrix.  

    Returns
    -------
    a pointer on allocated and initialized space  

    """
    return _numerics.SBM_new()

def SBM_null(sbm: "SparseBlockStructuredMatrix") -> "void":
    r"""
    SBM_null(SparseBlockStructuredMatrix *sbm) -> None

    set Sparse Block Matrix.  

    fields to NULL  

    Parameters
    ----------

    sbm :  
        a matrix  

    """
    return _numerics.SBM_null(sbm)

def SBM_gemv(sizeX: "unsigned int", sizeY: "unsigned int", alpha: "double", A: "SparseBlockStructuredMatrix", x: "double const *", beta: "double", y: "double *") -> "void":
    r"""
    SBM_gemv( int sizeX,  int sizeY, double alpha,  SparseBlockStructuredMatrix * A,  array_like (np.float64, 1D)x, double beta, array_like (np.float64, 1D)y) -> None

    SparseMatrix - vector product y = alpha*A*x + beta*y.  

    Parameters
    ----------

    sizeX :  
        dim of the vectors x  

    sizeY :  
        dim of the vectors y  

    alpha :  
        coefficient  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    beta :  
        coefficient  

    y :  
        the resulting vector  

    """
    return _numerics.SBM_gemv(sizeX, sizeY, alpha, A, x, beta, y)

def SBM_gemv_3x3(sizeX: "unsigned int", sizeY: "unsigned int", A: "SparseBlockStructuredMatrix", x: "double *const", y: "double *") -> "void":
    r"""
    SBM_gemv_3x3( int sizeX,  int sizeY,  SparseBlockStructuredMatrix * A, array_like (np.float64, 1D) x, array_like (np.float64, 1D)y) -> None

    SparseMatrix - vector product y = A*x + y for block of size 3x3.  

    Parameters
    ----------

    sizeX :  
        dim of the vectors x  

    sizeY :  
        dim of the vectors y  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    """
    return _numerics.SBM_gemv_3x3(sizeX, sizeY, A, x, y)

def SBM_gemm_without_allocation(alpha: "double", A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix", beta: "double", C: "SparseBlockStructuredMatrix") -> "void":
    r"""
    SBM_gemm_without_allocation(double alpha,  SparseBlockStructuredMatrix * A,  SparseBlockStructuredMatrix * B, double beta, SparseBlockStructuredMatrix *C) -> None

    SparseBlockStructuredMatrix - SparseBlockStructuredMatrix product C = alpha*A*B
    + beta*C The routine has to be used with precaution.  

    The allocation of C is not done since we want to add beta*C. We assume that the
    structure and the allocation of the matrix C are right. Especially:  

    *   the blocks C(i,j) must exists  
    *   the sizes of blocks must be consistent  
    *   no extra block must be present in C  

        Parameters:  

        alpha :  
            coefficient  

        A :  
            the matrix to be multiplied  

        B :  
            the matrix to be multiplied  

        beta :  
            coefficient  

        C :  
            the resulting matrix  

    """
    return _numerics.SBM_gemm_without_allocation(alpha, A, B, beta, C)

def SBM_multiply(A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix") -> "SparseBlockStructuredMatrix *":
    r"""
    SBM_multiply( SparseBlockStructuredMatrix * A,  SparseBlockStructuredMatrix * B) -> SparseBlockStructuredMatrix *

    SparseBlockStructuredMatrix - SparseBlockStructuredMatrix multiplication C = A
    *B Correct allocation is performed.  

    Parameters
    ----------

    A :  
        the matrix to be multiplied  

    B :  
        the matrix to be multiplied  

    Returns
    -------
    C the resulting matrix  

    """
    return _numerics.SBM_multiply(A, B)

def SBM_zero_matrix_for_multiply(A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix") -> "SparseBlockStructuredMatrix *":
    r"""
    SBM_zero_matrix_for_multiply( SparseBlockStructuredMatrix * A,  SparseBlockStructuredMatrix * B) -> SparseBlockStructuredMatrix *

    Perform the allocation of a zero matrix that is compatible qith multiplication.  

    """
    return _numerics.SBM_zero_matrix_for_multiply(A, B)

def SBM_add(A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix", alpha: "double", beta: "double") -> "SparseBlockStructuredMatrix *":
    r"""
    SBM_add(SparseBlockStructuredMatrix *A, SparseBlockStructuredMatrix *B, double alpha, double beta) -> SparseBlockStructuredMatrix *

    SparseBlockStructuredMatrix - SparseBlockStructuredMatrix addition C = alpha*A +
    beta*B.  

    Parameters
    ----------

    A :  
        the matrix to be added  

    B :  
        the matrix to be added  

    alpha :  
        coefficient  

    beta :  
        coefficient  

    Returns
    -------
    C the resulting matrix  

    """
    return _numerics.SBM_add(A, B, alpha, beta)

def SBM_add_without_allocation(A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix", alpha: "double", beta: "double", C: "SparseBlockStructuredMatrix", gamma: "double") -> "void":
    r"""
    SBM_add_without_allocation(SparseBlockStructuredMatrix *A, SparseBlockStructuredMatrix *B, double alpha, double beta, SparseBlockStructuredMatrix *C, double gamma) -> None

    SparseBlockStructuredMatrix - SparseBlockStructuredMatrix addition C = alpha*A +
    beta*B + gamma*C without allocation We assume that C has the correct structure.  

    Parameters
    ----------

    A :  
        the matrix to be added  

    B :  
        the matrix to be added  

    alpha :  
        coefficient  

    beta :  
        coefficient  

    gamma :  
        coefficient  

    C :  
        the resulting matrix  

    """
    return _numerics.SBM_add_without_allocation(A, B, alpha, beta, C, gamma)

def SBM_row_prod(sizeX: "unsigned int", sizeY: "unsigned int", currentRowNumber: "unsigned int", A: "SparseBlockStructuredMatrix", x: "double const *const", y: "double *", init: "int") -> "void":
    r"""
    SBM_row_prod( int sizeX,  int sizeY,  int currentRowNumber,  SparseBlockStructuredMatrix * A,  array_like (np.float64, 1D) x, array_like (np.float64, 1D)y, int init) -> None

    Row of a SparseMatrix - vector product y = rowA*x or y += rowA*x, rowA being a
    row of blocks of A.  

    Parameters
    ----------

    sizeX :  
        dim of the vector x  

    sizeY :  
        dim of the vector y  

    currentRowNumber :  
        number of the required row of blocks  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    init :  
        = 0 for y += Ax, =1 for y = Ax  

    """
    return _numerics.SBM_row_prod(sizeX, sizeY, currentRowNumber, A, x, y, init)

def SBM_row_prod_no_diag(sizeX: "unsigned int", sizeY: "unsigned int", currentRowNumber: "unsigned int", A: "SparseBlockStructuredMatrix", x: "double const *const", y: "double *", init: "int") -> "void":
    r"""
    SBM_row_prod_no_diag( int sizeX,  int sizeY,  int currentRowNumber,  SparseBlockStructuredMatrix * A,  array_like (np.float64, 1D) x, array_like (np.float64, 1D)y, int init) -> None

    Row of a SparseMatrix - vector product y = rowA*x or y += rowA*x, rowA being a
    row of blocks of A.  

    Parameters
    ----------

    sizeX :  
        dim of the vector x  

    sizeY :  
        dim of the vector y  

    currentRowNumber :  
        number of the required row of blocks  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    init :  
        = 0 for y += Ax, =1 for y = Ax  

    """
    return _numerics.SBM_row_prod_no_diag(sizeX, sizeY, currentRowNumber, A, x, y, init)

def SBM_row_prod_no_diag_3x3(sizeX: "unsigned int", sizeY: "unsigned int", currentRowNumber: "unsigned int", A: "SparseBlockStructuredMatrix", x: "double *const", y: "double *") -> "void":
    r"""
    SBM_row_prod_no_diag_3x3( int sizeX,  int sizeY,  int currentRowNumber,  SparseBlockStructuredMatrix * A, array_like (np.float64, 1D) x, array_like (np.float64, 1D)y) -> None

    Row of a SparseMatrix - vector product y = rowA*x or y += rowA*x, rowA being a
    row of blocks of A of size 3x3.  

    Parameters
    ----------

    sizeX :  
        dim of the vector x  

    sizeY :  
        dim of the vector y  

    currentRowNumber :  
        number of the required row of blocks  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    """
    return _numerics.SBM_row_prod_no_diag_3x3(sizeX, sizeY, currentRowNumber, A, x, y)

def SBM_row_prod_no_diag_1x1(sizeX: "unsigned int", sizeY: "unsigned int", currentRowNumber: "unsigned int", A: "SparseBlockStructuredMatrix", x: "double *const", y: "double *") -> "void":
    r"""
    SBM_row_prod_no_diag_1x1( int sizeX,  int sizeY,  int currentRowNumber,  SparseBlockStructuredMatrix * A, array_like (np.float64, 1D) x, array_like (np.float64, 1D)y) -> None

    """
    return _numerics.SBM_row_prod_no_diag_1x1(sizeX, sizeY, currentRowNumber, A, x, y)

def SBM_extract_component_3x3(A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix", row_components: "unsigned int *", row_components_size: "unsigned int", col_components: "unsigned int *", col_components_size: "unsigned int") -> "void":
    r"""
    SBM_extract_component_3x3( SparseBlockStructuredMatrix * A, SparseBlockStructuredMatrix *B,  int *row_components,  int row_components_size,  int *col_components,  int col_components_size) -> None

    """
    return _numerics.SBM_extract_component_3x3(A, B, row_components, row_components_size, col_components, col_components_size)

def SBM_free(blmat: "SparseBlockStructuredMatrix") -> "void":
    r"""
    SBM_free(SparseBlockStructuredMatrix *blmat) -> None

    Destructor for SparseBlockStructuredMatrix objects.  

    Parameters
    ----------

    blmat :  
        SparseBlockStructuredMatrix the matrix to be destroyed.  

    """
    return _numerics.SBM_free(blmat)

def SBMfree(A: "SparseBlockStructuredMatrix", level: "unsigned int") -> "void":
    r"""
    SBMfree(SparseBlockStructuredMatrix *A,  int level) -> None

    To free a SBM matrix (for example allocated by NM_new_from_file).  

    Parameters
    ----------

    A :  
        the SparseBlockStructuredMatrix that mus be de-allocated.  

    level :  
        use NUMERICS_SBM_FREE_BLOCK | NUMERICS_SBM_FREE_SBM  

    """
    return _numerics.SBMfree(A, level)

def SBM_print(m: "SparseBlockStructuredMatrix") -> "void":
    r"""
    SBM_print( SparseBlockStructuredMatrix * m) -> None

    Screen display of the matrix content.  

    Parameters
    ----------

    m :  
        the matrix to be displayed  

    """
    return _numerics.SBM_print(m)

def SBM_write_in_file(m: "SparseBlockStructuredMatrix", file: "FILE *") -> "void":
    r"""
    SBM_write_in_file( SparseBlockStructuredMatrix * m, FILE *file) -> None

    print in file of the matrix content  

    Parameters
    ----------

    m :  
        the matrix to be displayed  

    file :  
        the corresponding file  

    """
    return _numerics.SBM_write_in_file(m, file)

def SBM_read_in_file(M: "SparseBlockStructuredMatrix", file: "FILE *") -> "void":
    r"""
    SBM_read_in_file(SparseBlockStructuredMatrix * M, FILE *file) -> None

    read in file of the matrix content without performing memory allocation  

    Parameters
    ----------

    M :  
        the matrix to be displayed  

    file :  
        the corresponding name of the file  

    """
    return _numerics.SBM_read_in_file(M, file)

def SBM_new_from_file(file: "FILE *") -> "SparseBlockStructuredMatrix *":
    r"""
    SBM_new_from_file(FILE *file) -> SparseBlockStructuredMatrix *

    Create from file a SparseBlockStructuredMatrix with memory allocation.  

    Parameters
    ----------

    file :  
        the corresponding name of the file  

    Returns
    -------
    the matrix to be displayed  

    """
    return _numerics.SBM_new_from_file(file)

def SBM_write_in_fileForScilab(M: "SparseBlockStructuredMatrix", file: "FILE *") -> "void":
    r"""
    SBM_write_in_fileForScilab( SparseBlockStructuredMatrix * M, FILE *file) -> None

    print in file of the matrix content in Scilab format for each block  

    Parameters
    ----------

    M :  
        the matrix to be displayed  

    file :  
        the corresponding file  

    """
    return _numerics.SBM_write_in_fileForScilab(M, file)

def SBM_write_in_filename(M: "SparseBlockStructuredMatrix", filename: "char const *") -> "void":
    r"""
    SBM_write_in_filename( SparseBlockStructuredMatrix * M,  char *filename) -> None

    print in file of the matrix content  

    Parameters
    ----------

    M :  
        the matrix to be displayed  

    filename :  
        the corresponding file  

    """
    return _numerics.SBM_write_in_filename(M, filename)

def SBM_read_in_filename(M: "SparseBlockStructuredMatrix", filename: "char const *") -> "void":
    r"""
    SBM_read_in_filename(SparseBlockStructuredMatrix * M,  char *filename) -> None

    read in file of the matrix content  

    Parameters
    ----------

    M :  
        the matrix to be displayed  

    filename :  
        the corresponding name of the file  

    """
    return _numerics.SBM_read_in_filename(M, filename)

def SBM_free_pred(blmatpred: "SparseBlockStructuredMatrixPred") -> "void":
    r"""
    SBM_free_pred(SparseBlockStructuredMatrixPred *blmatpred) -> None

    Destructor for SparseBlockStructuredMatrixPred objects.  

    Parameters
    ----------

    blmatpred :  
        SparseBlockStructuredMatrix, the matrix to be destroyed.  

    """
    return _numerics.SBM_free_pred(blmatpred)

def SBM_diagonal_block_indices(M: "SparseBlockStructuredMatrix") -> "unsigned int *":
    r"""
    SBM_diagonal_block_indices(SparseBlockStructuredMatrix * M) ->  int *

    Compute the indices of blocks of the diagonal block.  

    Parameters
    ----------

    M :  
        the SparseBlockStructuredMatrix matrix  

    Returns
    -------
    the indices for all the rows  

    """
    return _numerics.SBM_diagonal_block_indices(M)

def SBM_diagonal_block_index(M: "SparseBlockStructuredMatrix", row: "unsigned int") -> "unsigned int":
    r"""
    SBM_diagonal_block_index(SparseBlockStructuredMatrix * M,  int row) ->  int

    Find index of the diagonal block in a row.  

    Parameters
    ----------

    M :  
        the SparseBlockStructuredMatrix matrix  

    row :  
        the row of the required block  

    Returns
    -------
    pos the position of the block  

    """
    return _numerics.SBM_diagonal_block_index(M, row)

def SBM_zentry(M: "SparseBlockStructuredMatrix", row: "unsigned int", col: "unsigned int", val: "double") -> "int":
    r"""
    SBM_zentry( SparseBlockStructuredMatrix * M,  int row,  int col, double val) -> int

    """
    return _numerics.SBM_zentry(M, row, col, val)

def SBM_get_value(M: "SparseBlockStructuredMatrix", row: "unsigned int", col: "unsigned int") -> "double":
    r"""
    SBM_get_value( SparseBlockStructuredMatrix * M,  int row,  int col) -> double

    get the element of row i and column j of the matrix M  

    Parameters
    ----------

    M :  
        the SparseBlockStructuredMatrix matrix  

    row :  
        the row index  

    col :  
        the column index  

    Returns
    -------
    the value  

    """
    return _numerics.SBM_get_value(M, row, col)

def SBM_copy(A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix", copyBlock: "unsigned int") -> "int":
    r"""
    SBM_copy( SparseBlockStructuredMatrix * A, SparseBlockStructuredMatrix *B,  int copyBlock) -> int

    Copy of a SBM A into B.  

    Parameters
    ----------

    A :  
        the SparseBlockStructuredMatrix matrix to be copied  

    B :  
        the SparseBlockStructuredMatrix matrix copy of A  

    copyBlock :  
        if copyBlock then the content of block are copied, else only the pointers
        are copied.  

    Returns
    -------
    0 if ok  

    """
    return _numerics.SBM_copy(A, B, copyBlock)

def SBM_transpose(A: "SparseBlockStructuredMatrix", B: "SparseBlockStructuredMatrix") -> "int":
    r"""
    SBM_transpose( SparseBlockStructuredMatrix * A, SparseBlockStructuredMatrix *B) -> int

    Transpose by copy of a SBM A into B.  

    Parameters
    ----------

    A :  
        the SparseBlockStructuredMatrix matrix to be copied  

    B :  
        the SparseBlockStructuredMatrix matrix copy of transpose A  

    Returns
    -------
    0 if ok  

    """
    return _numerics.SBM_transpose(A, B)

def SBM_inverse_diagonal_block_matrix_in_place(M: "SparseBlockStructuredMatrix", ipiv: "int *") -> "int":
    r"""
    SBM_inverse_diagonal_block_matrix_in_place( SparseBlockStructuredMatrix *M, int *ipiv) -> int

    Inverse (in place) a square diagonal block matrix.  

    Parameters
    ----------

    M :  
        the SparseBlockStructuredMatrix matrix to be inversed  

    ipiv :  
        worksapce for storign ipiv  

    Returns
    -------
    0 ik ok  

    """
    return _numerics.SBM_inverse_diagonal_block_matrix_in_place(M, ipiv)

def SBM_to_dense(A: "SparseBlockStructuredMatrix") -> "double *":
    r"""
    SBM_to_dense( SparseBlockStructuredMatrix * A, array_like (np.float64, 1D)denseMat) -> None

    Copy a SBM into a Dense Matrix.  

    Parameters
    ----------

    A :  
        the SparseBlockStructuredMatrix matrix  

    denseMat :  
        pointer on the filled dense Matrix  

    """
    return _numerics.SBM_to_dense(A)

def SBM_to_sparse(A: "SparseBlockStructuredMatrix") -> "struct cs_dl_sparse *":
    r"""
    SBM_to_sparse( SparseBlockStructuredMatrix * A, CSparseMatrix *outSparseMat) -> int

    Copy a SBM into a Sparse (CSR) Matrix.  

    Parameters
    ----------

    A :  
        the SparseBlockStructuredMatrix matrix  

    outSparseMat :  
        pointer on the filled sparse Matrix  

    Returns
    -------
    0 if ok  

    """
    return _numerics.SBM_to_sparse(A)

def SBM_to_sparse_init_memory(A: "SparseBlockStructuredMatrix", sparseMat: "CSparseMatrix *") -> "int":
    r"""
    SBM_to_sparse_init_memory( SparseBlockStructuredMatrix * A, CSparseMatrix *sparseMat) -> int

    initMemory of a Sparse (CSR) Matrix form a SBM matrix  

    Parameters
    ----------

    A :  
        the SparseBlockStructuredMatrix matrix  

    sparseMat :  
        pointer on the initialized sparse Matrix  

    Returns
    -------
    0 if ok  

    """
    return _numerics.SBM_to_sparse_init_memory(A, sparseMat)

def SBM_row_permutation(rowIndex: "unsigned int *", A: "SparseBlockStructuredMatrix", C: "SparseBlockStructuredMatrix") -> "void":
    r"""
    SBM_row_permutation( int *rowarray_like (int, 1D), SparseBlockStructuredMatrix *A, SparseBlockStructuredMatrix *C) -> None

    """
    return _numerics.SBM_row_permutation(rowIndex, A, C)

def SBM_column_permutation(colIndex: "unsigned int *", A: "SparseBlockStructuredMatrix", C: "SparseBlockStructuredMatrix") -> "void":
    r"""
    SBM_column_permutation( int *colarray_like (int, 1D), SparseBlockStructuredMatrix *A, SparseBlockStructuredMatrix *C) -> None

    """
    return _numerics.SBM_column_permutation(colIndex, A, C)

def SBCM_null(MC: "SparseBlockCoordinateMatrix") -> "void":
    r"""
    SBCM_null(SparseBlockCoordinateMatrix *MC) -> None

    """
    return _numerics.SBCM_null(MC)

def SBCM_new() -> "SparseBlockCoordinateMatrix *":
    r"""
    SBCM_new(None) -> SparseBlockCoordinateMatrix *

    """
    return _numerics.SBCM_new()

def SBCM_new_3x3(m: "unsigned int", n: "unsigned int", nbblocks: "unsigned int", row: "unsigned int *", column: "unsigned int *", block: "double *") -> "SparseBlockCoordinateMatrix *":
    r"""
    SBCM_new_3x3( int m,  int n,  int nbblocks,  int *row,  int *column, array_like (np.float64, 1D)block) -> SparseBlockCoordinateMatrix *

    allocate a SparseBlockCoordinateMatrix from a list of 3x3 blocks  

    Parameters
    ----------

    m :  
        the number of rows  

    n :  
        the number of colums  

    nbblocks :  
        the number of blocks  

    row :  
        a pointer to row of each block  

    column :  
        a pointer to column of each block  

    block :  
        a pointer to each block  

    Returns
    -------
    a pointer to a SparseBlockCoordinateMatrix structure  

    """
    return _numerics.SBCM_new_3x3(m, n, nbblocks, row, column, block)

def SBCM_free_3x3(MC: "SparseBlockCoordinateMatrix") -> "void":
    r"""
    SBCM_free_3x3(SparseBlockCoordinateMatrix *MC) -> None

    free allocated memory in newSparseBlockCoordinateMatrix functions  

    Parameters
    ----------

    MC :  
        matrix pointer  

    """
    return _numerics.SBCM_free_3x3(MC)

def SBCM_to_SBM(MC: "SparseBlockCoordinateMatrix") -> "SparseBlockStructuredMatrix *":
    r"""
    SBCM_to_SBM(SparseBlockCoordinateMatrix *MC) -> SparseBlockStructuredMatrix *

    copy a SparseBlockCoordinateMatrix to a SparseBlockStructuredMatrix  

    Parameters
    ----------

    MC :  
        the SparseBlockCoordinateMatrix matrix  

    Returns
    -------
    a pointer to a SparseBlockCoordinateMatrix structure  

    """
    return _numerics.SBCM_to_SBM(MC)

def SBM_free_from_SBCM(M: "SparseBlockStructuredMatrix") -> "void":
    r"""
    SBM_free_from_SBCM(SparseBlockStructuredMatrix *M) -> None

    free a SparseBlockStructuredMatrix created with SBCM_to_SBM  

    Parameters
    ----------

    M :  
        a SparseBlockStructuredMatrix to free  

    """
    return _numerics.SBM_free_from_SBCM(M)

def SBM_from_csparse(blocksize: "int", sparseMat: "CSparseMatrix const *const") -> "SparseBlockStructuredMatrix *":
    r"""
    SBM_from_csparse(int blocksize,  CSparseMatrix * sparseMat, SparseBlockStructuredMatrix *outSBM) -> int

    Copy a Sparse Matrix into a SBM, with fixed blocksize.  

    Parameters
    ----------

    blocksize :  
        the blocksize  

    sparseMat :  
        pointer on the Sparse Matrix  

    outSBM :  
        pointer on an empty SparseBlockStructuredMatrix  

    Returns
    -------
    0 in ok  

    """
    return _numerics.SBM_from_csparse(blocksize, sparseMat)
class NumericsMatrixInternalData(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    iWorkSize = property(_numerics.NumericsMatrixInternalData_iWorkSize_get, _numerics.NumericsMatrixInternalData_iWorkSize_set)
    iWork = property(_numerics.NumericsMatrixInternalData_iWork_get, _numerics.NumericsMatrixInternalData_iWork_set)
    sizeof_elt = property(_numerics.NumericsMatrixInternalData_sizeof_elt_get, _numerics.NumericsMatrixInternalData_sizeof_elt_set)
    dWorkSize = property(_numerics.NumericsMatrixInternalData_dWorkSize_get, _numerics.NumericsMatrixInternalData_dWorkSize_set)
    dWork = property(_numerics.NumericsMatrixInternalData_dWork_get, _numerics.NumericsMatrixInternalData_dWork_set)
    isLUfactorized = property(_numerics.NumericsMatrixInternalData_isLUfactorized_get, _numerics.NumericsMatrixInternalData_isLUfactorized_set)
    isInversed = property(_numerics.NumericsMatrixInternalData_isInversed_get, _numerics.NumericsMatrixInternalData_isInversed_set)

    def __init__(self):
        _numerics.NumericsMatrixInternalData_swiginit(self, _numerics.new_NumericsMatrixInternalData())
    __swig_destroy__ = _numerics.delete_NumericsMatrixInternalData

# Register NumericsMatrixInternalData in _numerics:
_numerics.NumericsMatrixInternalData_swigregister(NumericsMatrixInternalData)

class NumericsMatrix(object):
    r"""

    Interface to different type of matrices in numerics component.  

    See NM_* functions for linear algebra operations on dense, sparse block and
    sparse storage.  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_tools_NumericsMatrix.h`.


    Attributes
    ----------
     internalData : `NumericsMatrixInternalData *`  
        internal storage, used for workspace among other things  

     matrix0 : `array_like (np.float64, 1D)`  
        dense storage  

     matrix1 : `SparseBlockStructuredMatrix *`  
        sparse block storage  

     matrix2 : `NumericsSparseMatrix *`  
        csc, csr or triplet storage  

     size0 : `int`  
        number of rows  

     size1 : `int`  
        number of columns  

     storageType : `int`  
        the type of storage: 0: dense (double*), 1: SparseBlockStructuredMatrix, 2:
        classical sparse (csc, csr or triplet) via CSparse (from T.  

        Davis)  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    storageType = property(_numerics.NumericsMatrix_storageType_get, _numerics.NumericsMatrix_storageType_set)
    size0 = property(_numerics.NumericsMatrix_size0_get, _numerics.NumericsMatrix_size0_set)
    size1 = property(_numerics.NumericsMatrix_size1_get, _numerics.NumericsMatrix_size1_set)
    matrix0 = property(_numerics.NumericsMatrix_matrix0_get, _numerics.NumericsMatrix_matrix0_set)
    matrix1 = property(_numerics.NumericsMatrix_matrix1_get, _numerics.NumericsMatrix_matrix1_set)
    matrix2 = property(_numerics.NumericsMatrix_matrix2_get, _numerics.NumericsMatrix_matrix2_set)
    internalData = property(_numerics.NumericsMatrix_internalData_get, _numerics.NumericsMatrix_internalData_set)

    def __init__(self, o: "PyObject *"):
        r"""

        Interface to different type of matrices in numerics component.  

        See NM_* functions for linear algebra operations on dense, sparse block and
        sparse storage.  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_tools_NumericsMatrix.h`.


        Attributes
        ----------
         internalData : `NumericsMatrixInternalData *`  
            internal storage, used for workspace among other things  

         matrix0 : `array_like (np.float64, 1D)`  
            dense storage  

         matrix1 : `SparseBlockStructuredMatrix *`  
            sparse block storage  

         matrix2 : `NumericsSparseMatrix *`  
            csc, csr or triplet storage  

         size0 : `int`  
            number of rows  

         size1 : `int`  
            number of columns  

         storageType : `int`  
            the type of storage: 0: dense (double*), 1: SparseBlockStructuredMatrix, 2:
            classical sparse (csc, csr or triplet) via CSparse (from T.  

            Davis)  

        """
        _numerics.NumericsMatrix_swiginit(self, _numerics.new_NumericsMatrix(o))

    def set_matrix0(self, i: "int", j: "int", v: "double") -> "void":
        return _numerics.NumericsMatrix_set_matrix0(self, i, j, v)

    def get_matrix0(self, i: "int", j: "int") -> "double":
        return _numerics.NumericsMatrix_get_matrix0(self, i, j)

    def __setitem__(self, index: "PyObject *", v: "double") -> "PyObject *":
        return _numerics.NumericsMatrix___setitem__(self, index, v)

    def __getitem__(self, index: "PyObject *") -> "PyObject *":
        return _numerics.NumericsMatrix___getitem__(self, index)

    def __len__(self) -> "int":
        return _numerics.NumericsMatrix___len__(self)
    __swig_destroy__ = _numerics.delete_NumericsMatrix

# Register NumericsMatrix in _numerics:
_numerics.NumericsMatrix_swigregister(NumericsMatrix)

NM_DENSE = _numerics.NM_DENSE
NM_SPARSE_BLOCK = _numerics.NM_SPARSE_BLOCK
NM_SPARSE = _numerics.NM_SPARSE
NM_NONE = _numerics.NM_NONE
NM_KEEP_FACTORS = _numerics.NM_KEEP_FACTORS
NM_PRESERVE = _numerics.NM_PRESERVE

def NM_new() -> "NumericsMatrix *":
    r"""
    NM_new(None) -> NumericsMatrix *

    Constructors and destructors  

    Creation of an empty NumericsMatrix.  

    Returns
    -------
    a pointer to allocated space  

    """
    return _numerics.NM_new()

def NM_eye(size: "int") -> "NumericsMatrix *":
    r"""
    NM_eye(int size) -> NumericsMatrix *

    """
    return _numerics.NM_eye(size)

def NM_create(storageType: "int", size0: "int", size1: "int") -> "NumericsMatrix *":
    r"""
    NM_create(int storageType, int size0, int size1) -> NumericsMatrix *

    create a NumericsMatrix and allocate the memory according to the matrix type  

    Parameters
    ----------

    storageType :  
        the type of storage  

    size0 :  
        number of rows  

    size1 :  
        number of columns  

    Returns
    -------
    a pointer to a NumericsMatrix  

    """
    return _numerics.NM_create(storageType, size0, size1)

def NM_create_from_data(storageType: "int", size0: "int", size1: "int", data: "void *") -> "NumericsMatrix *":
    r"""
    NM_create_from_data(int storageType, int size0, int size1, None *data) -> NumericsMatrix *

    create a NumericsMatrix and possibly set the data  

    Parameters
    ----------

    storageType :  
        the type of storage  

    size0 :  
        number of rows  

    size1 :  
        number of columns  

    data :  
        pointer to the matrix data. If NULL, all matrixX fields are set to NULL  

    Returns
    -------
    a pointer to a NumericsMatrix  

    """
    return _numerics.NM_create_from_data(storageType, size0, size1, data)

def NM_create_from_filename(filename: "char *") -> "NumericsMatrix *":
    r"""
    NM_create_from_filename(char *filename) -> NumericsMatrix *

    """
    return _numerics.NM_create_from_filename(filename)

def NM_create_from_file(file: "FILE *") -> "NumericsMatrix *":
    r"""
    NM_create_from_file(FILE *file) -> NumericsMatrix *

    """
    return _numerics.NM_create_from_file(file)

def NM_copy(A: "NumericsMatrix", B: "NumericsMatrix") -> "void":
    r"""
    NM_copy( NumericsMatrix * A, NumericsMatrix *B) -> None

    Copy a NumericsMatrix inside another NumericsMatrix (deep).  

    Reallocations are performed if B cannot hold a copy of A  

    Parameters
    ----------

    A :  
        a NumericsMatrix  

    B :  
        a NumericsMatrix  

    """
    return _numerics.NM_copy(A, B)

def NM_copy_to_sparse(A: "NumericsMatrix", B: "NumericsMatrix") -> "void":
    r"""
    NM_copy_to_sparse( NumericsMatrix * A, NumericsMatrix *B) -> None

    Copy a NumericsMatrix to s sparse one.  

    Allocation or reallocation are performed on B  

    **Warning**: It is assumed that B has been properly initialized: its storageType
        must be set to NM_SPARSE.  

    Parameters
    ----------

    A :  
        a NumericsMatrix  

    B :  
        a NumericsMatrix  

    """
    return _numerics.NM_copy_to_sparse(A, B)

def NM_duplicate(mat: "NumericsMatrix") -> "NumericsMatrix *":
    r"""
    NM_duplicate(NumericsMatrix *mat) -> NumericsMatrix *

    create a NumericsMatrix similar to the another one.  

    The structure is the same  

    Parameters
    ----------

    mat :  
        the model matrix  

    Returns
    -------
    a pointer to a NumericsMatrix  

    """
    return _numerics.NM_duplicate(mat)

def numericsSparseMatrix(A: "NumericsMatrix") -> "NumericsSparseMatrix *":
    r"""
    numericsSparseMatrix(NumericsMatrix *A) -> NumericsSparseMatrix *

    Creation, if needed, of sparse matrix storage.  

    Parameters
    ----------

    A :  
        a NumericsMatrix  

    Returns
    -------
    a pointer on the sparse matrix storage  

    """
    return _numerics.numericsSparseMatrix(A)

def NM_triplet(A: "NumericsMatrix") -> "CSparseMatrix *":
    r"""
    NM_triplet(NumericsMatrix *A) -> CSparseMatrix *

    Creation, if needed, of triplet storage from sparse block storage.  

    Parameters
    ----------

    A :  
        a NumericsMatrix initialized with sparsed block storage.  

    Returns
    -------
    the triplet sparse Matrix created in A.  

    """
    return _numerics.NM_triplet(A)

def NM_csc(A: "NumericsMatrix") -> "CSparseMatrix *":
    r"""
    NM_csc(NumericsMatrix *A) -> CSparseMatrix *

    Creation, if needed, of compress column storage of a NumericsMatrix.  

    Parameters
    ----------

    A :  
        a NumericsMatrix with sparse block storage initialized  

    Returns
    -------
    the compressed column CSparseMatrix created in A.  

    """
    return _numerics.NM_csc(A)

def NM_csc_trans(A: "NumericsMatrix") -> "CSparseMatrix *":
    r"""
    NM_csc_trans(NumericsMatrix *A) -> CSparseMatrix *

    Creation, if needed, of the transposed compress column storage from compress
    column storage.  

    Parameters
    ----------

    A :  
        a NumericsMatrix with sparse block storage.  

    Returns
    -------
    the transposed compressed column matrix created in A.  

    """
    return _numerics.NM_csc_trans(A)

def NM_csr(A: "NumericsMatrix") -> "CSparseMatrix *":
    r"""
    NM_csr(NumericsMatrix *A) -> CSparseMatrix *

    Creation, if needed, of compress row storage of a NumericsMatrix.  

    **Warning**: This rely on the MKL  

    Parameters
    ----------

    A :  
        a NumericsMatrix with sparse block storage initialized  

    Returns
    -------
    the compressed row CSparseMatrix created in A.  

    """
    return _numerics.NM_csr(A)

def NM_fill(M: "NumericsMatrix", storageType: "int", size0: "int", size1: "int", data: "void *") -> "void":
    r"""
    NM_fill(NumericsMatrix *M, int storageType, int size0, int size1, None *data) -> None

    fill an existing NumericsMatrix struct  

    Parameters
    ----------

    M :  
        the struct to fill  

    storageType :  
        the type of storage  

    size0 :  
        number of rows  

    size1 :  
        number of columns  

    data :  
        pointer to the matrix data. If NULL, all matrixX fields are set to NULL  

    """
    return _numerics.NM_fill(M, storageType, size0, size1, data)

def NM_new_SBM(size0: "int", size1: "int", m1: "SparseBlockStructuredMatrix") -> "NumericsMatrix *":
    r"""
    NM_new_SBM(int size0, int size1, SparseBlockStructuredMatrix *m1) -> NumericsMatrix *

    new NumericsMatrix with sparse storage from minimal set of data  

    Parameters
    ----------

    size0 :  
        number of rows  

    size1 :  
        number of columns  

    m1 :  
        the SparseBlockStructuredMatrix  

    Returns
    -------
    a pointer to a NumericsMatrix  

    """
    return _numerics.NM_new_SBM(size0, size1, m1)

def NM_transpose(A: "NumericsMatrix") -> "NumericsMatrix *":
    r"""
    NM_transpose(NumericsMatrix *A) -> NumericsMatrix *

    new NumericsMatrix equal to the transpose of a given matrix  

    Parameters
    ----------

    A :  

    Returns
    -------
    a pointer to a NumericsMatrix  

    """
    return _numerics.NM_transpose(A)

def NM_null(A: "NumericsMatrix") -> "void":
    r"""
    NM_null(NumericsMatrix *A) -> None

    set NumericsMatrix fields to NULL  

    Parameters
    ----------

    A :  
        a matrix  

    """
    return _numerics.NM_null(A)

def NM_update_size(A: "NumericsMatrix") -> "void":
    r"""
    NM_update_size(NumericsMatrix *A) -> None

    update the size of the matrix based on the matrix data  

    Parameters
    ----------

    A :  
        the matrix which size is updated  

    """
    return _numerics.NM_update_size(A)

def NM_csc_alloc(A: "NumericsMatrix", nzmax: "long") -> "void":
    r"""
    NM_csc_alloc(NumericsMatrix *A, CS_INT nzmax) -> None

    Allocate a csc matrix in A.  

    Parameters
    ----------

    A :  
        the matrix  

    nzmax :  
        number of non-zero elements  

    """
    return _numerics.NM_csc_alloc(A, nzmax)

def NM_csc_empty_alloc(A: "NumericsMatrix", nzmax: "long") -> "void":
    r"""
    NM_csc_empty_alloc(NumericsMatrix *A, CS_INT nzmax) -> None

    Allocate a csc matrix in A and set the vector of column pointers to 0 such that
    the matrix is empty.  

    Parameters
    ----------

    A :  
        the matrix  

    nzmax :  
        number of non-zero elements  

    """
    return _numerics.NM_csc_empty_alloc(A, nzmax)

def NM_triplet_alloc(A: "NumericsMatrix", nzmax: "long") -> "void":
    r"""
    NM_triplet_alloc(NumericsMatrix *A, CS_INT nzmax) -> None

    Allocate a triplet matrix in A.  

    Parameters
    ----------

    A :  
        the matrix  

    nzmax :  
        maximum number of non-zero elements  

    """
    return _numerics.NM_triplet_alloc(A, nzmax)

def NM_csr_alloc(A: "NumericsMatrix", nzmax: "long") -> "void":
    r"""
    NM_csr_alloc(NumericsMatrix *A, CS_INT nzmax) -> None

    Allocate a csr matrix in A.  

    Parameters
    ----------

    A :  
        the matrix  

    nzmax :  
        number of non-zero elements  

    """
    return _numerics.NM_csr_alloc(A, nzmax)

def NM_free(m: "NumericsMatrix") -> "void":
    r"""
    NM_free(NumericsMatrix *m) -> None

    Free memory for a NumericsMatrix.  

    Warning: call this function only if you are sure that memory has been allocated
    for the structure in Numerics. This function is assumed that the memory is
    "owned" by this structure. Note that this function does not free m.  

    Parameters
    ----------

    m :  
        the matrix to be deleted.  

    """
    return _numerics.NM_free(m)

def NM_zentry(M: "NumericsMatrix", i: "int", j: "int", val: "double") -> "void":
    r"""
    NM_zentry(NumericsMatrix *M, int i, int j, double val) -> None

    setters and getters  

    insert an non zero entry into a NumericsMatrix. for storageType = NM_SPARSE, a
    conversion to triplet is done for performing the entry in the matrix. This
    method is expensice in terms of memory management. For a lot of entries, use
    preferably a triplet matrix.  

    Parameters
    ----------

    M :  
        the NumericsMatrix  

    i :  
        row index  

    j :  
        column index  

    val :  
        the value to be inserted.  

    """
    return _numerics.NM_zentry(M, i, j, val)

def NM_get_value(M: "NumericsMatrix", i: "int", j: "int") -> "double":
    r"""
    NM_get_value(NumericsMatrix *M, int i, int j) -> double

    get the value of a NumericsMatrix.  

    Parameters
    ----------

    M :  
        the NumericsMatrix  

    i :  
        row index  

    j :  
        column index  

    Returns
    -------
    the value to be inserted.  

    """
    return _numerics.NM_get_value(M, i, j)

def NM_equal(A: "NumericsMatrix", B: "NumericsMatrix") -> "bool":
    r"""
    NM_equal(NumericsMatrix *A, NumericsMatrix *B) -> bool

    compare to NumericsMatrix up to machine accuracy (DBL_EPSILON)  

    Parameters
    ----------

    A :  
        the NumericsMatrix  

    B :  
        the NumericsMatrix  

    """
    return _numerics.NM_equal(A, B)

def NM_compare(A: "NumericsMatrix", B: "NumericsMatrix", tol: "double") -> "bool":
    r"""
    NM_compare(NumericsMatrix *A, NumericsMatrix *B, double tol) -> bool

    compare to NumericsMatrix up to a given tolerance  

    Parameters
    ----------

    A :  
        the NumericsMatrix  

    B :  
        the NumericsMatrix  

    tol :  
        the tolerance  

    """
    return _numerics.NM_compare(A, B, tol)

def NM_nnz(M: "NumericsMatrix") -> "size_t":
    r"""
    NM_nnz( NumericsMatrix *M) -> size_t

    return the number of non-zero element.  

    For a dense matrix, it is the product of the dimensions (e.g. an upper bound).
    For a sparse matrix, it is the true number  

    Parameters
    ----------

    M :  
        the matrix  

    Returns
    -------
    the number (or an upper bound) of non-zero elements in the matrix  

    """
    return _numerics.NM_nnz(M)

def NM_extract_diag_block(M: "NumericsMatrix", block_row_nb: "int", start_row: "size_t", size: "int", Block: "double **") -> "void":
    r"""
    NM_extract_diag_block(NumericsMatrix *M, int block_row_nb, size_t start_row, int size, array_like (np.float64, 1D)*Block) -> None

    get the (square) diagonal block of a NumericsMatrix.  

    No allocation is done.  

    Parameters
    ----------

    M :  
        a NumericsMatrix  

    block_row_nb :  
        the number of the block Row. Useful only in sparse case  

    start_row :  
        the starting row. Useful only in dense case.  

    size :  
        of the diag block. Only useful in dense case.  

    Block :  
        the target. In the dense and sparse case (*Block) must be allocated by
        caller. In case of SBM case **Bout contains the resulting block (from the
        SBM).  

    """
    return _numerics.NM_extract_diag_block(M, block_row_nb, start_row, size, Block)

def NM_extract_diag_block3(M: "NumericsMatrix", block_row_nb: "int", Block: "double **") -> "void":
    r"""
    NM_extract_diag_block3(NumericsMatrix *M, int block_row_nb, array_like (np.float64, 1D)*Block) -> None

    get a 3x3 diagonal block of a NumericsMatrix.  

    No allocation is done.  

    Parameters
    ----------

    M :  
        a NumericsMatrix  

    block_row_nb :  
        the number of the block row  

    Block :  
        the target. In the dense and sparse case (*Block) must be allocated by
        caller. In case of SBM case **Bout contains the resulting block (from the
        SBM).  

    """
    return _numerics.NM_extract_diag_block3(M, block_row_nb, Block)

def NM_copy_diag_block3(M: "NumericsMatrix", block_row_nb: "int", Block: "double **") -> "void":
    r"""
    NM_copy_diag_block3(NumericsMatrix *M, int block_row_nb, array_like (np.float64, 1D)*Block) -> None

    get a 3x3 diagonal block of a NumericsMatrix.  

    No allocation is done.  

    Parameters
    ----------

    M :  
        a NumericsMatrix  

    block_row_nb :  
        the number of the block row  

    Block :  
        the target. In all cases (dense, sbm, and sparse) (*Block) must be allocated
        by caller. A copy is always performed  

    """
    return _numerics.NM_copy_diag_block3(M, block_row_nb, Block)

def NM_prod_mv_3x3(sizeX: "int", sizeY: "int", A: "NumericsMatrix", x: "double *const", y: "double *") -> "void":
    r"""
    NM_prod_mv_3x3(int sizeX, int sizeY, NumericsMatrix *A, array_like (np.float64, 1D) x, array_like (np.float64, 1D)y) -> None

    Matrix - vector product  

    Matrix - vector product y = A*x + y  

    Parameters
    ----------

    sizeX :  
        dim of the vector x  

    sizeY :  
        dim of the vector y  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    """
    return _numerics.NM_prod_mv_3x3(sizeX, sizeY, A, x, y)

def NM_row_prod(sizeX: "int", sizeY: "int", currentRowNumber: "int", A: "NumericsMatrix", x: "double const *const", y: "double *", init: "int") -> "void":
    r"""
    NM_row_prod(int sizeX, int sizeY, int currentRowNumber,  NumericsMatrix * A,  array_like (np.float64, 1D) x, array_like (np.float64, 1D)y, int init) -> None

    Row of a Matrix - vector product y = rowA*x or y += rowA*x, rowA being a
    submatrix of A (sizeY rows and sizeX columns)  

    Parameters
    ----------

    sizeX :  
        dim of the vector x  

    sizeY :  
        dim of the vector y  

    currentRowNumber :  
        position of the first row of rowA in A (warning: real row if A is a double*,
        block-row if A is a SparseBlockStructuredMatrix)  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    init :  
        = 0 for y += Ax, =1 for y = Ax  

    """
    return _numerics.NM_row_prod(sizeX, sizeY, currentRowNumber, A, x, y, init)

def NM_row_prod_no_diag(sizeX: "size_t", sizeY: "size_t", block_start: "int", row_start: "size_t", A: "NumericsMatrix", x: "double *", y: "double *", xsave: "double *", init: "bool") -> "void":
    r"""
    NM_row_prod_no_diag(size_t sizeX, size_t sizeY, int block_start, size_t row_start, NumericsMatrix *A, array_like (np.float64, 1D)x, array_like (np.float64, 1D)y, array_like (np.float64, 1D)xsave, bool init) -> None

    Row of a Matrix - vector product y = rowA*x or y += rowA*x, rowA being a
    submatrix of A (sizeY rows and sizeX columns)  

    Parameters
    ----------

    sizeX :  
        dim of the vector x  

    sizeY :  
        dim of the vector y  

    block_start :  
        block number (only used for SBM)  

    row_start :  
        position of the first row of A (unused if A is SBM)  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    xsave :  
        storage for saving the part of x set to 0  

    init :  
        if True y = Ax, else y += Ax  

    """
    return _numerics.NM_row_prod_no_diag(sizeX, sizeY, block_start, row_start, A, x, y, xsave, init)

def NM_row_prod_no_diag3(sizeX: "size_t", block_start: "int", row_start: "size_t", A: "NumericsMatrix", x: "double *", y: "double *", init: "bool") -> "void":
    r"""
    NM_row_prod_no_diag3(size_t sizeX, int block_start, size_t row_start, NumericsMatrix *A, array_like (np.float64, 1D)x, array_like (np.float64, 1D)y, bool init) -> None

    Row of a Matrix - vector product y = rowA*x or y += rowA*x, rowA being a
    submatrix of A (3 rows and sizeX columns)  

    Parameters
    ----------

    sizeX :  
        dim of the vector x  

    block_start :  
        block number (only used for SBM)  

    row_start :  
        position of the first row of A (unused if A is SBM)  

    A :  
        the matrix to be multiplied  

    x :  
        the vector to be multiplied  

    y :  
        the resulting vector  

    init :  
        if True y = Ax, else y += Ax  

    """
    return _numerics.NM_row_prod_no_diag3(sizeX, block_start, row_start, A, x, y, init)

def NM_row_prod_no_diag1x1(sizeX: "size_t", block_start: "int", row_start: "size_t", A: "NumericsMatrix", x: "double *", y: "double *", init: "bool") -> "void":
    r"""
    NM_row_prod_no_diag1x1(size_t sizeX, int block_start, size_t row_start, NumericsMatrix *A, array_like (np.float64, 1D)x, array_like (np.float64, 1D)y, bool init) -> None

    """
    return _numerics.NM_row_prod_no_diag1x1(sizeX, block_start, row_start, A, x, y, init)

def NM_gemv(alpha: "double const", A: "NumericsMatrix", x: "double const *", beta: "double const", y: "double *") -> "void":
    r"""
    NM_gemv( double alpha, NumericsMatrix *A,  array_like (np.float64, 1D)x,  double beta, array_like (np.float64, 1D)y) -> None

    Matrix vector multiplication : y = alpha A x + beta y.  

    Parameters
    ----------

    alpha :  
        scalar  

    A :  
        a NumericsMatrix  

    x :  
        pointer on a dense vector of size A->size1  

    beta :  
        scalar  

    y :  
        pointer on a dense vector of size A->size1  

    """
    return _numerics.NM_gemv(alpha, A, x, beta, y)

def NM_gemm(alpha: "double const", A: "NumericsMatrix", B: "NumericsMatrix", beta: "double const", C: "NumericsMatrix") -> "void":
    r"""
    NM_gemm( double alpha, NumericsMatrix *A, NumericsMatrix *B,  double beta, NumericsMatrix *C) -> None

    Matrix matrix multiplication : C = alpha A B + beta C.  

    Parameters
    ----------

    alpha :  
        scalar  

    A :  
        a NumericsMatrix  

    B :  
        a NumericsMatrix  

    beta :  
        scalar  

    C :  
        a NumericsMatrix  

    """
    return _numerics.NM_gemm(alpha, A, B, beta, C)

def NM_multiply(A: "NumericsMatrix", B: "NumericsMatrix") -> "NumericsMatrix *":
    r"""
    NM_multiply(NumericsMatrix *A, NumericsMatrix *B) -> NumericsMatrix *

    Matrix matrix multiplication : C = A B.  

    Parameters
    ----------

    A :  
        a NumericsMatrix  

    B :  
        a NumericsMatrix  

    C :  
        a NumericsMatrix  

    """
    return _numerics.NM_multiply(A, B)

def NM_tgemv(alpha: "double const", A: "NumericsMatrix", x: "double const *", beta: "double const", y: "double *") -> "void":
    r"""
    NM_tgemv( double alpha, NumericsMatrix *A,  array_like (np.float64, 1D)x,  double beta, array_like (np.float64, 1D)y) -> None

    Transposed matrix multiplication : y += alpha transpose(A) x + y.  

    Parameters
    ----------

    alpha :  
        scalar  

    A :  
        a NumericsMatrix  

    x :  
        pointer on a dense vector of size A->size1  

    beta :  
        scalar  

    y :  
        pointer on a dense vector of size A->size1  

    """
    return _numerics.NM_tgemv(alpha, A, x, beta, y)

def NM_dense_to_sparse(A: "NumericsMatrix", B: "NumericsMatrix") -> "void":
    r"""
    NM_dense_to_sparse( NumericsMatrix * A, NumericsMatrix *B) -> None

    matrix conversion display  

    matrix and vector display  

    """
    return _numerics.NM_dense_to_sparse(A, B)

def NM_to_dense(A: "NumericsMatrix", B: "NumericsMatrix") -> "int":
    r"""
    NM_to_dense( NumericsMatrix * A, NumericsMatrix *B) -> int

    """
    return _numerics.NM_to_dense(A, B)

def NM_dense_display_matlab(m: "double *", nRow: "int", nCol: "int", lDim: "int") -> "void":
    r"""
    NM_dense_display_matlab(array_like (np.float64, 1D)m, int nRow, int nCol, int lDim) -> None

    Screen display of the matrix content stored as a double * array in Fortran
    style.  

    Parameters
    ----------

    m :  
        the matrix to be displayed  

    nRow :  
        the number of rows  

    nCol :  
        the number of columns  

    lDim :  
        the leading dimension of M  

    """
    return _numerics.NM_dense_display_matlab(m, nRow, nCol, lDim)

def NM_dense_display(m: "double *", nRow: "int", nCol: "int", lDim: "int") -> "void":
    r"""
    NM_dense_display(array_like (np.float64, 1D)m, int nRow, int nCol, int lDim) -> None

    Screen display of the matrix content stored as a double * array in Fortran
    style.  

    Parameters
    ----------

    m :  
        the matrix to be displayed  

    nRow :  
        the number of rows  

    nCol :  
        the number of columns  

    lDim :  
        the leading dimension of M  

    """
    return _numerics.NM_dense_display(m, nRow, nCol, lDim)

def NM_vector_display(m: "double *", nRow: "int") -> "void":
    r"""
    NM_vector_display(array_like (np.float64, 1D)m, int nRow) -> None

    Screen display of the vector content stored as a double * array.  

    Parameters
    ----------

    m :  
        the vector to be displayed  

    nRow :  
        the number of rows  

    """
    return _numerics.NM_vector_display(m, nRow)

def NM_display(M: "NumericsMatrix") -> "void":
    r"""
    NM_display( NumericsMatrix * M) -> None

    Screen display of the matrix content.  

    Parameters
    ----------

    M :  
        the matrix to be displayed  

    """
    return _numerics.NM_display(M)

def NM_display_row_by_row(m: "NumericsMatrix") -> "void":
    r"""
    NM_display_row_by_row( NumericsMatrix * m) -> None

    Screen display raw by raw of the matrix content.  

    Parameters
    ----------

    m :  
        the matrix to be displayed  

    """
    return _numerics.NM_display_row_by_row(m)

def NM_write_in_filename(M: "NumericsMatrix", filename: "char const *") -> "void":
    r"""
    NM_write_in_filename( NumericsMatrix * M,  char *filename) -> None

    matrix I/O  

    PrintInFile of the matrix content  

    Parameters
    ----------

    M :  
        the matrix to be printed  

    filename :  
        the corresponding name of the file  

    """
    return _numerics.NM_write_in_filename(M, filename)

def NM_read_in_filename(M: "NumericsMatrix", filename: "char const *") -> "void":
    r"""
    NM_read_in_filename(NumericsMatrix * M,  char *filename) -> None

    Read in file of the matrix content.  

    Parameters
    ----------

    M :  
        the matrix to be read  

    filename :  
        the corresponding name of the file  

    """
    return _numerics.NM_read_in_filename(M, filename)

def NM_write_in_file(M: "NumericsMatrix", file: "FILE *") -> "void":
    r"""
    NM_write_in_file( NumericsMatrix * M, FILE *file) -> None

    PrintInFile of the matrix content.  

    Parameters
    ----------

    M :  
        the matrix to be printed  

    file :  
        filename the corresponding file  

    """
    return _numerics.NM_write_in_file(M, file)

def NM_read_in_file(M: "NumericsMatrix", file: "FILE *") -> "void":
    r"""
    NM_read_in_file(NumericsMatrix * M, FILE *file) -> None

    Read in file of the matrix content without performing memory allocation.  

    Parameters
    ----------

    M :  
        the matrix to be read  

    file :  
        the corresponding file  

    """
    return _numerics.NM_read_in_file(M, file)

def NM_new_from_file(file: "FILE *") -> "NumericsMatrix *":
    r"""
    NM_new_from_file(FILE *file) -> NumericsMatrix *

    Create from file a NumericsMatrix with memory allocation.  

    Parameters
    ----------

    file :  
        the corresponding file  

    Returns
    -------
    0 if the matrix  

    """
    return _numerics.NM_new_from_file(file)

def NM_new_from_filename(filename: "char *") -> "NumericsMatrix *":
    r"""
    NM_new_from_filename(char *filename) -> NumericsMatrix *

    """
    return _numerics.NM_new_from_filename(filename)

def NM_write_in_file_scilab(M: "NumericsMatrix", file: "FILE *") -> "void":
    r"""
    NM_write_in_file_scilab( NumericsMatrix * M, FILE *file) -> None

    NM_write_in_file_scilab of the matrix content.  

    Parameters
    ----------

    M :  
        the matrix to be printed  

    file :  
        the corresponding file  

    """
    return _numerics.NM_write_in_file_scilab(M, file)

def NM_write_in_file_python(M: "NumericsMatrix", file: "FILE *") -> "void":
    r"""
    NM_write_in_file_python( NumericsMatrix * M, FILE *file) -> None

    NM_write_in_file_python of the matrix content.  

    Parameters
    ----------

    M :  
        the matrix to be printed  

    file :  
        the corresponding file  

    """
    return _numerics.NM_write_in_file_python(M, file)

def NM_read_in_file_scilab(M: "NumericsMatrix", file: "FILE *") -> "void":
    r"""
    NM_read_in_file_scilab(NumericsMatrix * M, FILE *file) -> None

    Read in file for scilab of the matrix content.  

    Parameters
    ----------

    M :  
        the matrix to be read  

    file :  
        the corresponding file  

    """
    return _numerics.NM_read_in_file_scilab(M, file)

def NM_clearDense(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearDense(NumericsMatrix *A) -> None

    Clear dense storage, if it is existent.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearDense(A)

def NM_clearSparseBlock(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearSparseBlock(NumericsMatrix *A) -> None

    Clear sparse block storage, if it is existent.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearSparseBlock(A)

def NM_clearSparse(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearSparse(NumericsMatrix *A) -> None

    Clear sparse data, if it is existent.  

    The linear solver parameters are also cleared.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearSparse(A)

def NM_clearTriplet(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearTriplet(NumericsMatrix *A) -> None

    Clear triplet storage, if it is existent.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearTriplet(A)

def NM_clearCSC(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearCSC(NumericsMatrix *A) -> None

    Clear compressed column storage, if it is existent.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearCSC(A)

def NM_clearCSCTranspose(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearCSCTranspose(NumericsMatrix *A) -> None

    Clear transposed compressed column storage, if it is existent.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearCSCTranspose(A)

def NM_clearCSR(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearCSR(NumericsMatrix *A) -> None

    Clear compressed row storage, if it is existent.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearCSR(A)

def NM_clearSparseStorage(A: "NumericsMatrix") -> "void":
    r"""
    NM_clearSparseStorage(NumericsMatrix *A) -> None

    Clear triplet, csc, csc transposed storage, if they are existent.  

    Linear solver parameters are preserved.  

    Parameters
    ----------

    A :  
        a Numericsmatrix  

    """
    return _numerics.NM_clearSparseStorage(A)

def NM_gesv_expert(A: "NumericsMatrix", b: "double *", keep: "unsigned int") -> "int":
    r"""
    NM_gesv_expert(NumericsMatrix *A, array_like (np.float64, 1D)b,  keep) -> int

    Direct computation of the solution of a real system of linear equations: A x =
    b.  

    The factorized matrix A is kept for future solve. If A is already factorized,
    the solve the linear system from it  

    **Warning**: this is not enable for all the solvers, your mileage may vary  

    Parameters
    ----------

    A :  
        a NumericsMatrix. On a dense factorisation A.iWork is initialized.  

    b :  
        pointer on a dense vector of size A->size1  

    keep :  
        if set to NM_KEEP_FACTORS, keep all the info related to the factorization to
        allow for future solves. If A is already factorized, just solve the linear
        system. If set to NM_PRESERVE, preserve the original matrix (just used in
        the dense case). if NM_NONE, discard everything.  

    Returns
    -------
    0 if successful, else the error is specific to the backend solver used  

    """
    return _numerics.NM_gesv_expert(A, b, keep)

def NM_gesv_expert_multiple_rhs(A: "NumericsMatrix", b: "double *", n_rhs: "unsigned int", keep: "unsigned int") -> "int":
    r"""
    NM_gesv_expert_multiple_rhs(NumericsMatrix *A, array_like (np.float64, 1D)b,  int n_rhs,  keep) -> int

    """
    return _numerics.NM_gesv_expert_multiple_rhs(A, b, n_rhs, keep)

def NM_inv(A: "NumericsMatrix", Ainv: "NumericsMatrix") -> "int":
    r"""
    NM_inv(NumericsMatrix *A, NumericsMatrix *Ainv) -> int

    Computation of the inverse of a NumericsMatrix A usinf NM_gesv_expert.  

    Parameters
    ----------

    A :  
        a NumericsMatrix.  

    Ainv :  
        the matrix inverse.  

    """
    return _numerics.NM_inv(A, Ainv)

def NM_inverse_diagonal_block_matrix_in_place(A: "NumericsMatrix") -> "int":
    r"""
    NM_inverse_diagonal_block_matrix_in_place(NumericsMatrix *A) -> int

    """
    return _numerics.NM_inverse_diagonal_block_matrix_in_place(A)

def NM_gesv(A: "NumericsMatrix", b: "double *", preserve: "bool") -> "int":
    r"""
    NM_gesv(NumericsMatrix *A, array_like (np.float64, 1D)b, bool preserve) -> int

    Direct computation of the solution of a real system of linear equations: A x =
    b.  

    Parameters
    ----------

    A :  
        a NumericsMatrix. On a dense factorisation A.iWork is initialized.  

    b :  
        pointer on a dense vector of size A->size1  

    preserve :  
        preserve the original matrix data. Only useful in the dense case, where the
        LU factorization is done in-place.  

    Returns
    -------
    0 if successful, else the error is specific to the backend solver used  

    """
    return _numerics.NM_gesv(A, b, preserve)

def NM_setSparseSolver(A: "NumericsMatrix", solver_id: "unsigned int") -> "void":
    r"""
    NM_setSparseSolver(NumericsMatrix *A,  solver_id) -> None

    Set the linear solver.  

    Parameters
    ----------

    A :  
        the matrix  

    solver_id :  
        the solver  

    """
    return _numerics.NM_setSparseSolver(A, solver_id)

def NM_internalData(A: "NumericsMatrix") -> "NumericsMatrixInternalData *":
    r"""
    NM_internalData(NumericsMatrix *A) -> NumericsMatrixInternalData *

    Get Matrix internal data with initialization if needed.  

    Parameters
    ----------

    A :  
        a NumericsMatrix.  

    Returns
    -------
    a pointer on internal data.  

    """
    return _numerics.NM_internalData(A)

def NM_internalData_new(M: "NumericsMatrix") -> "void":
    r"""
    NM_internalData_new(NumericsMatrix *M) -> None

    Allocate the internalData structure (but not its content!)  

    Parameters
    ----------

    M :  
        the matrix to modify  

    """
    return _numerics.NM_internalData_new(M)

def NM_internalData_copy(A: "NumericsMatrix", B: "NumericsMatrix") -> "void":
    r"""
    NM_internalData_copy( NumericsMatrix * A, NumericsMatrix *B) -> None

    Copy the internalData structure.  

    Parameters
    ----------

    M :  
        the matrix to modify  

    """
    return _numerics.NM_internalData_copy(A, B)

def NM_iWork(A: "NumericsMatrix", size: "size_t", sizeof_elt: "size_t") -> "void *":
    r"""
    NM_iWork(NumericsMatrix *A, size_t size, size_t sizeof_elt) -> None *

    Integer work vector initialization, if needed.  

    Parameters
    ----------

    A :  
        pointer on a NumericsMatrix.  

    size :  
        number of element to allocate  

    sizeof_elt :  
        of an element in bytes (result of sizeof for instance)  

    Returns
    -------
    pointer on A->iWork allocated space of with the right size  

    """
    return _numerics.NM_iWork(A, size, sizeof_elt)

def NM_dWork(A: "NumericsMatrix", size: "int") -> "double *":
    r"""
    NM_dWork(NumericsMatrix *A, int size) -> array_like (np.float64, 1D)

    Double workspace initialization, if needed.  

    Parameters
    ----------

    A :  
        pointer on a NumericsMatrix.  

    size :  
        the size of needed space.  

    Returns
    -------
    pointer on A->dWork allocated space of with the right size  

    """
    return _numerics.NM_dWork(A, size)

def NM_add_to_diag3(M: "NumericsMatrix", alpha: "double") -> "void":
    r"""
    NM_add_to_diag3(NumericsMatrix *M, double alpha) -> None

    Add a constant term to the diagonal elements, when the block of the SBM are 3x3.  

    Parameters
    ----------

    M :  
        the matrix  

    alpha :  
        the term to add  

    """
    return _numerics.NM_add_to_diag3(M, alpha)

def NM_add(alpha: "double", A: "NumericsMatrix", beta: "double", B: "NumericsMatrix") -> "NumericsMatrix *":
    r"""
    NM_add(double alpha, NumericsMatrix *A, double beta, NumericsMatrix *B) -> NumericsMatrix *

    Add two matrices with coefficients C = alpha*A + beta*B.  

    Parameters
    ----------

    alpha :  
        the first coefficient  

    A :  
        the first matrix  

    beta :  
        the second coefficient  

    B :  
        the second matrix  

    Returns
    -------
    C a new NumericsMatrix  

    """
    return _numerics.NM_add(alpha, A, beta, B)

def NM_assert(type: "int const", M: "NumericsMatrix") -> "void":
    r"""
    NM_assert( int type, NumericsMatrix *M) -> None

    assert that a NumericsMatrix has the right structure given its type  

    Parameters
    ----------

    type :  
        expected type  

    M :  
        the matrix to check  

    """
    return _numerics.NM_assert(type, M)

def NM_check(A: "NumericsMatrix") -> "int":
    r"""
    NM_check( NumericsMatrix * A) -> int

    Check the matrix (the sparse format for now)  

    Parameters
    ----------

    A :  
        the matrix to check  

    Returns
    -------
    0 if the matrix storage is fine, 1 if not  

    """
    return _numerics.NM_check(A)

def NM_norm_1(A: "NumericsMatrix") -> "double":
    r"""
    NM_norm_1(NumericsMatrix * A) -> double

    Compute the 1-norm of a sparse matrix = max (sum (abs (A))), largest column sum
    of a matrix (the sparse format for now)  

    Parameters
    ----------

    A :  
        the matrix  

    Returns
    -------
    the norm  

    """
    return _numerics.NM_norm_1(A)

def NM_norm_inf(A: "NumericsMatrix") -> "double":
    r"""
    NM_norm_inf(NumericsMatrix * A) -> double

    Compute the inf-norm of a sparse matrix = max (sum (abs (A^T))), largest row sum
    of a matrix (the sparse format for now)  

    Parameters
    ----------

    A :  
        the matrix  

    Returns
    -------
    the norm  

    """
    return _numerics.NM_norm_inf(A)

def NM_is_symmetric(A: "NumericsMatrix") -> "int":
    r"""
    NM_is_symmetric(NumericsMatrix *A) -> int

    """
    return _numerics.NM_is_symmetric(A)

def NM_symmetry_discrepancy(A: "NumericsMatrix") -> "double":
    r"""
    NM_symmetry_discrepancy(NumericsMatrix *A) -> double

    """
    return _numerics.NM_symmetry_discrepancy(A)
class linalg_data_t(object):
    r"""
    linalg_data_t -> struct linalg_data_t

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    id = property(_numerics.linalg_data_t_id_get, _numerics.linalg_data_t_id_set)
    free_fn = property(_numerics.linalg_data_t_free_fn_get, _numerics.linalg_data_t_free_fn_set)

    def __init__(self):
        r"""
        linalg_data_t -> struct linalg_data_t

        """
        _numerics.linalg_data_t_swiginit(self, _numerics.new_linalg_data_t())
    __swig_destroy__ = _numerics.delete_linalg_data_t

# Register linalg_data_t in _numerics:
_numerics.linalg_data_t_swigregister(linalg_data_t)

SN_LINALG_UNKNOWN = _numerics.SN_LINALG_UNKNOWN
SN_LINALG_MKL = _numerics.SN_LINALG_MKL
NSM_CS_LUSOL = _numerics.NSM_CS_LUSOL
NSM_MUMPS = _numerics.NSM_MUMPS
NSM_UMFPACK = _numerics.NSM_UMFPACK
NSM_MKL_PARDISO = _numerics.NSM_MKL_PARDISO
NSM_SUPERLU = _numerics.NSM_SUPERLU
NSM_SUPERLU_MT = _numerics.NSM_SUPERLU_MT
NSM_CS_CSC = _numerics.NSM_CS_CSC
NSM_CS_CSR = _numerics.NSM_CS_CSR
class NSM_linear_solver_params(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    solver = property(_numerics.NSM_linear_solver_params_solver_get, _numerics.NSM_linear_solver_params_solver_set)
    solver_data = property(_numerics.NSM_linear_solver_params_solver_data_get, _numerics.NSM_linear_solver_params_solver_data_set)
    solver_free_hook = property(_numerics.NSM_linear_solver_params_solver_free_hook_get, _numerics.NSM_linear_solver_params_solver_free_hook_set)
    iWork = property(_numerics.NSM_linear_solver_params_iWork_get, _numerics.NSM_linear_solver_params_iWork_set)
    iWorkSize = property(_numerics.NSM_linear_solver_params_iWorkSize_get, _numerics.NSM_linear_solver_params_iWorkSize_set)
    dWork = property(_numerics.NSM_linear_solver_params_dWork_get, _numerics.NSM_linear_solver_params_dWork_set)
    dWorkSize = property(_numerics.NSM_linear_solver_params_dWorkSize_get, _numerics.NSM_linear_solver_params_dWorkSize_set)
    linalg_data = property(_numerics.NSM_linear_solver_params_linalg_data_get, _numerics.NSM_linear_solver_params_linalg_data_set)

    def __init__(self):
        _numerics.NSM_linear_solver_params_swiginit(self, _numerics.new_NSM_linear_solver_params())
    __swig_destroy__ = _numerics.delete_NSM_linear_solver_params

# Register NSM_linear_solver_params in _numerics:
_numerics.NSM_linear_solver_params_swigregister(NSM_linear_solver_params)

NSM_UNKNOWN = _numerics.NSM_UNKNOWN
NSM_TRIPLET = _numerics.NSM_TRIPLET
NSM_CSC = _numerics.NSM_CSC
NSM_CSR = _numerics.NSM_CSR
class NumericsSparseMatrix(object):
    r"""

    Sparse matrix representation in Numerics. The supported format are: triplet (aka
    coordinate, COO), CSC (via CSparse) and CSR if MKL is used  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_tools_NumericsSparseMatrix.h`.


    Attributes
    ----------
     csc : `CSparseMatrix *`  
        csc matrix  

     csr : `CSparseMatrix *`  
        csr matrix, only supported with mkl  

     diag_indx : `CS_INT *`  
        indices for the diagonal terms.  

        Very useful for the proximal perturbation  

     linearSolverParams : `NSM_linear_solver_params *`  
        solver-specific parameters  

     origin : ``  
        original format of the matrix  

     trans_csc : `CSparseMatrix *`  
        transpose of a csc matrix (used by CSparse)  

     triplet : `CSparseMatrix *`  
        triplet format, aka coordinate  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    triplet = property(_numerics.NumericsSparseMatrix_triplet_get, _numerics.NumericsSparseMatrix_triplet_set)
    csc = property(_numerics.NumericsSparseMatrix_csc_get, _numerics.NumericsSparseMatrix_csc_set)
    trans_csc = property(_numerics.NumericsSparseMatrix_trans_csc_get, _numerics.NumericsSparseMatrix_trans_csc_set)
    csr = property(_numerics.NumericsSparseMatrix_csr_get, _numerics.NumericsSparseMatrix_csr_set)
    diag_indx = property(_numerics.NumericsSparseMatrix_diag_indx_get, _numerics.NumericsSparseMatrix_diag_indx_set)
    origin = property(_numerics.NumericsSparseMatrix_origin_get, _numerics.NumericsSparseMatrix_origin_set)
    linearSolverParams = property(_numerics.NumericsSparseMatrix_linearSolverParams_get, _numerics.NumericsSparseMatrix_linearSolverParams_set)

    def __init__(self):
        r"""

        Sparse matrix representation in Numerics. The supported format are: triplet (aka
        coordinate, COO), CSC (via CSparse) and CSR if MKL is used  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_tools_NumericsSparseMatrix.h`.


        Attributes
        ----------
         csc : `CSparseMatrix *`  
            csc matrix  

         csr : `CSparseMatrix *`  
            csr matrix, only supported with mkl  

         diag_indx : `CS_INT *`  
            indices for the diagonal terms.  

            Very useful for the proximal perturbation  

         linearSolverParams : `NSM_linear_solver_params *`  
            solver-specific parameters  

         origin : ``  
            original format of the matrix  

         trans_csc : `CSparseMatrix *`  
            transpose of a csc matrix (used by CSparse)  

         triplet : `CSparseMatrix *`  
            triplet format, aka coordinate  

        """
        _numerics.NumericsSparseMatrix_swiginit(self, _numerics.new_NumericsSparseMatrix())
    __swig_destroy__ = _numerics.delete_NumericsSparseMatrix

# Register NumericsSparseMatrix in _numerics:
_numerics.NumericsSparseMatrix_swigregister(NumericsSparseMatrix)


def NSM_null(A: "NumericsSparseMatrix") -> "void":
    r"""
    NSM_null(NumericsSparseMatrix *A) -> None

    Initialize the fields of a NumericsSparseMatrix.  

    Parameters
    ----------

    A :  
        the sparse matrix  

    """
    return _numerics.NSM_null(A)

def NSM_new() -> "NumericsSparseMatrix *":
    r"""
    NSM_new(None) -> NumericsSparseMatrix *

    New and empty NumericsSparseMatrix with correctly initialized fields.  

    Returns
    -------
    a pointer on the allocated space.  

    """
    return _numerics.NSM_new()

def NSM_triplet_eye(size: "unsigned int") -> "NumericsSparseMatrix *":
    r"""
    NSM_triplet_eye( int size) -> NumericsSparseMatrix *

    """
    return _numerics.NSM_triplet_eye(size)

def NSM_free(A: "NumericsSparseMatrix") -> "NumericsSparseMatrix *":
    r"""
    NSM_free(NumericsSparseMatrix *A) -> NumericsSparseMatrix *

    Free allocated space for a NumericsSparseMatrix.  

    Parameters
    ----------

    A :  
        a NumericsSparseMatrix  

    Returns
    -------
    NULL on success  

    """
    return _numerics.NSM_free(A)

def NSM_free_p(p: "void *") -> "void":
    r"""
    NSM_free_p(None *p) -> None

    Free a workspace related to a LU factorization.  

    Parameters
    ----------

    p :  
        the structure to free  

    """
    return _numerics.NSM_free_p(p)

def NSM_data(A: "NumericsSparseMatrix") -> "double *":
    r"""
    NSM_data(NumericsSparseMatrix *A) -> array_like (np.float64, 1D)

    Get the data part of sparse matrix.  

    Parameters
    ----------

    A :  
        the sparse matrix  

    Returns
    -------
    a pointer to the data array  

    """
    return _numerics.NSM_data(A)

def NSM_solver_data(p: "NSM_linear_solver_params") -> "void *":
    r"""
    NSM_solver_data(NSM_linear_solver_params *p) -> None *

    Get the LU factors for cs_lusol.  

    Parameters
    ----------

    p :  
        the structure holding the data for the solver  

    """
    return _numerics.NSM_solver_data(p)

def NSM_workspace(p: "NSM_linear_solver_params") -> "double *":
    r"""
    NSM_workspace(NSM_linear_solver_params *p) -> array_like (np.float64, 1D)

    Get the workspace for the sparse solver.  

    Parameters
    ----------

    p :  
        the structure holding the data for the solver  

    Returns
    -------
    the (double) workspace  

    """
    return _numerics.NSM_workspace(p)

def NSM_nnz(A: "CSparseMatrix const *const") -> "size_t":
    r"""
    NSM_nnz( CSparseMatrix * A) -> size_t

    get the number of non-zero (nnz) in a sparse matrix  

    Parameters
    ----------

    A :  
        the matrix  

    Returns
    -------
    the number of non-zero elements in the matrix  

    """
    return _numerics.NSM_nnz(A)

def NSM_diag_indices(M: "NumericsMatrix") -> "long *":
    r"""
    NSM_diag_indices(NumericsMatrix *M) -> CS_INT *

    return the set of indices corresponding to the diagonal elements of the matrix  

    **Warning**: should be better tested  

    Parameters
    ----------

    M :  
        the matrix  

    Returns
    -------
    the list of indices for the diagonal elements  

    """
    return _numerics.NSM_diag_indices(M)

def NSM_extract_block(M: "NumericsMatrix", blockM: "double *", pos_row: "size_t", pos_col: "size_t", block_row_size: "size_t", block_col_size: "size_t") -> "void":
    r"""
    NSM_extract_block(NumericsMatrix *M, array_like (np.float64, 1D)blockM, size_t pos_row, size_t pos_col, size_t block_row_size, size_t block_col_size) -> None

    Extract a block from a sparse matrix.  

    Parameters
    ----------

    M :  
        matrix  

    blockM :  
        dense storage for the block  

    pos_row :  
        starting row for the block  

    pos_col :  
        starting column for the block  

    block_row_size :  
        block width  

    block_col_size :  
        block height  

    """
    return _numerics.NSM_extract_block(M, blockM, pos_row, pos_col, block_row_size, block_col_size)

def NSM_linearSolverParams_free(p: "NSM_linear_solver_params") -> "NSM_linear_solver_params *":
    r"""
    NSM_linearSolverParams_free(NSM_linear_solver_params *p) -> NSM_linear_solver_params *

    Free allocated space for NSM_linear_solver_params.  

    Parameters
    ----------

    p :  
        a NSM_linear_solver_params  

    Returns
    -------
    NULL on success  

    """
    return _numerics.NSM_linearSolverParams_free(p)

def NSM_linearSolverParams_new() -> "NSM_linear_solver_params *":
    r"""
    NSM_linearSolverParams_new(None) -> NSM_linear_solver_params *

    New and empty NSM_linear_solver_params.  

    Returns
    -------
    a pointer on the allocated space.  

    """
    return _numerics.NSM_linearSolverParams_new()

def NSM_linearSolverParams(A: "NumericsMatrix") -> "NSM_linear_solver_params *":
    r"""
    NSM_linearSolverParams(NumericsMatrix *A) -> NSM_linear_solver_params *

    Get linear solver parameters with initialization if needed.  

    Parameters
    ----------

    A :  
        a NumericsMatrix.  

    Returns
    -------
    a pointer on parameters.  

    """
    return _numerics.NSM_linearSolverParams(A)

def NSM_fix_csc(A: "CSparseMatrix *") -> "void":
    r"""
    NSM_fix_csc(CSparseMatrix *A) -> None

    Check and fix a matrix, if needed.  

    Parameters
    ----------

    A :  
        the matrix to check, modified if necessary to have ordered indices  

    """
    return _numerics.NSM_fix_csc(A)

def NSM_origin(M: "NumericsSparseMatrix") -> "unsigned int":
    r"""
    NSM_origin( NumericsSparseMatrix *M) -> 

    return the origin of a sparse part of a matrix  

    Parameters
    ----------

    M :  
        the matrix  

    Returns
    -------
    -1 if the matrix has no sparse representation, the origin otherwise  

    """
    return _numerics.NSM_origin(M)

def NSM_get_origin(M: "NumericsSparseMatrix") -> "CSparseMatrix *":
    r"""
    NSM_get_origin( NumericsSparseMatrix *M) -> CSparseMatrix *

    return the sparse matrix that has the original label  

    Parameters
    ----------

    M :  
        the matrix  

    Returns
    -------
    the sparse matrix that is at the origin, or NULL if an error occur  

    """
    return _numerics.NSM_get_origin(M)

def NSM_write_in_file(m: "NumericsSparseMatrix", file: "FILE *") -> "void":
    r"""
    NSM_write_in_file( NumericsSparseMatrix *m, FILE *file) -> None

    """
    return _numerics.NSM_write_in_file(m, file)

def NSM_new_from_file(file: "FILE *") -> "NumericsSparseMatrix *":
    r"""
    NSM_new_from_file(FILE *file) -> NumericsSparseMatrix *

    New and empty NumericsSparseMatrix with correctly initialized fields.  

    Returns
    -------
    a pointer on the allocated space.  

    """
    return _numerics.NSM_new_from_file(file)

def NSM_to_dense(A: "NumericsSparseMatrix", B: "double *") -> "int":
    r"""
    NSM_to_dense( NumericsSparseMatrix * A, array_like (np.float64, 1D)B) -> int

    """
    return _numerics.NSM_to_dense(A, B)
SICONOS_MLCP_PGS = _numerics.SICONOS_MLCP_PGS
SICONOS_MLCP_RPGS = _numerics.SICONOS_MLCP_RPGS
SICONOS_MLCP_PSOR = _numerics.SICONOS_MLCP_PSOR
SICONOS_MLCP_RPSOR = _numerics.SICONOS_MLCP_RPSOR
SICONOS_MLCP_PATH = _numerics.SICONOS_MLCP_PATH
SICONOS_MLCP_ENUM = _numerics.SICONOS_MLCP_ENUM
SICONOS_MLCP_SIMPLEX = _numerics.SICONOS_MLCP_SIMPLEX
SICONOS_MLCP_DIRECT_ENUM = _numerics.SICONOS_MLCP_DIRECT_ENUM
SICONOS_MLCP_PATH_ENUM = _numerics.SICONOS_MLCP_PATH_ENUM
SICONOS_MLCP_DIRECT_SIMPLEX = _numerics.SICONOS_MLCP_DIRECT_SIMPLEX
SICONOS_MLCP_DIRECT_PATH = _numerics.SICONOS_MLCP_DIRECT_PATH
SICONOS_MLCP_DIRECT_PATH_ENUM = _numerics.SICONOS_MLCP_DIRECT_PATH_ENUM
SICONOS_MLCP_FB = _numerics.SICONOS_MLCP_FB
SICONOS_MLCP_DIRECT_FB = _numerics.SICONOS_MLCP_DIRECT_FB
SICONOS_MLCP_PGS_SBM = _numerics.SICONOS_MLCP_PGS_SBM
class MLCP(object):
    r"""

    The Structure that contains and defines MLCProblem. Find FORMULA117_ such that:
    FORMULA118_ FORMULA119_ are vectors of size n. FORMULA120_ are vectors of size
    m.  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_MLCP_MixedLinearComplementarityProblem.h`.


    Attributes
    ----------
     A : `array_like (np.float64, 1D)`  
        NumericsMatrix* Bblock;.  

        < Bblock ? A matrix of the MLCP  

     a : `array_like (np.float64, 1D)`  
        a vector of the MLCP  

     B : `array_like (np.float64, 1D)`  
        B matrix of the MLCP.  

     b : `array_like (np.float64, 1D)`  
        b vector of the MLCP  

     blocksIsComp : `int *`  
        if bloksIsComp[i]=0, then block i formed by the rows from blocksRows[i] to
        blocksRows[i+1]-1 is an equality block else the block is a complementarity
        block.  

     blocksRows : `int *`  
        The rows from blocksRows[i] to blocksRows[i+1]-1 forms a block of equalities
        iif bloksIsComp[i]=0, else the block is a complementarity block.  

        The number of total blocks is given by NbBlocks such that
        blocksRows[NbBlocks] = n+m  

     C : `array_like (np.float64, 1D)`  
        C matrix of the MLCP.  

     D : `array_like (np.float64, 1D)`  
        D matrix of the MLCP.  

     isStorageType1 : `int`  
        boolean for storageType1 1 if the problem is saved using (M,q), 0 otherwise  

     isStorageType2 : `int`  
        boolean for storageType2 1 if the problem is saved using (A,B,C,D,a,b), 0
        otherwise  

     m : `int`  
        number of complementarity constraints  

     M : `NumericsMatrix *`  
        M matrix of the MLCP.  

     n : `int`  
        number of equality constraints  

     q : `array_like (np.float64, 1D)`  
        q vector of the MLCP  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    isStorageType1 = property(_numerics.MLCP_isStorageType1_get, _numerics.MLCP_isStorageType1_set)
    isStorageType2 = property(_numerics.MLCP_isStorageType2_get, _numerics.MLCP_isStorageType2_set)
    n = property(_numerics.MLCP_n_get, _numerics.MLCP_n_set)
    m = property(_numerics.MLCP_m_get, _numerics.MLCP_m_set)
    blocksRows = property(_numerics.MLCP_blocksRows_get, _numerics.MLCP_blocksRows_set)
    blocksIsComp = property(_numerics.MLCP_blocksIsComp_get, _numerics.MLCP_blocksIsComp_set)
    M = property(_numerics.MLCP_M_get, _numerics.MLCP_M_set)
    q = property(_numerics.MLCP_q_get, _numerics.MLCP_q_set)
    A = property(_numerics.MLCP_A_get, _numerics.MLCP_A_set)
    B = property(_numerics.MLCP_B_get, _numerics.MLCP_B_set)
    C = property(_numerics.MLCP_C_get, _numerics.MLCP_C_set)
    D = property(_numerics.MLCP_D_get, _numerics.MLCP_D_set)
    a = property(_numerics.MLCP_a_get, _numerics.MLCP_a_set)
    b = property(_numerics.MLCP_b_get, _numerics.MLCP_b_set)

    def __init__(self, *args):
        r"""

        The Structure that contains and defines MLCProblem. Find FORMULA117_ such that:
        FORMULA118_ FORMULA119_ are vectors of size n. FORMULA120_ are vectors of size
        m.  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_MLCP_MixedLinearComplementarityProblem.h`.


        Attributes
        ----------
         A : `array_like (np.float64, 1D)`  
            NumericsMatrix* Bblock;.  

            < Bblock ? A matrix of the MLCP  

         a : `array_like (np.float64, 1D)`  
            a vector of the MLCP  

         B : `array_like (np.float64, 1D)`  
            B matrix of the MLCP.  

         b : `array_like (np.float64, 1D)`  
            b vector of the MLCP  

         blocksIsComp : `int *`  
            if bloksIsComp[i]=0, then block i formed by the rows from blocksRows[i] to
            blocksRows[i+1]-1 is an equality block else the block is a complementarity
            block.  

         blocksRows : `int *`  
            The rows from blocksRows[i] to blocksRows[i+1]-1 forms a block of equalities
            iif bloksIsComp[i]=0, else the block is a complementarity block.  

            The number of total blocks is given by NbBlocks such that
            blocksRows[NbBlocks] = n+m  

         C : `array_like (np.float64, 1D)`  
            C matrix of the MLCP.  

         D : `array_like (np.float64, 1D)`  
            D matrix of the MLCP.  

         isStorageType1 : `int`  
            boolean for storageType1 1 if the problem is saved using (M,q), 0 otherwise  

         isStorageType2 : `int`  
            boolean for storageType2 1 if the problem is saved using (A,B,C,D,a,b), 0
            otherwise  

         m : `int`  
            number of complementarity constraints  

         M : `NumericsMatrix *`  
            M matrix of the MLCP.  

         n : `int`  
            number of equality constraints  

         q : `array_like (np.float64, 1D)`  
            q vector of the MLCP  

        """
        _numerics.MLCP_swiginit(self, _numerics.new_MLCP(*args))
    __swig_destroy__ = _numerics.delete_MLCP

# Register MLCP in _numerics:
_numerics.MLCP_swigregister(MLCP)
SICONOS_NONAME_STR = cvar.SICONOS_NONAME_STR
SICONOS_MLCP_PGS_STR = cvar.SICONOS_MLCP_PGS_STR
SICONOS_MLCP_RPGS_STR = cvar.SICONOS_MLCP_RPGS_STR
SICONOS_MLCP_PSOR_STR = cvar.SICONOS_MLCP_PSOR_STR
SICONOS_MLCP_RPSOR_STR = cvar.SICONOS_MLCP_RPSOR_STR
SICONOS_MLCP_PATH_STR = cvar.SICONOS_MLCP_PATH_STR
SICONOS_MLCP_ENUM_STR = cvar.SICONOS_MLCP_ENUM_STR
SICONOS_MLCP_SIMPLEX_STR = cvar.SICONOS_MLCP_SIMPLEX_STR
SICONOS_MLCP_DIRECT_ENUM_STR = cvar.SICONOS_MLCP_DIRECT_ENUM_STR
SICONOS_MLCP_PATH_ENUM_STR = cvar.SICONOS_MLCP_PATH_ENUM_STR
SICONOS_MLCP_DIRECT_SIMPLEX_STR = cvar.SICONOS_MLCP_DIRECT_SIMPLEX_STR
SICONOS_MLCP_DIRECT_PATH_STR = cvar.SICONOS_MLCP_DIRECT_PATH_STR
SICONOS_MLCP_DIRECT_PATH_ENUM_STR = cvar.SICONOS_MLCP_DIRECT_PATH_ENUM_STR
SICONOS_MLCP_FB_STR = cvar.SICONOS_MLCP_FB_STR
SICONOS_MLCP_DIRECT_FB_STR = cvar.SICONOS_MLCP_DIRECT_FB_STR
SICONOS_MLCP_PGS_SBM_STR = cvar.SICONOS_MLCP_PGS_SBM_STR


def mixedLinearComplementarity_display(p: "MLCP") -> "void":
    r"""
    mixedLinearComplementarity_display(MixedLinearComplementarityProblem *p) -> None

    """
    return _numerics.mixedLinearComplementarity_display(p)

def mixedLinearComplementarity_printInFile(problem: "MLCP", file: "FILE *") -> "int":
    r"""
    mixedLinearComplementarity_printInFile(MixedLinearComplementarityProblem *problem, FILE *file) -> int

    function to write in a file a MixedLinearComplementarityProblem  

    Parameters
    ----------

    problem :  
        pointer to a MixedLinearComplementarityProblem to print  

    file :  
        pointer to a FILE  

    Returns
    -------
    0 if ok  

    """
    return _numerics.mixedLinearComplementarity_printInFile(problem, file)

def mixedLinearComplementarity_newFromFile(problem: "MLCP", file: "FILE *") -> "int":
    r"""
    mixedLinearComplementarity_newFromFile(MixedLinearComplementarityProblem *problem, FILE *file) -> int

    function to read and create a MixedLinearComplementarityProblem from a file  

    Parameters
    ----------

    problem :  
        pointer to a MixedLinearComplementarityProblem to create  

    file :  
        pointer to a FILE  

    Returns
    -------
    0 if ok  

    """
    return _numerics.mixedLinearComplementarity_newFromFile(problem, file)

def mixedLinearComplementarity_newFromFileOld(problem: "MLCP", file: "FILE *") -> "int":
    r"""
    mixedLinearComplementarity_newFromFileOld(MixedLinearComplementarityProblem *problem, FILE *file) -> int

    function to read and create a MixedLinearComplementarityProblem from a file  

    Parameters
    ----------

    problem :  
        pointer to a MixedLinearComplementarityProblem to create  

    file :  
        pointer to a FILE  

    Returns
    -------
    0 if ok  

    """
    return _numerics.mixedLinearComplementarity_newFromFileOld(problem, file)

def mixedLinearComplementarity_newFromFilename(problem: "MLCP", filename: "char *") -> "int":
    r"""
    mixedLinearComplementarity_newFromFilename(MixedLinearComplementarityProblem *problem, char *filename) -> int

    """
    return _numerics.mixedLinearComplementarity_newFromFilename(problem, filename)

def freeMixedLinearComplementarityProblem(problem: "MLCP") -> "void":
    r"""
    freeMixedLinearComplementarityProblem(MixedLinearComplementarityProblem *problem) -> None

    function to delete a MixedLinearComplementarityProblem  

    Parameters
    ----------

    problem :  
        pointer to a MixedLinearComplementarityProblem to delete  

    """
    return _numerics.freeMixedLinearComplementarityProblem(problem)

def newMLCP() -> "MixedLinearComplementarityProblem *":
    r"""
    newMLCP(None) -> MixedLinearComplementarityProblem *

    create empty MLCP  

    Returns
    -------
    empy MLCP  

    """
    return _numerics.newMLCP()

def mlcp_driver_init(problem: "MLCP", options: "SolverOptions") -> "void":
    r"""
    mlcp_driver_init(MixedLinearComplementarityProblem *problem, SolverOptions *options) -> None

    General interface to initialize a solver.  

    Must be call for the following solvers:  

    *   mlcp_enum  
    *   mlcp_path  
    *   mlcp_simplex  
    *   mlcp_direct_enum  
    *   mlcp_direct_path  
    *   mlcp_direct_simplex  

    Parameters
    ----------

    problem :  
        the MixedLinearComplementarityProblem structure which handles the problem
        (M,q)  

    options :  
        structure used to define the solver(s) and their parameters  

    """
    return _numerics.mlcp_driver_init(problem, options)

def mlcp_driver_reset(problem: "MLCP", options: "SolverOptions") -> "void":
    r"""
    mlcp_driver_reset(MixedLinearComplementarityProblem *problem, SolverOptions *options) -> None

    General interface to reset a solver.  

    Must be call for the following solvers:  

    *   mlcp_enum  
    *   mlcp_path  
    *   mlcp_simplex  
    *   mlcp_direct_enum  
    *   mlcp_direct_path  
    *   mlcp_direct_simplex  

    Parameters
    ----------

    problem :  
        the MixedLinearComplementarityProblem structure which handles the problem
        (M,q)  

    options :  
        structure used to define the solver(s) and their parameters  

    """
    return _numerics.mlcp_driver_reset(problem, options)

def mlcp_alloc_working_memory(problem: "MLCP", options: "SolverOptions") -> "int":
    r"""
    mlcp_alloc_working_memory(MixedLinearComplementarityProblem *problem, SolverOptions *options) -> int

    """
    return _numerics.mlcp_alloc_working_memory(problem, options)

def mlcp_free_working_memory(problem: "MLCP", options: "SolverOptions") -> "void":
    r"""
    mlcp_free_working_memory(MixedLinearComplementarityProblem *problem, SolverOptions *options) -> None

    """
    return _numerics.mlcp_free_working_memory(problem, options)

def mlcp_driver_get_iwork(problem: "MLCP", options: "SolverOptions") -> "int":
    r"""
    mlcp_driver_get_iwork(MixedLinearComplementarityProblem *problem, SolverOptions *options) -> int

    General interface to get the number of integers that must be allocated for the
    solver.  

    Must be use for the following solvers:  

    *   mlcp_enum  
    *   mlcp_path  
    *   mlcp_simplex  
    *   mlcp_direct_enum  
    *   mlcp_direct_path  
    *   mlcp_direct_simplex  

    Parameters
    ----------

    problem :  
        the MixedLinearComplementarityProblem structure which handles the problem
        (M,q)  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    the number of integers that must be allocated by the user.  

    """
    return _numerics.mlcp_driver_get_iwork(problem, options)

def mlcp_driver_get_dwork(problem: "MLCP", options: "SolverOptions") -> "int":
    r"""
    mlcp_driver_get_dwork(MixedLinearComplementarityProblem *problem, SolverOptions *options) -> int

    General interface to get the number of doubles that must be allocated for the
    solver.  

    Must be use for the following solvers:  

    *   mlcp_enum  
    *   mlcp_path  
    *   mlcp_simplex  
    *   mlcp_direct_enum  
    *   mlcp_direct_path  
    *   mlcp_direct_simplex  

    Parameters
    ----------

    problem :  
        the MixedLinearComplementarityProblem structure which handles the problem
        (M,q)  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    the number of doubles that must be allocated by the user.  

    """
    return _numerics.mlcp_driver_get_dwork(problem, options)

def mlcp_pgs(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_pgs(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    mlcp_pgs (Projected Gauss-Seidel) is a basic Projected Gauss-Seidel solver for
    MLCP.  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,m,M, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_pgs(problem, z, w, options)

def mlcp_rpgs(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_rpgs(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    mlcp_rpgs (Projected Gauss-Seidel) is a basic Projected Gauss-Seidel solver for
    MLCP.  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,m,M, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_rpgs(problem, z, w, options)

def mlcp_psor(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_psor(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    mlcp_psor (projected successive overrelaxation method) is a solver for MLCP.  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,m,M, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_psor(problem, z, w, options)

def mlcp_rpsor(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_rpsor(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    mlcp_rpsor (regularized projected successive overrelaxation method) is a solver
    for MLCP.  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,m,M, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_rpsor(problem, z, w, options)

def mlcp_path(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_path(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    path solver  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,m,M, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_path(problem, z, w, options)

def mlcp_enum(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_enum(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    enum solver  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_enum(problem, z, w, options)

def mlcp_direct(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_direct(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    direct solver  

    Parameters
    ----------

    problem :  
        MixedLinearComplementarityProblem* problem structure that represents the
        MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_direct(problem, z, w, options)

def mlcp_direct_enum(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_direct_enum(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    direct-enum solver  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_direct_enum(problem, z, w, options)

def mlcp_direct_simplex(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_direct_simplex(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    direct-simplex solver  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_direct_simplex(problem, z, w, options)

def mlcp_direct_path(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_direct_path(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    direct-path solver  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_direct_path(problem, z, w, options)

def mlcp_simplex(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_simplex(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    simplex solver  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_simplex(problem, z, w, options)

def mlcp_FB(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_FB(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Fischer Burmeister solver.  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_FB(problem, z, w, options)

def mlcp_direct_FB(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_direct_FB(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Direct Fischer Burmeister solver.  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,mM, q...)  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success,it found a
        solution 1 : failure,it did not find any solution  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_direct_FB(problem, z, w, options)

def mlcp_pgs_SBM(problem: "MLCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mlcp_pgs_SBM(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    generic interface used to call any MLCP solver applied on a Sparse-Block
    structured matrix M, with a Gauss-Seidel process to solve the global problem
    (formulation/solving of local problems for each row of blocks)  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...). M must be a
        SparseBlockStructuredMatrix  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence >0 : failed,
        depends on local solver  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mlcp_pgs_SBM(problem, z, w, options)

def mixedLinearComplementarity_pgs_SBM_setDefaultSolverOptions(problem: "MLCP", options: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_pgs_SBM_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (M, q...). M must be a
        SparseBlockStructuredMatrix  

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.mixedLinearComplementarity_pgs_SBM_setDefaultSolverOptions(problem, options)

def mlcp_compute_error(problem: "MLCP", z: "double *", w: "double *", tolerance: "double") -> "double *":
    r"""
    mlcp_compute_error(MixedLinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, double tolerance, array_like (np.float64, 1D)error) -> int

    This function checks the validity of the vector z as a solution of the MLCP :  

    FORMULA5_  

    The criterion is based on FORMULA6_ with FORMULA7_ and FORMULA8_. This sum is
    divided by FORMULA9_ and then compared to tol. It changes the input vector w by
    storing FORMULA10_ in it.  

    Parameters
    ----------

    problem :  
        structure that represents the MLCP (n,m,M, q... or (A,B,C...))  

    z :  
        a m+n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a m+n-vector of doubles which returns the solution of the problem.  

    tolerance :  
        threshold used to validate the solution: if the error is less than this
        value, the solution is accepted  

    error :  

    Returns
    -------
    status: 0 : convergence, 1: error > tolerance  

    """
    return _numerics.mlcp_compute_error(problem, z, w, tolerance)

def mixedLinearComplementarity_default_setDefaultSolverOptions(problem: "MLCP", pOptions: "SolverOptions") -> "void":
    r"""
    mixedLinearComplementarity_default_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pOptions) -> None

    """
    return _numerics.mixedLinearComplementarity_default_setDefaultSolverOptions(problem, pOptions)

def mixedLinearComplementarity_deleteDefaultSolverOptions(problem: "MLCP", pOptions: "SolverOptions") -> "void":
    r"""
    mixedLinearComplementarity_deleteDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pOptions) -> None

    """
    return _numerics.mixedLinearComplementarity_deleteDefaultSolverOptions(problem, pOptions)

def mixedLinearComplementarity_setDefaultSolverOptions(problem: "MLCP", pOptions: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pOptions) -> int

    set the default solver parameters and perform memory allocation for
    MixedLinearComplementarity  

    Parameters
    ----------

    problem :  
        * the pointer to the array of options to set.  

    pOptions :  
        SolverOptions * the pointer to option.  

    """
    return _numerics.mixedLinearComplementarity_setDefaultSolverOptions(problem, pOptions)

def mixedLinearComplementarity_directEnum_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_directEnum_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_directEnum_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_directFB_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_directFB_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_directFB_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_directPath_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_directPath_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_directPath_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_directPathEnum_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_directPathEnum_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_directPathEnum_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_directSimplex_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_directSimplex_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_directSimplex_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_enum_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_enum_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_enum_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_fb_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_fb_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_fb_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_path_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_path_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_path_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_pathEnum_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_pathEnum_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_pathEnum_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_pgs_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_pgs_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_pgs_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_rpgs_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_rpgs_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_rpgs_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_simplex_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_simplex_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_simplex_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_rpsor_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_rpsor_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_rpsor_setDefaultSolverOptions(problem, pSolver)

def mixedLinearComplementarity_psor_setDefaultSolverOptions(problem: "MLCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedLinearComplementarity_psor_setDefaultSolverOptions(MixedLinearComplementarityProblem *problem, SolverOptions *pSolver) -> int

    """
    return _numerics.mixedLinearComplementarity_psor_setDefaultSolverOptions(problem, pSolver)
class LCP(object):
    r"""

    Structure that contains and defines a LCP Problem.  

    FORMULA88_  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_LCP_LinearComplementarityProblem.h`.


    Attributes
    ----------
     M : `NumericsMatrix *`  
        M matrix of the LCP (see the mathematical description)  

     q : `array_like (np.float64, 1D)`  
        vector of the LCP (see the mathematical description)  

     size : `int`  
        size of the problem  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    size = property(_numerics.LCP_size_get, _numerics.LCP_size_set)
    M = property(_numerics.LCP_M_get, _numerics.LCP_M_set)
    q = property(_numerics.LCP_q_get, _numerics.LCP_q_set)

    def __init__(self, M: "PyObject *", q: "PyObject *"):
        r"""

        Structure that contains and defines a LCP Problem.  

        FORMULA88_  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_LCP_LinearComplementarityProblem.h`.


        Attributes
        ----------
         M : `NumericsMatrix *`  
            M matrix of the LCP (see the mathematical description)  

         q : `array_like (np.float64, 1D)`  
            vector of the LCP (see the mathematical description)  

         size : `int`  
            size of the problem  

        """
        _numerics.LCP_swiginit(self, _numerics.new_LCP(M, q))
    __swig_destroy__ = _numerics.delete_LCP

# Register LCP in _numerics:
_numerics.LCP_swigregister(LCP)


def linearComplementarity_display(problem: "LCP") -> "void":
    r"""
    linearComplementarity_display(LinearComplementarityProblem *problem) -> None

    function to display a LinearComplementarityProblem  

    Parameters
    ----------

    problem :  
        pointer to a LinearComplementarityProblem to display  

    """
    return _numerics.linearComplementarity_display(problem)

def linearComplementarity_printInFile(problem: "LCP", file: "FILE *") -> "int":
    r"""
    linearComplementarity_printInFile(LinearComplementarityProblem *problem, FILE *file) -> int

    function to write in a file a LinearComplementarityProblem  

    Parameters
    ----------

    problem :  
        pointer to a LinearComplementarityProblem to print  

    file :  
        pointer to a FILE  

    Returns
    -------
    0 if ok  

    """
    return _numerics.linearComplementarity_printInFile(problem, file)

def linearComplementarity_newFromFile(problem: "LCP", file: "FILE *") -> "int":
    r"""
    linearComplementarity_newFromFile(LinearComplementarityProblem *problem, FILE *file) -> int

    function to read and create a LinearComplementarityProblem from a file  

    Parameters
    ----------

    problem :  
        pointer to a LinearComplementarityProblem to create  

    file :  
        pointer to a FILE  

    Returns
    -------
    0 if ok  

    """
    return _numerics.linearComplementarity_newFromFile(problem, file)

def linearComplementarity_newFromFilename(problem: "LCP", filename: "char *") -> "int":
    r"""
    linearComplementarity_newFromFilename(LinearComplementarityProblem *problem, char *filename) -> int

    """
    return _numerics.linearComplementarity_newFromFilename(problem, filename)

def freeLinearComplementarityProblem(problem: "LCP") -> "void":
    r"""
    freeLinearComplementarityProblem(LinearComplementarityProblem *problem) -> None

    function to delete a LinearComplementarityProblem  

    Parameters
    ----------

    problem :  
        pointer to a LinearComplementarityProblem to delete  

    """
    return _numerics.freeLinearComplementarityProblem(problem)

def newLCP() -> "LinearComplementarityProblem *":
    r"""
    newLCP(None) -> LinearComplementarityProblem *

    Create new LCP and clear its fields.  

    Returns
    -------
    a LinearComplementarityProblem  

    """
    return _numerics.newLCP()

def linearComplementarity_setDefaultSolverOptions(problem: "LCP", options: "SolverOptions", arg3: "int") -> "int":
    r"""
    linearComplementarity_setDefaultSolverOptions(LinearComplementarityProblem *problem, SolverOptions *options, int) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    problem :  
        the LinearComplementarityProblem structure which handles the problem (M,q)  

    options :  
        the pointer to the array of options to set  

    Returns
    -------
    info termination value  

    """
    return _numerics.linearComplementarity_setDefaultSolverOptions(problem, options, arg3)

def lcp_qp(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_qp(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_qp uses a quadratic programm formulation for solving a LCP  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence /
        minimization sucessfull 1 : Too Many iterations 2 : Accuracy insuficient to
        satisfy convergence criterion 5 : Length of working array insufficient Other
        : The constraints are inconstent  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_qp(problem, z, w, options)

def linearComplementarity_qp_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_qp_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_qp_setDefaultSolverOptions(options)

def lcp_cpg(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_cpg(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_cpg is a CPG (Conjugated Projected Gradient) solver for LCP based on
    quadratic minimization.  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0: convergence 1: iter =
        itermax 2: negative diagonal term 3: pWp nul  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_cpg(problem, z, w, options)

def linearComplementarity_cpg_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_cpg_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_cpg_setDefaultSolverOptions(options)

def lcp_pgs(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_pgs(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_pgs (Projected Gauss-Seidel) is a basic Projected Gauss-Seidel solver for
    LCP.  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_pgs(problem, z, w, options)

def linearComplementarity_pgs_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_pgs_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_pgs_setDefaultSolverOptions(options)

def lcp_rpgs(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_rpgs(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_rpgs (Regularized Projected Gauss-Seidel ) is a solver for LCP, able to
    handle matrices with null diagonal terms.  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_rpgs(problem, z, w, options)

def linearComplementarity_rpgs_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_rpgs_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_rpgs_setDefaultSolverOptions(options)

def lcp_psor(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_psor(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_psor Projected Succesive over relaxation solver for LCP.  

    See cottle, Pang Stone Chap 5  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_psor(problem, z, w, options)

def linearComplementarity_psor_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_psor_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_psor_setDefaultSolverOptions(options)

def lcp_nsqp(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_nsqp(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_nsqp use a quadratic programm formulation for solving an non symmetric LCP  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence /
        minimization sucessfull 1 : Too Many iterations 2 : Accuracy insuficient to
        satisfy convergence criterion 5 : Length of working array insufficient Other
        : The constraints are inconstent  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_nsqp(problem, z, w, options)

def linearComplementarity_nsqp_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_nsqp_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_nsqp_setDefaultSolverOptions(options)

def lcp_latin(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_latin(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_latin (LArge Time INcrements) is a basic latin solver for LCP.  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : Cholesky Factorization failed 3 : nul diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_latin(problem, z, w, options)

def linearComplementarity_latin_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_latin_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_latin_setDefaultSolverOptions(options)

def lcp_latin_w(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_latin_w(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_latin_w (LArge Time INcrements) is a basic latin solver with relaxation for
    LCP.  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : Cholesky Factorization failed 3 : nul diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_latin_w(problem, z, w, options)

def linearComplementarity_latin_w_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_latin_w_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_latin_w_setDefaultSolverOptions(options)

def lcp_lexicolemke(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_lexicolemke(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_lexicolemke is a direct solver for LCP based on pivoting method principle
    for degenerate problem Choice of pivot variable is performed via lexicographic
    ordering Ref: "The Linear Complementarity Problem" Cottle, Pang, Stone (1992)  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_lexicolemke(problem, z, w, options)

def linearComplementarity_lexicolemke_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_lexicolemke_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_lexicolemke_setDefaultSolverOptions(options)

def lcp_newton_min(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_newton_min(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_newton_min uses a nonsmooth Newton method based on the min formulation (or
    max formulation) of the LCP FORMULA25_  

    FORMULA26_  

    References: Alart & Curnier 1990, Pang 1990  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : Problem in resolution in DGESV 0 : convergence / minimization
        sucessfull 1 : Too Many iterations 2 : Accuracy insuficient to satisfy
        convergence criterion 5 : Length of working array insufficient Other : The
        constraints are inconstent  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_newton_min(problem, z, w, options)

def linearComplementarity_newton_min_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_newton_min_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_newton_min_setDefaultSolverOptions(options)

def lcp_newton_FB(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_newton_FB(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_newton_FB use a nonsmooth newton method based on the Fischer-Bursmeister
    convex function  

    FORMULA23_  

    FORMULA24_  

    References: Alart & Curnier 1990, Pang 1990  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 - convergence 1 - iter =
        itermax 2 - failure in the descent direction search (in LAPACK)  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_newton_FB(problem, z, w, options)

def lcp_newton_minFB(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_newton_minFB(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_newton_minFB use a nonsmooth newton method based on both a min and Fischer-
    Bursmeister reformulation References: Facchinei--Pang (2003)  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 - convergence 1 - iter =
        itermax 2 - failure in the descent direction search (in LAPACK)  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_newton_minFB(problem, z, w, options)

def lcp_path(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_path(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax 2 : negative diagonal term  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_path(problem, z, w, options)

def lcp_enum(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_enum(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    enumerative solver  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : success 1 : failed  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_enum(problem, z, w, options)

def lcp_enum_init(problem: "LCP", options: "SolverOptions", withMemAlloc: "int") -> "void":
    r"""
    lcp_enum_init(LinearComplementarityProblem *problem, SolverOptions *options, int withMemAlloc) -> None

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    options :  
        structure used to define the solver and its parameters.  

    withMemAlloc :  
        If it is not 0, then the necessary work memory is allocated.  

    """
    return _numerics.lcp_enum_init(problem, options, withMemAlloc)

def lcp_enum_reset(problem: "LCP", options: "SolverOptions", withMemAlloc: "int") -> "void":
    r"""
    lcp_enum_reset(LinearComplementarityProblem *problem, SolverOptions *options, int withMemAlloc) -> None

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    options :  
        structure used to define the solver and its parameters.  

    withMemAlloc :  
        If it is not 0, then the work memory is free.  

    """
    return _numerics.lcp_enum_reset(problem, options, withMemAlloc)

def linearComplementarity_enum_setDefaultSolverOptions(problem: "LCP", options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_enum_setDefaultSolverOptions(LinearComplementarityProblem *problem, SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_enum_setDefaultSolverOptions(problem, options)

def lcp_avi_caoferris(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_avi_caoferris(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_avi_caoferris is a direct solver for LCP based on an Affine Variational
    Inequalities (AVI) reformulation The AVI solver is here the one from Cao and
    Ferris Ref: "A Pivotal Method for Affine Variational Inequalities" Menglin Cao
    et Michael Ferris (1996)  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_avi_caoferris(problem, z, w, options)

def lcp_pivot(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_pivot(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_pivot is a direct solver for LCP based on a pivoting method It can currently
    use Bard, Murty's least-index or Lemke rule for choosing the pivot.  

    The default one is Lemke and it cam be changed by setting iparam[2]. The list of
    choices are in the enum LCP_PIVOT (see lcp_cst.h).  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_pivot(problem, z, w, options)

def lcp_pivot_covering_vector(problem: "LCP", u: "double *", s: "double *", options: "SolverOptions", cov_vec: "double *") -> "int *":
    r"""
    lcp_pivot_covering_vector(LinearComplementarityProblem *problem, array_like (np.float64, 1D)u, array_like (np.float64, 1D)s, int *info, SolverOptions *options, array_like (np.float64, 1D)cov_vec) -> None

    """
    return _numerics.lcp_pivot_covering_vector(problem, u, s, options, cov_vec)

def lcp_pivot_lumod(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_pivot_lumod(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    """
    return _numerics.lcp_pivot_lumod(problem, z, w, options)

def lcp_pivot_lumod_covering_vector(problem: "LCP", u: "double *", s: "double *", options: "SolverOptions", cov_vec: "double *") -> "int *":
    r"""
    lcp_pivot_lumod_covering_vector(LinearComplementarityProblem *problem, array_like (np.float64, 1D)u, array_like (np.float64, 1D)s, int *info, SolverOptions *options, array_like (np.float64, 1D)cov_vec) -> None

    """
    return _numerics.lcp_pivot_lumod_covering_vector(problem, u, s, options, cov_vec)

def lcp_pathsearch(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_pathsearch(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_pathsearch is a direct solver for LCP based on the pathsearch algorithm  

    **Warning**: this solver is available for testing purposes only! consider using
        lcp_pivot() if you are looking for simular solvers  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_pathsearch(problem, z, w, options)

def lcp_gams(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_gams(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    lcp_gams uses the solver provided by GAMS  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence 1 : iter =
        itermax  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_gams(problem, z, w, options)

def lcp_nsgs_SBM(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_nsgs_SBM(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    generic interface used to call any LCP solver applied on a Sparse-Block
    structured matrix M, with a Gauss-Seidel process to solve the global problem
    (formulation/solving of local problems for each row of blocks)  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...). M must be a
        SparseBlockStructuredMatrix  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    info :  
        an integer which returns the termination value: 0 : convergence >0 : failed,
        depends on local solver  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.lcp_nsgs_SBM(problem, z, w, options)

def linearComplementarity_nsgs_SBM_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_nsgs_SBM_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for
    LinearComplementarity  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.linearComplementarity_nsgs_SBM_setDefaultSolverOptions(options)

def lcp_nsgs_SBM_buildLocalProblem(rowNumber: "int", blmat: "SparseBlockStructuredMatrix", local_problem: "LCP", q: "double *", z: "double *") -> "void":
    r"""
    lcp_nsgs_SBM_buildLocalProblem(int rowNumber, SparseBlockStructuredMatrix * blmat, LinearComplementarityProblem *local_problem, array_like (np.float64, 1D)q, array_like (np.float64, 1D)z) -> None

    Construct local problem from a "global" one.  

    Parameters
    ----------

    rowNumber :  
        index of the local problem  

    blmat :  
        matrix containing the problem  

    local_problem :  
        problem to fill  

    q :  
        big q  

    z :  
        big z  

    """
    return _numerics.lcp_nsgs_SBM_buildLocalProblem(rowNumber, blmat, local_problem, q, z)

def lcp_compute_error(problem: "LCP", z: "double *", w: "double *", tolerance: "double") -> "double *":
    r"""
    lcp_compute_error(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, double tolerance, array_like (np.float64, 1D)error) -> int

    This function computes the input vector FORMULA11_ and checks the validity of
    the vector z as a solution of the LCP : FORMULA12_ The criterion is based on
    FORMULA13_ with FORMULA14_ and FORMULA15_.  

    This sum is divided by FORMULA16_ and then compared to tol.  

    Parameters
    ----------

    problem :  
        structure that represents the LCP (M, q...)  

    z :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    w :  
        a n-vector of doubles which returns the solution of the problem.  

    tolerance :  
        threshold used to validate the solution: if the error is less than this
        value, the solution is accepted  

    error :  
        the actual error of the solution with respect to the problem  

    Returns
    -------
    status: 0 : convergence, 1: error > tolerance  

    """
    return _numerics.lcp_compute_error(problem, z, w, tolerance)

def lcp_driver_DenseMatrix(problem: "LCP", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    lcp_driver_DenseMatrix(LinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    Interface to solvers for Linear Complementarity Problems, dedicated to dense
    matrix storage.  

    Parameters
    ----------

    problem :  
        the LinearComplementarityProblem structure which handles the problem (M,q)  

    z :  
        a n-vector of doubles which contains the solution of the problem.  

    w :  
        a n-vector of doubles which contains the solution of the problem.  

    options :  
        structure used to define the solver(s) and their parameters  

    Returns
    -------
    info termination value  

    *   0 : successful  
    *   >0 : otherwise see each solver for more information about the log info  

    """
    return _numerics.lcp_driver_DenseMatrix(problem, z, w, options)

def lcp_ConvexQP_ProjectedGradient(problem: "LCP", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    lcp_ConvexQP_ProjectedGradient(LinearComplementarityProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.lcp_ConvexQP_ProjectedGradient(problem, reaction, velocity, options)

def linearComplementarity_ConvexQP_ProjectedGradient_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    linearComplementarity_ConvexQP_ProjectedGradient_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.linearComplementarity_ConvexQP_ProjectedGradient_setDefaultSolverOptions(options)
SICONOS_LCP_LEMKE = _numerics.SICONOS_LCP_LEMKE
SICONOS_LCP_NSGS_SBM = _numerics.SICONOS_LCP_NSGS_SBM
SICONOS_LCP_PGS = _numerics.SICONOS_LCP_PGS
SICONOS_LCP_CPG = _numerics.SICONOS_LCP_CPG
SICONOS_LCP_LATIN = _numerics.SICONOS_LCP_LATIN
SICONOS_LCP_LATIN_W = _numerics.SICONOS_LCP_LATIN_W
SICONOS_LCP_QP = _numerics.SICONOS_LCP_QP
SICONOS_LCP_NSQP = _numerics.SICONOS_LCP_NSQP
SICONOS_LCP_NEWTONMIN = _numerics.SICONOS_LCP_NEWTONMIN
SICONOS_LCP_NEWTON_FBLSA = _numerics.SICONOS_LCP_NEWTON_FBLSA
SICONOS_LCP_PSOR = _numerics.SICONOS_LCP_PSOR
SICONOS_LCP_RPGS = _numerics.SICONOS_LCP_RPGS
SICONOS_LCP_PATH = _numerics.SICONOS_LCP_PATH
SICONOS_LCP_ENUM = _numerics.SICONOS_LCP_ENUM
SICONOS_LCP_AVI_CAOFERRIS = _numerics.SICONOS_LCP_AVI_CAOFERRIS
SICONOS_LCP_PIVOT = _numerics.SICONOS_LCP_PIVOT
SICONOS_LCP_BARD = _numerics.SICONOS_LCP_BARD
SICONOS_LCP_MURTY = _numerics.SICONOS_LCP_MURTY
SICONOS_LCP_NEWTON_MINFBLSA = _numerics.SICONOS_LCP_NEWTON_MINFBLSA
SICONOS_LCP_PATHSEARCH = _numerics.SICONOS_LCP_PATHSEARCH
SICONOS_LCP_PIVOT_LUMOD = _numerics.SICONOS_LCP_PIVOT_LUMOD
SICONOS_LCP_GAMS = _numerics.SICONOS_LCP_GAMS
SICONOS_LCP_CONVEXQP_PG = _numerics.SICONOS_LCP_CONVEXQP_PG
SICONOS_LCP_PIVOT_BARD = _numerics.SICONOS_LCP_PIVOT_BARD
SICONOS_LCP_PIVOT_LEAST_INDEX = _numerics.SICONOS_LCP_PIVOT_LEAST_INDEX
SICONOS_LCP_PIVOT_LEMKE = _numerics.SICONOS_LCP_PIVOT_LEMKE
SICONOS_LCP_PIVOT_PATHSEARCH = _numerics.SICONOS_LCP_PIVOT_PATHSEARCH
class AVI(object):
    r"""

    Structure that contains and defines an AVI.  

    The problem is : given a matrix FORMULA83_ and a vector FORMULA84_, find
    FORMULA85_ such that  

    FORMULA86_  

    See  

    FORMULA87_  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_AVI_AffineVariationalInequalities.h`.


    Attributes
    ----------
     cones : `None *`  
        Non-polyhedral Cones where the variable lives (not implemented yet)  

     d : `array_like (np.float64, 1D)`  
        Covering vector (optional)  

     lb : `array_like (np.float64, 1D)`  
        Lower bounds for the variables.  

     M : `NumericsMatrix *`  
        M matrix of the AVI (see the mathematical description)  

     poly : `polyhedron_set`  
        Polyhedra where the solution has to belong.  

     q : `array_like (np.float64, 1D)`  
        vector of the AVI (see the mathematical description)  

     size : ` int`  
        size of the problem  

     ub : `array_like (np.float64, 1D)`  
        Upper bounds for the variables.  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    size = property(_numerics.AVI_size_get, _numerics.AVI_size_set)
    M = property(_numerics.AVI_M_get, _numerics.AVI_M_set)
    q = property(_numerics.AVI_q_get, _numerics.AVI_q_set)
    d = property(_numerics.AVI_d_get, _numerics.AVI_d_set)
    poly = property(_numerics.AVI_poly_get, _numerics.AVI_poly_set)
    lb = property(_numerics.AVI_lb_get, _numerics.AVI_lb_set)
    ub = property(_numerics.AVI_ub_get, _numerics.AVI_ub_set)
    cones = property(_numerics.AVI_cones_get, _numerics.AVI_cones_set)

    def __init__(self, *args):
        r"""

        Structure that contains and defines an AVI.  

        The problem is : given a matrix FORMULA83_ and a vector FORMULA84_, find
        FORMULA85_ such that  

        FORMULA86_  

        See  

        FORMULA87_  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_AVI_AffineVariationalInequalities.h`.


        Attributes
        ----------
         cones : `None *`  
            Non-polyhedral Cones where the variable lives (not implemented yet)  

         d : `array_like (np.float64, 1D)`  
            Covering vector (optional)  

         lb : `array_like (np.float64, 1D)`  
            Lower bounds for the variables.  

         M : `NumericsMatrix *`  
            M matrix of the AVI (see the mathematical description)  

         poly : `polyhedron_set`  
            Polyhedra where the solution has to belong.  

         q : `array_like (np.float64, 1D)`  
            vector of the AVI (see the mathematical description)  

         size : ` int`  
            size of the problem  

         ub : `array_like (np.float64, 1D)`  
            Upper bounds for the variables.  

        """
        _numerics.AVI_swiginit(self, _numerics.new_AVI(*args))

    def set_polyhedron(self, H_mat: "PyObject *", K_vec: "PyObject *") -> "void":
        return _numerics.AVI_set_polyhedron(self, H_mat, K_vec)
    __swig_destroy__ = _numerics.delete_AVI

# Register AVI in _numerics:
_numerics.AVI_swigregister(AVI)
SICONOS_LCP_LEMKE_STR = cvar.SICONOS_LCP_LEMKE_STR
SICONOS_LCP_NSGS_SBM_STR = cvar.SICONOS_LCP_NSGS_SBM_STR
SICONOS_LCP_PGS_STR = cvar.SICONOS_LCP_PGS_STR
SICONOS_LCP_CPG_STR = cvar.SICONOS_LCP_CPG_STR
SICONOS_LCP_LATIN_STR = cvar.SICONOS_LCP_LATIN_STR
SICONOS_LCP_LATIN_W_STR = cvar.SICONOS_LCP_LATIN_W_STR
SICONOS_LCP_QP_STR = cvar.SICONOS_LCP_QP_STR
SICONOS_LCP_NSQP_STR = cvar.SICONOS_LCP_NSQP_STR
SICONOS_LCP_NEWTONMIN_STR = cvar.SICONOS_LCP_NEWTONMIN_STR
SICONOS_LCP_NEWTON_FBLSA_STR = cvar.SICONOS_LCP_NEWTON_FBLSA_STR
SICONOS_LCP_NEWTON_MINFBLSA_STR = cvar.SICONOS_LCP_NEWTON_MINFBLSA_STR
SICONOS_LCP_PSOR_STR = cvar.SICONOS_LCP_PSOR_STR
SICONOS_LCP_RPGS_STR = cvar.SICONOS_LCP_RPGS_STR
SICONOS_LCP_PATH_STR = cvar.SICONOS_LCP_PATH_STR
SICONOS_LCP_ENUM_STR = cvar.SICONOS_LCP_ENUM_STR
SICONOS_LCP_AVI_CAOFERRIS_STR = cvar.SICONOS_LCP_AVI_CAOFERRIS_STR
SICONOS_LCP_PIVOT_STR = cvar.SICONOS_LCP_PIVOT_STR
SICONOS_LCP_BARD_STR = cvar.SICONOS_LCP_BARD_STR
SICONOS_LCP_MURTY_STR = cvar.SICONOS_LCP_MURTY_STR
SICONOS_LCP_PATHSEARCH_STR = cvar.SICONOS_LCP_PATHSEARCH_STR
SICONOS_LCP_PIVOT_LUMOD_STR = cvar.SICONOS_LCP_PIVOT_LUMOD_STR
SICONOS_LCP_GAMS_STR = cvar.SICONOS_LCP_GAMS_STR
SICONOS_LCP_CONVEXQP_PG_STR = cvar.SICONOS_LCP_CONVEXQP_PG_STR


def AVI_display(avi: "AVI") -> "void":
    r"""
    AVI_display(AffineVariationalInequalities *avi) -> None

    Affine Variational Inequalities display.  

    Parameters
    ----------

    avi :  
        pointer to the AffineVariationalInequalities to display  

    """
    return _numerics.AVI_display(avi)

def AVI_printInFile(avi: "AVI", file: "FILE *") -> "int":
    r"""
    AVI_printInFile(AffineVariationalInequalities *avi, FILE *file) -> int

    write AVI to file  

    Parameters
    ----------

    avi :  
        pointer to a AffineVariationalInequalities to print  

    file :  
        pointer to a FILE  

    Returns
    -------
    1 if successfull  

    """
    return _numerics.AVI_printInFile(avi, file)

def AVI_newFromFile(avi: "AVI", file: "FILE *") -> "int":
    r"""
    AVI_newFromFile(AffineVariationalInequalities *avi, FILE *file) -> int

    read from file and create AffineVariationalInequalities  

    Parameters
    ----------

    avi :  
        pointer to a AffineVariationalInequalities to create  

    file :  
        pointer to a FILE  

    Returns
    -------
    1 if successfull  

    """
    return _numerics.AVI_newFromFile(avi, file)

def AVI_newFromFilename(avi: "AVI", filename: "char *") -> "int":
    r"""
    AVI_newFromFilename(AffineVariationalInequalities *avi, char *filename) -> int

    function to read and create a AffineVariationalInequalities from a file  

    Parameters
    ----------

    avi :  
        pointer to a AffineVariationalInequalities to create  

    filename :  
        that contains the AVI  

    Returns
    -------
    1 if successfull  

    """
    return _numerics.AVI_newFromFilename(avi, filename)

def freeAVI(avi: "AVI") -> "void":
    r"""
    freeAVI(AffineVariationalInequalities *avi) -> None

    function to delete a AffineVariationalInequalities  

    Parameters
    ----------

    avi :  
        pointer to a AffineVariationalInequalities to delete  

    """
    return _numerics.freeAVI(avi)

def newAVI() -> "AffineVariationalInequalities *":
    r"""
    newAVI(None) -> AffineVariationalInequalities *

    Create an empty AVI struct.  

    Returns
    -------
    an empty AffineVariationalInequalities  

    """
    return _numerics.newAVI()

def avi_caoferris(problem: "AVI", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    avi_caoferris(AffineVariationalInequalities *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    avi_caoferris is a direct solver for AVI based on pivoting method principle for
    degenerate problem Choice of pivot variable is performed via lexicographic
    ordering Ref: "A Pivotal Method for Affine Variational Inequalities" Menglin
    Cao et Michael Ferris (1996)  

    Parameters
    ----------

    problem :  
        structure that represents the AVI (M, q, K)  

    z :  
        on call contains the initial solution and on return holds the solution of
        the problem.  

    w :  
        defined as Mz + q  

    options :  
        structure used to define the solver and its parameters.  

    Returns
    -------
    info about the convergence: 0 ok; 1 ...  

    """
    return _numerics.avi_caoferris(problem, z, w, options)

def avi_pathavi(problem: "AVI", z: "double *", w: "double *", options: "SolverOptions") -> "int":
    r"""
    avi_pathavi(AffineVariationalInequalities *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, SolverOptions *options) -> int

    avi_pathavi is using PATHVI, a direct solver for VI based on pivoting method
    principle for degenerate problem Ref: "A structure-preserving Pivotal Method
    for Affine Variational Inequalities" Y.  

    Kim, O. Huber, M.C. Ferris, Math Prog B (2017)  

    Parameters
    ----------

    problem :  
        structure that represents the AVI (M, q, K)  

    z :  
        on call contains the initial solution and on return holds the solution of
        the problem.  

    w :  
        defined as Mz + q  

    options :  
        structure used to define the solver and its parameters.  

    Returns
    -------
    info about the convergence: 0 ok; 1 ...  

    """
    return _numerics.avi_pathavi(problem, z, w, options)
SICONOS_AVI_CAOFERRIS = _numerics.SICONOS_AVI_CAOFERRIS
SICONOS_AVI_PATHAVI = _numerics.SICONOS_AVI_PATHAVI

def mixedLinearComplementarityProblemFromFile(filename: "char const *") -> "MixedLinearComplementarityProblem *":
    return _numerics.mixedLinearComplementarityProblemFromFile(filename)
SICONOS_RELAY_PGS = _numerics.SICONOS_RELAY_PGS
SICONOS_RELAY_ENUM = _numerics.SICONOS_RELAY_ENUM
SICONOS_RELAY_PATH = _numerics.SICONOS_RELAY_PATH
SICONOS_RELAY_LEMKE = _numerics.SICONOS_RELAY_LEMKE
SICONOS_RELAY_LATIN = _numerics.SICONOS_RELAY_LATIN
SICONOS_RELAY_NLGS = _numerics.SICONOS_RELAY_NLGS
SICONOS_RELAY_AVI_CAOFERRIS = _numerics.SICONOS_RELAY_AVI_CAOFERRIS
SICONOS_RELAY_AVI_CAOFERRIS_TEST = _numerics.SICONOS_RELAY_AVI_CAOFERRIS_TEST
SICONOS_FRICTION_2D_NSGS = _numerics.SICONOS_FRICTION_2D_NSGS
SICONOS_FRICTION_2D_PGS = _numerics.SICONOS_FRICTION_2D_PGS
SICONOS_FRICTION_2D_CPG = _numerics.SICONOS_FRICTION_2D_CPG
SICONOS_FRICTION_2D_LATIN = _numerics.SICONOS_FRICTION_2D_LATIN
SICONOS_FRICTION_2D_LEMKE = _numerics.SICONOS_FRICTION_2D_LEMKE
SICONOS_FRICTION_2D_ENUM = _numerics.SICONOS_FRICTION_2D_ENUM
SICONOS_FRICTION_3D_NSGS = _numerics.SICONOS_FRICTION_3D_NSGS
SICONOS_FRICTION_3D_NSGSV = _numerics.SICONOS_FRICTION_3D_NSGSV
SICONOS_FRICTION_3D_PROX = _numerics.SICONOS_FRICTION_3D_PROX
SICONOS_FRICTION_3D_TFP = _numerics.SICONOS_FRICTION_3D_TFP
SICONOS_FRICTION_3D_NSN_AC = _numerics.SICONOS_FRICTION_3D_NSN_AC
SICONOS_FRICTION_3D_DSFP = _numerics.SICONOS_FRICTION_3D_DSFP
SICONOS_FRICTION_3D_VI_FPP = _numerics.SICONOS_FRICTION_3D_VI_FPP
SICONOS_FRICTION_3D_VI_EG = _numerics.SICONOS_FRICTION_3D_VI_EG
SICONOS_FRICTION_3D_HP = _numerics.SICONOS_FRICTION_3D_HP
SICONOS_FRICTION_3D_NCPGlockerFBFixedPoint = _numerics.SICONOS_FRICTION_3D_NCPGlockerFBFixedPoint
SICONOS_FRICTION_3D_FPP = _numerics.SICONOS_FRICTION_3D_FPP
SICONOS_FRICTION_3D_EG = _numerics.SICONOS_FRICTION_3D_EG
SICONOS_FRICTION_3D_NSN_FB = _numerics.SICONOS_FRICTION_3D_NSN_FB
SICONOS_FRICTION_3D_GAMS_PATH = _numerics.SICONOS_FRICTION_3D_GAMS_PATH
SICONOS_FRICTION_3D_GAMS_PATHVI = _numerics.SICONOS_FRICTION_3D_GAMS_PATHVI
SICONOS_FRICTION_3D_ACLMFP = _numerics.SICONOS_FRICTION_3D_ACLMFP
SICONOS_FRICTION_3D_SOCLCP = _numerics.SICONOS_FRICTION_3D_SOCLCP
SICONOS_FRICTION_3D_GAMS_LCP_PATH = _numerics.SICONOS_FRICTION_3D_GAMS_LCP_PATH
SICONOS_FRICTION_3D_GAMS_LCP_PATHVI = _numerics.SICONOS_FRICTION_3D_GAMS_LCP_PATHVI
SICONOS_FRICTION_3D_NSN_NM = _numerics.SICONOS_FRICTION_3D_NSN_NM
SICONOS_FRICTION_3D_NSN_AC_TEST = _numerics.SICONOS_FRICTION_3D_NSN_AC_TEST
SICONOS_FRICTION_3D_PFP = _numerics.SICONOS_FRICTION_3D_PFP
SICONOS_FRICTION_3D_ADMM = _numerics.SICONOS_FRICTION_3D_ADMM
SICONOS_FRICTION_3D_ONECONTACT_NSN = _numerics.SICONOS_FRICTION_3D_ONECONTACT_NSN
SICONOS_FRICTION_3D_ONECONTACT_NSN_GP = _numerics.SICONOS_FRICTION_3D_ONECONTACT_NSN_GP
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone = _numerics.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithLocalIteration = _numerics.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithLocalIteration
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithRegularization = _numerics.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithRegularization
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithDiagonalization = _numerics.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithDiagonalization
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone_velocity = _numerics.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone_velocity
SICONOS_FRICTION_3D_DeSaxceFixedPoint = _numerics.SICONOS_FRICTION_3D_DeSaxceFixedPoint
SICONOS_FRICTION_3D_NCPGlockerFBPATH = _numerics.SICONOS_FRICTION_3D_NCPGlockerFBPATH
SICONOS_FRICTION_3D_NCPGlockerFBNewton = _numerics.SICONOS_FRICTION_3D_NCPGlockerFBNewton
SICONOS_FRICTION_3D_ONECONTACT_QUARTIC = _numerics.SICONOS_FRICTION_3D_ONECONTACT_QUARTIC
SICONOS_FRICTION_3D_ONECONTACT_QUARTIC_NU = _numerics.SICONOS_FRICTION_3D_ONECONTACT_QUARTIC_NU
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCylinder = _numerics.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCylinder
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCylinderWithLocalIteration = _numerics.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCylinderWithLocalIteration
SICONOS_FRICTION_3D_ONECONTACT_NSN_GP_HYBRID = _numerics.SICONOS_FRICTION_3D_ONECONTACT_NSN_GP_HYBRID
SICONOS_FRICTION_3D_VI_FPP_Cylinder = _numerics.SICONOS_FRICTION_3D_VI_FPP_Cylinder
SICONOS_FRICTION_3D_ConvexQP_PG_Cylinder = _numerics.SICONOS_FRICTION_3D_ConvexQP_PG_Cylinder
SICONOS_GLOBAL_FRICTION_3D_NSGS_WR = _numerics.SICONOS_GLOBAL_FRICTION_3D_NSGS_WR
SICONOS_GLOBAL_FRICTION_3D_NSGSV_WR = _numerics.SICONOS_GLOBAL_FRICTION_3D_NSGSV_WR
SICONOS_GLOBAL_FRICTION_3D_PROX_WR = _numerics.SICONOS_GLOBAL_FRICTION_3D_PROX_WR
SICONOS_GLOBAL_FRICTION_3D_DSFP_WR = _numerics.SICONOS_GLOBAL_FRICTION_3D_DSFP_WR
SICONOS_GLOBAL_FRICTION_3D_TFP_WR = _numerics.SICONOS_GLOBAL_FRICTION_3D_TFP_WR
SICONOS_GLOBAL_FRICTION_3D_NSGS = _numerics.SICONOS_GLOBAL_FRICTION_3D_NSGS
SICONOS_GLOBAL_FRICTION_3D_NSN_AC_WR = _numerics.SICONOS_GLOBAL_FRICTION_3D_NSN_AC_WR
SICONOS_GLOBAL_FRICTION_3D_NSN_AC = _numerics.SICONOS_GLOBAL_FRICTION_3D_NSN_AC
SICONOS_GLOBAL_FRICTION_3D_GAMS_PATH = _numerics.SICONOS_GLOBAL_FRICTION_3D_GAMS_PATH
SICONOS_GLOBAL_FRICTION_3D_GAMS_PATHVI = _numerics.SICONOS_GLOBAL_FRICTION_3D_GAMS_PATHVI
SICONOS_GLOBAL_FRICTION_3D_VI_FPP = _numerics.SICONOS_GLOBAL_FRICTION_3D_VI_FPP
SICONOS_GLOBAL_FRICTION_3D_VI_EG = _numerics.SICONOS_GLOBAL_FRICTION_3D_VI_EG
SICONOS_GLOBAL_FRICTION_3D_ACLMFP = _numerics.SICONOS_GLOBAL_FRICTION_3D_ACLMFP
SICONOS_GLOBAL_FRICTION_3D_ADMM = _numerics.SICONOS_GLOBAL_FRICTION_3D_ADMM
SICONOS_GLOBAL_FRICTION_3D_ADMM_WR = _numerics.SICONOS_GLOBAL_FRICTION_3D_ADMM_WR
SICONOS_FRICTION_3D_IPARAM_INTERNAL_ERROR_STRATEGY = _numerics.SICONOS_FRICTION_3D_IPARAM_INTERNAL_ERROR_STRATEGY
SICONOS_FRICTION_3D_IPARAM_ERROR_EVALUATION = _numerics.SICONOS_FRICTION_3D_IPARAM_ERROR_EVALUATION
SICONOS_FRICTION_3D_IPARAM_ERROR_EVALUATION_FREQUENCY = _numerics.SICONOS_FRICTION_3D_IPARAM_ERROR_EVALUATION_FREQUENCY
SICONOS_FRICTION_3D_INTERNAL_ERROR_STRATEGY_ADAPTIVE = _numerics.SICONOS_FRICTION_3D_INTERNAL_ERROR_STRATEGY_ADAPTIVE
SICONOS_FRICTION_3D_INTERNAL_ERROR_STRATEGY_GIVEN_VALUE = _numerics.SICONOS_FRICTION_3D_INTERNAL_ERROR_STRATEGY_GIVEN_VALUE
SICONOS_FRICTION_3D_INTERNAL_ERROR_STRATEGY_ADAPTIVE_N_CONTACT = _numerics.SICONOS_FRICTION_3D_INTERNAL_ERROR_STRATEGY_ADAPTIVE_N_CONTACT
SICONOS_FRICTION_3D_DPARAM_INTERNAL_ERROR_RATIO = _numerics.SICONOS_FRICTION_3D_DPARAM_INTERNAL_ERROR_RATIO
SICONOS_FRICTION_3D_NSGS_RELAXATION = _numerics.SICONOS_FRICTION_3D_NSGS_RELAXATION
SICONOS_FRICTION_3D_NSGS_SHUFFLE = _numerics.SICONOS_FRICTION_3D_NSGS_SHUFFLE
SICONOS_FRICTION_3D_NSGS_SHUFFLE_SEED = _numerics.SICONOS_FRICTION_3D_NSGS_SHUFFLE_SEED
SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION = _numerics.SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION
SICONOS_FRICTION_3D_NSGS_RELAXATION_VALUE = _numerics.SICONOS_FRICTION_3D_NSGS_RELAXATION_VALUE
SICONOS_FRICTION_3D_NSGS_LOCALSOLVER_CONTACTNUMBER = _numerics.SICONOS_FRICTION_3D_NSGS_LOCALSOLVER_CONTACTNUMBER
SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_FULL = _numerics.SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_FULL
SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_LIGHT = _numerics.SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_LIGHT
SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_LIGHT_WITH_FULL_FINAL = _numerics.SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_LIGHT_WITH_FULL_FINAL
SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_ADAPTIVE = _numerics.SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_ADAPTIVE
SICONOS_FRICTION_3D_NSGS_SHUFFLE_FALSE = _numerics.SICONOS_FRICTION_3D_NSGS_SHUFFLE_FALSE
SICONOS_FRICTION_3D_NSGS_SHUFFLE_TRUE = _numerics.SICONOS_FRICTION_3D_NSGS_SHUFFLE_TRUE
SICONOS_FRICTION_3D_NSGS_SHUFFLE_TRUE_EACH_LOOP = _numerics.SICONOS_FRICTION_3D_NSGS_SHUFFLE_TRUE_EACH_LOOP
SICONOS_FRICTION_3D_NSGS_RELAXATION_FALSE = _numerics.SICONOS_FRICTION_3D_NSGS_RELAXATION_FALSE
SICONOS_FRICTION_3D_NSGS_RELAXATION_TRUE = _numerics.SICONOS_FRICTION_3D_NSGS_RELAXATION_TRUE
SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION_FALSE = _numerics.SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION_FALSE
SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION_TRUE = _numerics.SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION_TRUE
SICONOS_FRICTION_3D_NSN_RHO_STRATEGY = _numerics.SICONOS_FRICTION_3D_NSN_RHO_STRATEGY
SICONOS_FRICTION_3D_NSN_FORMULATION = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION
SICONOS_FRICTION_3D_NSN_LINESEARCH = _numerics.SICONOS_FRICTION_3D_NSN_LINESEARCH
SICONOS_FRICTION_3D_NSN_LINESEARCH_MAXITER = _numerics.SICONOS_FRICTION_3D_NSN_LINESEARCH_MAXITER
SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY = _numerics.SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY
SICONOS_FRICTION_3D_NSN_HYBRID_MAX_LOOP = _numerics.SICONOS_FRICTION_3D_NSN_HYBRID_MAX_LOOP
SICONOS_FRICTION_3D_NSN_HYBRID_MAX_ITER = _numerics.SICONOS_FRICTION_3D_NSN_HYBRID_MAX_ITER
SICONOS_FRICTION_3D_NSN_MEMORY_ALLOCATION = _numerics.SICONOS_FRICTION_3D_NSN_MEMORY_ALLOCATION
SICONOS_FRICTION_3D_NSN_MPI_COM = _numerics.SICONOS_FRICTION_3D_NSN_MPI_COM
SICONOS_FRICTION_3D_NSN_RHO = _numerics.SICONOS_FRICTION_3D_NSN_RHO
SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_CONSTANT = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_CONSTANT
SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_SPECTRAL_NORM = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_SPECTRAL_NORM
SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_SPLIT_SPECTRAL_NORM_COND = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_SPLIT_SPECTRAL_NORM_COND
SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_SPLIT_SPECTRAL_NORM = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_SPLIT_SPECTRAL_NORM
SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_ADAPTIVE = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_RHO_STRATEGY_ADAPTIVE
SICONOS_FRICTION_3D_NSN_FORMULATION_ALARTCURNIER_STD = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_ALARTCURNIER_STD
SICONOS_FRICTION_3D_NSN_FORMULATION_JEANMOREAU_STD = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_JEANMOREAU_STD
SICONOS_FRICTION_3D_NSN_FORMULATION_ALARTCURNIER_GENERATED = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_ALARTCURNIER_GENERATED
SICONOS_FRICTION_3D_NSN_FORMULATION_JEANMOREAU_GENERATED = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_JEANMOREAU_GENERATED
SICONOS_FRICTION_3D_NSN_FORMULATION_NULL = _numerics.SICONOS_FRICTION_3D_NSN_FORMULATION_NULL
SICONOS_FRICTION_3D_NSN_LINESEARCH_GOLDSTEINPRICE = _numerics.SICONOS_FRICTION_3D_NSN_LINESEARCH_GOLDSTEINPRICE
SICONOS_FRICTION_3D_NSN_LINESEARCH_ARMIJO = _numerics.SICONOS_FRICTION_3D_NSN_LINESEARCH_ARMIJO
SICONOS_FRICTION_3D_NSN_LINESEARCH_NO = _numerics.SICONOS_FRICTION_3D_NSN_LINESEARCH_NO
SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_NO = _numerics.SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_NO
SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_PLI_NSN_LOOP = _numerics.SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_PLI_NSN_LOOP
SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_NSN_AND_PLI_NSN_LOOP = _numerics.SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_NSN_AND_PLI_NSN_LOOP
SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_VI_EG_NSN = _numerics.SICONOS_FRICTION_3D_NSN_HYBRID_STRATEGY_VI_EG_NSN
SICONOS_FRICTION_3D_FP_ERROR_STRATEGY = _numerics.SICONOS_FRICTION_3D_FP_ERROR_STRATEGY
SICONOS_FRICTION_3D_PROXIMAL_IPARAM_CUMULATIVE_ITER_DONE = _numerics.SICONOS_FRICTION_3D_PROXIMAL_IPARAM_CUMULATIVE_ITER_DONE
SICONOS_FRICTION_3D_PROXIMAL_IPARAM_RELAXATION = _numerics.SICONOS_FRICTION_3D_PROXIMAL_IPARAM_RELAXATION
SICONOS_FRICTION_3D_PROXIMAL_IPARAM_STRATEGY = _numerics.SICONOS_FRICTION_3D_PROXIMAL_IPARAM_STRATEGY
SICONOS_FRICTION_3D_PROXIMAL_DPARAM_ALPHA = _numerics.SICONOS_FRICTION_3D_PROXIMAL_DPARAM_ALPHA
SICONOS_FRICTION_3D_PROXIMAL_DPARAM_SIGMA = _numerics.SICONOS_FRICTION_3D_PROXIMAL_DPARAM_SIGMA
SICONOS_FRICTION_3D_PROXIMAL_DPARAM_NU = _numerics.SICONOS_FRICTION_3D_PROXIMAL_DPARAM_NU
SICONOS_FRICTION_3D_PROXIMAL_DPARAM_RELAXATION = _numerics.SICONOS_FRICTION_3D_PROXIMAL_DPARAM_RELAXATION
SICONOS_FRICTION_3D_PROXIMAL_PROX = _numerics.SICONOS_FRICTION_3D_PROXIMAL_PROX
SICONOS_FRICTION_3D_PROXIMAL_REGULARIZATION = _numerics.SICONOS_FRICTION_3D_PROXIMAL_REGULARIZATION
SICONOS_FRICTION_3D_ADMM_IPARAM_RHO_STRATEGY = _numerics.SICONOS_FRICTION_3D_ADMM_IPARAM_RHO_STRATEGY
SICONOS_FRICTION_3D_ADMM_IPARAM_ACCELERATION = _numerics.SICONOS_FRICTION_3D_ADMM_IPARAM_ACCELERATION
SICONOS_FRICTION_3D_ADMM_IPARAM_SYMMETRY = _numerics.SICONOS_FRICTION_3D_ADMM_IPARAM_SYMMETRY
SICONOS_FRICTION_3D_ADMM_IPARAM_SPARSE_STORAGE = _numerics.SICONOS_FRICTION_3D_ADMM_IPARAM_SPARSE_STORAGE
SICONOS_FRICTION_3D_ADMM_RHO = _numerics.SICONOS_FRICTION_3D_ADMM_RHO
SICONOS_FRICTION_3D_ADMM_RESTART_ETA = _numerics.SICONOS_FRICTION_3D_ADMM_RESTART_ETA
SICONOS_FRICTION_3D_ADMM_BALANCING_RESIDUAL_TAU = _numerics.SICONOS_FRICTION_3D_ADMM_BALANCING_RESIDUAL_TAU
SICONOS_FRICTION_3D_ADMM_BALANCING_RESIDUAL_PHI = _numerics.SICONOS_FRICTION_3D_ADMM_BALANCING_RESIDUAL_PHI
SICONOS_FRICTION_3D_ADMM_NO_ACCELERATION = _numerics.SICONOS_FRICTION_3D_ADMM_NO_ACCELERATION
SICONOS_FRICTION_3D_ADMM_ACCELERATION = _numerics.SICONOS_FRICTION_3D_ADMM_ACCELERATION
SICONOS_FRICTION_3D_ADMM_ACCELERATION_AND_RESTART = _numerics.SICONOS_FRICTION_3D_ADMM_ACCELERATION_AND_RESTART
SICONOS_FRICTION_3D_ADMM_CHECK_SYMMETRY = _numerics.SICONOS_FRICTION_3D_ADMM_CHECK_SYMMETRY
SICONOS_FRICTION_3D_ADMM_FORCED_SYMMETRY = _numerics.SICONOS_FRICTION_3D_ADMM_FORCED_SYMMETRY
SICONOS_FRICTION_3D_ADMM_FORCED_ASYMMETRY = _numerics.SICONOS_FRICTION_3D_ADMM_FORCED_ASYMMETRY
SICONOS_FRICTION_3D_ADMM_KEEP_STORAGE = _numerics.SICONOS_FRICTION_3D_ADMM_KEEP_STORAGE
SICONOS_FRICTION_3D_ADMM_FORCED_SPARSE_STORAGE = _numerics.SICONOS_FRICTION_3D_ADMM_FORCED_SPARSE_STORAGE
SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_CONSTANT = _numerics.SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_CONSTANT
SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_NORM_INF = _numerics.SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_NORM_INF
SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_RESIDUAL_BALANCING = _numerics.SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_RESIDUAL_BALANCING
SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_SCALED_RESIDUAL_BALANCING = _numerics.SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_SCALED_RESIDUAL_BALANCING
SICONOS_MCP_FB = _numerics.SICONOS_MCP_FB
SICONOS_MCP_NEWTON_FBLSA = _numerics.SICONOS_MCP_NEWTON_FBLSA
SICONOS_MCP_NEWTON_MINFBLSA = _numerics.SICONOS_MCP_NEWTON_MINFBLSA
SICONOS_NCP_NEWTON_FBLSA = _numerics.SICONOS_NCP_NEWTON_FBLSA
SICONOS_NCP_NEWTON_MINFBLSA = _numerics.SICONOS_NCP_NEWTON_MINFBLSA
SICONOS_NCP_PATHSEARCH = _numerics.SICONOS_NCP_PATHSEARCH
SICONOS_NCP_PATH = _numerics.SICONOS_NCP_PATH
SICONOS_VI_EG = _numerics.SICONOS_VI_EG
SICONOS_VI_FPP = _numerics.SICONOS_VI_FPP
SICONOS_VI_HP = _numerics.SICONOS_VI_HP
SICONOS_VI_BOX_QI = _numerics.SICONOS_VI_BOX_QI
SICONOS_VI_BOX_AVI_LSA = _numerics.SICONOS_VI_BOX_AVI_LSA
SICONOS_VI_BOX_PATH = _numerics.SICONOS_VI_BOX_PATH
SICONOS_VI_IPARAM_LINESEARCH_METHOD = _numerics.SICONOS_VI_IPARAM_LINESEARCH_METHOD
SICONOS_VI_IPARAM_ERROR_EVALUATION = _numerics.SICONOS_VI_IPARAM_ERROR_EVALUATION
SICONOS_VI_IPARAM_ERROR_EVALUATION_FREQUENCY = _numerics.SICONOS_VI_IPARAM_ERROR_EVALUATION_FREQUENCY
SICONOS_VI_EG_DPARAM_RHO = _numerics.SICONOS_VI_EG_DPARAM_RHO
SICONOS_VI_EG_DPARAM_LS_TAU = _numerics.SICONOS_VI_EG_DPARAM_LS_TAU
SICONOS_VI_EG_DPARAM_LS_TAUINV = _numerics.SICONOS_VI_EG_DPARAM_LS_TAUINV
SICONOS_VI_EG_DPARAM_LS_L = _numerics.SICONOS_VI_EG_DPARAM_LS_L
SICONOS_VI_EG_DPARAM_LS_LMIN = _numerics.SICONOS_VI_EG_DPARAM_LS_LMIN
SICONOS_VI_ERROR_EVALUATION_FULL = _numerics.SICONOS_VI_ERROR_EVALUATION_FULL
SICONOS_VI_ERROR_EVALUATION_LIGHT_WITH_FULL_FINAL = _numerics.SICONOS_VI_ERROR_EVALUATION_LIGHT_WITH_FULL_FINAL
SICONOS_VI_ERROR_EVALUATION_LIGHT = _numerics.SICONOS_VI_ERROR_EVALUATION_LIGHT
SICONOS_VI_ERROR_EVALUATION_ADAPTIVE = _numerics.SICONOS_VI_ERROR_EVALUATION_ADAPTIVE
SICONOS_GENERIC_MECHANICAL_NSGS = _numerics.SICONOS_GENERIC_MECHANICAL_NSGS
ENV_IS_C_STRUCT = _numerics.ENV_IS_C_STRUCT
ENV_IS_UNKNOWN = _numerics.ENV_IS_UNKNOWN
ENV_IS_PYTHON_CLASS = _numerics.ENV_IS_PYTHON_CLASS
ENV_IS_PYTHON_FUNCTIONS = _numerics.ENV_IS_PYTHON_FUNCTIONS
ENV_IS_PYTHON_FUNCTIONS_WITH_PROJ = _numerics.ENV_IS_PYTHON_FUNCTIONS_WITH_PROJ
ENV_IS_MATLAB_FUNCTION_HANDLES = _numerics.ENV_IS_MATLAB_FUNCTION_HANDLES
ENV_IS_MATLAB_FUNCTION_NAMES = _numerics.ENV_IS_MATLAB_FUNCTION_NAMES
class MCP(object):
    r"""

    The structure that defines a Mixed Complementarity problem (MCP) : find two
    vectors FORMULA68_ such that:  

    FORMULA69_  

    where "i" (resp. "e") stands for inequalities (resp. equalities). The vector
    FORMULA70_ is splitted like FORMULA71_:  

    FORMULA72_  

    FORMULA73_ are vectors of size sizeEqualities, FORMULA74_ vectors of size
    sizeInequalities  

    and FORMULA75_ is a non linear function that must be user-defined.  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_MCP_MixedComplementarityProblem.h`.


    Attributes
    ----------
     computeFmcp : `ptrFunctionMCP`  
        pointer to the function to compute F(z)  

     computeNablaFmcp : `ptrFunctionMCP`  

     Fmcp : `array_like (np.float64, 1D)`  
        pointer to the function to compute the jacobian of F(z)  

        The value F(z)  

     nablaFmcp : `array_like (np.float64, 1D)`  
        jacobian of F(z)  

     sizeEqualities : `int`  
        size of equalities $z_e, w_e$ size  

     sizeInequalities : `int`  
        size of inequalities $z_i,w_i$ size  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    sizeEqualities = property(_numerics.MCP_sizeEqualities_get, _numerics.MCP_sizeEqualities_set)
    sizeInequalities = property(_numerics.MCP_sizeInequalities_get, _numerics.MCP_sizeInequalities_set)
    computeFmcp = property(_numerics.MCP_computeFmcp_get, _numerics.MCP_computeFmcp_set)
    computeNablaFmcp = property(_numerics.MCP_computeNablaFmcp_get, _numerics.MCP_computeNablaFmcp_set)
    Fmcp = property(_numerics.MCP_Fmcp_get, _numerics.MCP_Fmcp_set)
    nablaFmcp = property(_numerics.MCP_nablaFmcp_get, _numerics.MCP_nablaFmcp_set)

    def set_computeFmcp(self, o: "PyObject *") -> "void":
        return _numerics.MCP_set_computeFmcp(self, o)

    def set_computeNablaFmcp(self, o: "PyObject *") -> "void":
        return _numerics.MCP_set_computeNablaFmcp(self, o)

    def test_call_to_callback(self) -> "void":
        return _numerics.MCP_test_call_to_callback(self)

    def __init__(self, *args):
        r"""

        The structure that defines a Mixed Complementarity problem (MCP) : find two
        vectors FORMULA68_ such that:  

        FORMULA69_  

        where "i" (resp. "e") stands for inequalities (resp. equalities). The vector
        FORMULA70_ is splitted like FORMULA71_:  

        FORMULA72_  

        FORMULA73_ are vectors of size sizeEqualities, FORMULA74_ vectors of size
        sizeInequalities  

        and FORMULA75_ is a non linear function that must be user-defined.  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_MCP_MixedComplementarityProblem.h`.


        Attributes
        ----------
         computeFmcp : `ptrFunctionMCP`  
            pointer to the function to compute F(z)  

         computeNablaFmcp : `ptrFunctionMCP`  

         Fmcp : `array_like (np.float64, 1D)`  
            pointer to the function to compute the jacobian of F(z)  

            The value F(z)  

         nablaFmcp : `array_like (np.float64, 1D)`  
            jacobian of F(z)  

         sizeEqualities : `int`  
            size of equalities $z_e, w_e$ size  

         sizeInequalities : `int`  
            size of inequalities $z_i,w_i$ size  

        """
        _numerics.MCP_swiginit(self, _numerics.new_MCP(*args))
    __swig_destroy__ = _numerics.delete_MCP

# Register MCP in _numerics:
_numerics.MCP_swigregister(MCP)
SICONOS_AVI_CAOFERRIS_STR = cvar.SICONOS_AVI_CAOFERRIS_STR
SICONOS_AVI_PATHAVI_STR = cvar.SICONOS_AVI_PATHAVI_STR
SICONOS_RELAY_PGS_STR = cvar.SICONOS_RELAY_PGS_STR
SICONOS_RELAY_PATH_STR = cvar.SICONOS_RELAY_PATH_STR
SICONOS_RELAY_ENUM_STR = cvar.SICONOS_RELAY_ENUM_STR
SICONOS_RELAY_NLGS_STR = cvar.SICONOS_RELAY_NLGS_STR
SICONOS_RELAY_LEMKE_STR = cvar.SICONOS_RELAY_LEMKE_STR
SICONOS_RELAY_LATIN_STR = cvar.SICONOS_RELAY_LATIN_STR
SICONOS_RELAY_AVI_CAOFERRIS_STR = cvar.SICONOS_RELAY_AVI_CAOFERRIS_STR
SICONOS_RELAY_AVI_CAOFERRIS_TEST_STR = cvar.SICONOS_RELAY_AVI_CAOFERRIS_TEST_STR
SICONOS_FRICTION_2D_NSGS_STR = cvar.SICONOS_FRICTION_2D_NSGS_STR
SICONOS_FRICTION_2D_PGS_STR = cvar.SICONOS_FRICTION_2D_PGS_STR
SICONOS_FRICTION_2D_CPG_STR = cvar.SICONOS_FRICTION_2D_CPG_STR
SICONOS_FRICTION_2D_LATIN_STR = cvar.SICONOS_FRICTION_2D_LATIN_STR
SICONOS_FRICTION_2D_LEMKE_STR = cvar.SICONOS_FRICTION_2D_LEMKE_STR
SICONOS_FRICTION_2D_ENUM_STR = cvar.SICONOS_FRICTION_2D_ENUM_STR
SICONOS_FRICTION_3D_NSGS_STR = cvar.SICONOS_FRICTION_3D_NSGS_STR
SICONOS_FRICTION_3D_NSGSV_STR = cvar.SICONOS_FRICTION_3D_NSGSV_STR
SICONOS_FRICTION_3D_PROX_STR = cvar.SICONOS_FRICTION_3D_PROX_STR
SICONOS_FRICTION_3D_TFP_STR = cvar.SICONOS_FRICTION_3D_TFP_STR
SICONOS_FRICTION_3D_PFP_STR = cvar.SICONOS_FRICTION_3D_PFP_STR
SICONOS_FRICTION_3D_NSN_AC_STR = cvar.SICONOS_FRICTION_3D_NSN_AC_STR
SICONOS_FRICTION_3D_NSN_AC_TEST_STR = cvar.SICONOS_FRICTION_3D_NSN_AC_TEST_STR
SICONOS_FRICTION_3D_NSN_FB_STR = cvar.SICONOS_FRICTION_3D_NSN_FB_STR
SICONOS_FRICTION_3D_NSN_NM_STR = cvar.SICONOS_FRICTION_3D_NSN_NM_STR
SICONOS_FRICTION_3D_DSFP_STR = cvar.SICONOS_FRICTION_3D_DSFP_STR
SICONOS_FRICTION_3D_VI_EG_STR = cvar.SICONOS_FRICTION_3D_VI_EG_STR
SICONOS_FRICTION_3D_VI_FPP_STR = cvar.SICONOS_FRICTION_3D_VI_FPP_STR
SICONOS_FRICTION_3D_EG_STR = cvar.SICONOS_FRICTION_3D_EG_STR
SICONOS_FRICTION_3D_FPP_STR = cvar.SICONOS_FRICTION_3D_FPP_STR
SICONOS_FRICTION_3D_HP_STR = cvar.SICONOS_FRICTION_3D_HP_STR
SICONOS_FRICTION_3D_NCPGlockerFBFixedPoint_STR = cvar.SICONOS_FRICTION_3D_NCPGlockerFBFixedPoint_STR
SICONOS_FRICTION_3D_ONECONTACT_NSN_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_NSN_STR
SICONOS_FRICTION_3D_ONECONTACT_NSN_GP_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_NSN_GP_STR
SICONOS_FRICTION_3D_ONECONTACT_NSN_GP_HYBRID_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_NSN_GP_HYBRID_STR
SICONOS_FRICTION_3D_NCPGlockerFBNewton_STR = cvar.SICONOS_FRICTION_3D_NCPGlockerFBNewton_STR
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithDiagonalization_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithDiagonalization_STR
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone_STR
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithLocalIteration_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithLocalIteration_STR
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithRegularization_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnConeWithRegularization_STR
SICONOS_FRICTION_3D_NCPGlockerFBPATH_STR = cvar.SICONOS_FRICTION_3D_NCPGlockerFBPATH_STR
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCylinder_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCylinder_STR
SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone_velocity_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_ProjectionOnCone_velocity_STR
SICONOS_FRICTION_3D_ConvexQP_PG_Cylinder_STR = cvar.SICONOS_FRICTION_3D_ConvexQP_PG_Cylinder_STR
SICONOS_FRICTION_3D_VI_FPP_Cylinder_STR = cvar.SICONOS_FRICTION_3D_VI_FPP_Cylinder_STR
SICONOS_FRICTION_3D_DeSaxceFixedPoint_STR = cvar.SICONOS_FRICTION_3D_DeSaxceFixedPoint_STR
SICONOS_FRICTION_3D_GAMS_PATH_STR = cvar.SICONOS_FRICTION_3D_GAMS_PATH_STR
SICONOS_FRICTION_3D_GAMS_PATHVI_STR = cvar.SICONOS_FRICTION_3D_GAMS_PATHVI_STR
SICONOS_FRICTION_3D_GAMS_LCP_PATH_STR = cvar.SICONOS_FRICTION_3D_GAMS_LCP_PATH_STR
SICONOS_FRICTION_3D_GAMS_LCP_PATHVI_STR = cvar.SICONOS_FRICTION_3D_GAMS_LCP_PATHVI_STR
SICONOS_FRICTION_3D_SOCLCP_STR = cvar.SICONOS_FRICTION_3D_SOCLCP_STR
SICONOS_FRICTION_3D_ACLMFP_STR = cvar.SICONOS_FRICTION_3D_ACLMFP_STR
SICONOS_FRICTION_3D_ADMM_STR = cvar.SICONOS_FRICTION_3D_ADMM_STR
SICONOS_GLOBAL_FRICTION_3D_NSGS_WR_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_NSGS_WR_STR
SICONOS_GLOBAL_FRICTION_3D_NSGSV_WR_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_NSGSV_WR_STR
SICONOS_GLOBAL_FRICTION_3D_PROX_WR_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_PROX_WR_STR
SICONOS_GLOBAL_FRICTION_3D_DSFP_WR_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_DSFP_WR_STR
SICONOS_GLOBAL_FRICTION_3D_TFP_WR_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_TFP_WR_STR
SICONOS_GLOBAL_FRICTION_3D_NSGS_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_NSGS_STR
SICONOS_GLOBAL_FRICTION_3D_NSN_AC_WR_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_NSN_AC_WR_STR
SICONOS_GLOBAL_FRICTION_3D_NSN_AC_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_NSN_AC_STR
SICONOS_GLOBAL_FRICTION_3D_GAMS_PATH_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_GAMS_PATH_STR
SICONOS_GLOBAL_FRICTION_3D_GAMS_PATHVI_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_GAMS_PATHVI_STR
SICONOS_GLOBAL_FRICTION_3D_VI_FPP_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_VI_FPP_STR
SICONOS_GLOBAL_FRICTION_3D_VI_EG_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_VI_EG_STR
SICONOS_GLOBAL_FRICTION_3D_ACLMFP_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_ACLMFP_STR
SICONOS_GLOBAL_FRICTION_3D_ADMM_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_ADMM_STR
SICONOS_GLOBAL_FRICTION_3D_ADMM_WR_STR = cvar.SICONOS_GLOBAL_FRICTION_3D_ADMM_WR_STR
SICONOS_FRICTION_3D_ONECONTACT_QUARTIC_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_QUARTIC_STR
SICONOS_FRICTION_3D_ONECONTACT_QUARTIC_NU_STR = cvar.SICONOS_FRICTION_3D_ONECONTACT_QUARTIC_NU_STR
SICONOS_MCP_FB_STR = cvar.SICONOS_MCP_FB_STR
SICONOS_MCP_NEWTON_FBLSA_STR = cvar.SICONOS_MCP_NEWTON_FBLSA_STR
SICONOS_MCP_NEWTON_MINFBLSA_STR = cvar.SICONOS_MCP_NEWTON_MINFBLSA_STR
SICONOS_NCP_NEWTON_FBLSA_STR = cvar.SICONOS_NCP_NEWTON_FBLSA_STR
SICONOS_NCP_NEWTON_MINFBLSA_STR = cvar.SICONOS_NCP_NEWTON_MINFBLSA_STR
SICONOS_NCP_PATHSEARCH_STR = cvar.SICONOS_NCP_PATHSEARCH_STR
SICONOS_NCP_PATH_STR = cvar.SICONOS_NCP_PATH_STR
SICONOS_VI_EG_STR = cvar.SICONOS_VI_EG_STR
SICONOS_VI_FPP_STR = cvar.SICONOS_VI_FPP_STR
SICONOS_VI_HP_STR = cvar.SICONOS_VI_HP_STR
SICONOS_VI_BOX_QI_STR = cvar.SICONOS_VI_BOX_QI_STR
SICONOS_VI_BOX_AVI_LSA_STR = cvar.SICONOS_VI_BOX_AVI_LSA_STR
SICONOS_VI_BOX_PATH_STR = cvar.SICONOS_VI_BOX_PATH_STR

class MixedComplementarityProblem2(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    n1 = property(_numerics.MixedComplementarityProblem2_n1_get, _numerics.MixedComplementarityProblem2_n1_set)
    n2 = property(_numerics.MixedComplementarityProblem2_n2_get, _numerics.MixedComplementarityProblem2_n2_set)
    compute_Fmcp = property(_numerics.MixedComplementarityProblem2_compute_Fmcp_get, _numerics.MixedComplementarityProblem2_compute_Fmcp_set)
    compute_nabla_Fmcp = property(_numerics.MixedComplementarityProblem2_compute_nabla_Fmcp_get, _numerics.MixedComplementarityProblem2_compute_nabla_Fmcp_set)
    nabla_Fmcp = property(_numerics.MixedComplementarityProblem2_nabla_Fmcp_get, _numerics.MixedComplementarityProblem2_nabla_Fmcp_set)
    env = property(_numerics.MixedComplementarityProblem2_env_get, _numerics.MixedComplementarityProblem2_env_set)

    @staticmethod
    def call_compute_F(problem: "void *", n: "int", z: "double *", F: "double *") -> "void":
        return _numerics.MixedComplementarityProblem2_call_compute_F(problem, n, z, F)

    @staticmethod
    def call_compute_nabla_F(problem: "void *", n: "int", z: "double *", nabla_F: "NumericsMatrix") -> "void":
        return _numerics.MixedComplementarityProblem2_call_compute_nabla_F(problem, n, z, nabla_F)

    def __init__(self, *args):
        _numerics.MixedComplementarityProblem2_swiginit(self, _numerics.new_MixedComplementarityProblem2(*args))

    def set_compute_F_and_nabla_F_as_C_functions(self, lib_name: "PyObject *", compute_F_name: "PyObject *", compute_nabla_F_name: "PyObject *") -> "void":
        return _numerics.MixedComplementarityProblem2_set_compute_F_and_nabla_F_as_C_functions(self, lib_name, compute_F_name, compute_nabla_F_name)

    def get_env_as_long(self) -> "PyObject *":
        return _numerics.MixedComplementarityProblem2_get_env_as_long(self)
    __swig_destroy__ = _numerics.delete_MixedComplementarityProblem2

# Register MixedComplementarityProblem2 in _numerics:
_numerics.MixedComplementarityProblem2_swigregister(MixedComplementarityProblem2)

def MixedComplementarityProblem2_call_compute_F(problem: "void *", n: "int", z: "double *", F: "double *") -> "void":
    return _numerics.MixedComplementarityProblem2_call_compute_F(problem, n, z, F)

def MixedComplementarityProblem2_call_compute_nabla_F(problem: "void *", n: "int", z: "double *", nabla_F: "NumericsMatrix") -> "void":
    return _numerics.MixedComplementarityProblem2_call_compute_nabla_F(problem, n, z, nabla_F)


def freeMixedComplementarityProblem(problem: "MCP") -> "void":
    r"""
    freeMixedComplementarityProblem(MixedComplementarityProblem *problem) -> None

    function to delete a MixedComplementarityProblem  

    Parameters
    ----------

    problem :  
        pointer to a MixedComplementarityProblem to delete  

    """
    return _numerics.freeMixedComplementarityProblem(problem)

def freeMCP(mcp: "MixedComplementarityProblem2") -> "void":
    r"""
    freeMCP(MixedComplementarityProblem2 *mcp) -> None

    free an MCP problem  

    Parameters
    ----------

    mcp :  
        structure to free  

    """
    return _numerics.freeMCP(mcp)

def newMCP() -> "MixedComplementarityProblem2 *":
    r"""
    newMCP(None) -> MixedComplementarityProblem2 *

    create an empty MCP problem  

    Returns
    -------
    an MixedComplementarityProblem instance  

    """
    return _numerics.newMCP()

def mcp_driver_init(problem: "MCP", options: "SolverOptions") -> "void":
    r"""
    mcp_driver_init(MixedComplementarityProblem *problem, SolverOptions *options) -> None

    Initialisation of the MCP solver (set problem, allocate working memory and so
    on.  

    This routine must be called before any attempt to run the mcp_driver.  

    Parameters
    ----------

    problem :  
        the description of the MCP  

    options :  
        for the solver  

    """
    return _numerics.mcp_driver_init(problem, options)

def mcp_driver_reset(problem: "MCP", options: "SolverOptions") -> "void":
    r"""
    mcp_driver_reset(MixedComplementarityProblem *problem, SolverOptions *options) -> None

    Reset of the MCP solver.  

    Parameters
    ----------

    problem :  
        the description of the MCP  

    options :  
        for the solver  

    """
    return _numerics.mcp_driver_reset(problem, options)

def mixedComplementarity_setDefaultSolverOptions(problem: "MCP", pOptions: "SolverOptions") -> "int":
    r"""
    mixedComplementarity_setDefaultSolverOptions(MixedComplementarityProblem *problem, SolverOptions *pOptions) -> int

    set the default solver parameters and perform memory allocation for
    MixedLinearComplementarity  

    Parameters
    ----------

    problem :  
        the pointer to the array of options to set.  

    pOptions :  
        the pointer to the SolverOptions stucture.  

    """
    return _numerics.mixedComplementarity_setDefaultSolverOptions(problem, pOptions)

def mixedComplementarity_default_setDefaultSolverOptions(problem: "MCP", pOptions: "SolverOptions") -> "void":
    r"""
    mixedComplementarity_default_setDefaultSolverOptions(MixedComplementarityProblem *problem, SolverOptions *pOptions) -> None

    set the default solver parameters and perform memory allocation for
    MixedLinearComplementarity  

    Parameters
    ----------

    problem :  
        the pointer to the array of options to set.  

    pOptions :  
        the pointer to the SolverOptions stucture.  

    """
    return _numerics.mixedComplementarity_default_setDefaultSolverOptions(problem, pOptions)

def mcp_FischerBurmeister(problem: "MCP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    mcp_FischerBurmeister(MixedComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Fischer Burmeister solver.  

    Parameters
    ----------

    problem :  
        a structure which represents the MCP  

    z :  
        a m+n-vector, initial solution + returns the solution of the problem.  

    w :  
        not used  

    info :  
        termination value: 0 if success else >0.  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mcp_FischerBurmeister(problem, z, w, options)

def mcp_newton_FBLSA(problem: "MixedComplementarityProblem2", z: "double *", Fmcp: "double *", options: "SolverOptions") -> "int *":
    r"""
    mcp_newton_FBLSA(MixedComplementarityProblem2 *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)Fmcp, int *info, SolverOptions *options) -> None

    Solver based on Fischer-Burmeister reformulation and line search (VFBLSA in
    Facchinei--Pang 2003 p.  

    834)  

    Parameters
    ----------

    problem :  
        a structure which represents the MCP  

    z :  
        a n1+n2-vector, initial solution + returns the solution of the problem.  

    Fmcp :  
        n1+n2-vector which contains the value of Fmcp(z) = (G(z), H(z))  

    info :  
        termination value: 0 if success else >0.  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mcp_newton_FBLSA(problem, z, Fmcp, options)

def mcp_newton_minFBLSA(problem: "MixedComplementarityProblem2", z: "double *", Fmcp: "double *", options: "SolverOptions") -> "int *":
    r"""
    mcp_newton_minFBLSA(MixedComplementarityProblem2 *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)Fmcp, int *info, SolverOptions *options) -> None

    Solver based on Fischer-Burmeister reformulation and line search.  

    The descent direction is found using a min reformulation (minFBLSA in Facchinei
    --Pang 2003 p. 855)  

    Parameters
    ----------

    problem :  
        a structure which represents the MCP  

    z :  
        a n1+n2-vector, initial solution + returns the solution of the problem.  

    Fmcp :  
        n1+n2-vector which contains the value of Fmcp(z) = (G(z), H(z))  

    info :  
        termination value: 0 if success else >0.  

    options :  
        structure used to define the solver and its parameters.  

    """
    return _numerics.mcp_newton_minFBLSA(problem, z, Fmcp, options)

def mixedComplementarity_FB_setDefaultSolverOptions(problem: "MCP", pSolver: "SolverOptions") -> "int":
    r"""
    mixedComplementarity_FB_setDefaultSolverOptions(MixedComplementarityProblem *problem, SolverOptions *pSolver) -> int

    set the default solver parameters and perform memory allocation for
    MixedLinearComplementarity  

    Parameters
    ----------

    problem :  
        the pointer to the array of options to set.  

    pSolver :  
        the pointer to the SolverOptions stucture.  

    """
    return _numerics.mixedComplementarity_FB_setDefaultSolverOptions(problem, pSolver)
class NCP(object):
    r"""

    The structure that defines a Nonlinear Complementarity Problem (NCP) : Find two
    vectors FORMULA112_ such that:  

    FORMULA113_  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_NCP_NonlinearComplementarityProblem.h`.


    Attributes
    ----------
     compute_F : `ptrFunctionNCP`  
        pointer to the function used to compute FORMULA114_  

     compute_nabla_F : `ptrFunctionJacNCP`  
        pointer to the function used to compute FORMULA115_  

     env : `None *`  
        environment for the compute_Fmcp and compute_nabla_F function.  

        When called from Python, it contains an object with compute_F and
        compute_nabla_F as methods. When called from C, it can reference a data
        struct containing variables needed for the computations.  

     n : ``  
        size of the problem  

     nabla_F : `NumericsMatrix *`  
        storage for FORMULA116_  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    n = property(_numerics.NCP_n_get, _numerics.NCP_n_set)
    compute_F = property(_numerics.NCP_compute_F_get, _numerics.NCP_compute_F_set)
    compute_nabla_F = property(_numerics.NCP_compute_nabla_F_get, _numerics.NCP_compute_nabla_F_set)
    nabla_F = property(_numerics.NCP_nabla_F_get, _numerics.NCP_nabla_F_set)
    env = property(_numerics.NCP_env_get, _numerics.NCP_env_set)

    @staticmethod
    def call_compute_F(problem: "void *", n: "int", z: "double *", F: "double *") -> "void":
        return _numerics.NCP_call_compute_F(problem, n, z, F)

    @staticmethod
    def call_compute_nabla_F(problem: "void *", n: "int", z: "double *", nabla_F: "NumericsMatrix") -> "void":
        return _numerics.NCP_call_compute_nabla_F(problem, n, z, nabla_F)

    def __init__(self, *args):
        r"""

        The structure that defines a Nonlinear Complementarity Problem (NCP) : Find two
        vectors FORMULA112_ such that:  

        FORMULA113_  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_NCP_NonlinearComplementarityProblem.h`.


        Attributes
        ----------
         compute_F : `ptrFunctionNCP`  
            pointer to the function used to compute FORMULA114_  

         compute_nabla_F : `ptrFunctionJacNCP`  
            pointer to the function used to compute FORMULA115_  

         env : `None *`  
            environment for the compute_Fmcp and compute_nabla_F function.  

            When called from Python, it contains an object with compute_F and
            compute_nabla_F as methods. When called from C, it can reference a data
            struct containing variables needed for the computations.  

         n : ``  
            size of the problem  

         nabla_F : `NumericsMatrix *`  
            storage for FORMULA116_  

        """
        _numerics.NCP_swiginit(self, _numerics.new_NCP(*args))

    def set_compute_F_and_nabla_F_as_C_functions(self, lib_name: "PyObject *", compute_F_name: "PyObject *", compute_nabla_F_name: "PyObject *") -> "void":
        return _numerics.NCP_set_compute_F_and_nabla_F_as_C_functions(self, lib_name, compute_F_name, compute_nabla_F_name)

    def get_env_as_long(self) -> "PyObject *":
        return _numerics.NCP_get_env_as_long(self)
    __swig_destroy__ = _numerics.delete_NCP

# Register NCP in _numerics:
_numerics.NCP_swigregister(NCP)

def NCP_call_compute_F(problem: "void *", n: "int", z: "double *", F: "double *") -> "void":
    return _numerics.NCP_call_compute_F(problem, n, z, F)

def NCP_call_compute_nabla_F(problem: "void *", n: "int", z: "double *", nabla_F: "NumericsMatrix") -> "void":
    return _numerics.NCP_call_compute_nabla_F(problem, n, z, nabla_F)


def freeNCP(ncp: "NCP") -> "void":
    r"""
    freeNCP(NonlinearComplementarityProblem *ncp) -> None

    free an NCP problem  

    Parameters
    ----------

    ncp :  
        structure to free  

    """
    return _numerics.freeNCP(ncp)

def newNCP() -> "NonlinearComplementarityProblem *":
    r"""
    newNCP(None) -> NonlinearComplementarityProblem *

    create an empty NCP problem  

    Returns
    -------
    an MixedComplementarityProblem instance  

    """
    return _numerics.newNCP()

def ncp_compute_error(n: "int", z: "double *", F: "double *", tol: "double", err: "double *") -> "int":
    r"""
    ncp_compute_error(int n, array_like (np.float64, 1D)z, array_like (np.float64, 1D)F, double tol, array_like (np.float64, 1D)err) -> int

    This function compute the complementarity error of the NCP: FORMULA82_.  

    Parameters
    ----------

    n :  
        size of the vectors  

    z :  
        solution  

    F :  
        value of the function at the solution  

    tol :  
        tolerance for the error  

    err :  
        value of the error  

    Returns
    -------
    0 if the solution is good enough, 1 otherwise  

    """
    return _numerics.ncp_compute_error(n, z, F, tol, err)

def ncp_newton_FBLSA(problem: "NCP", z: "double *", F: "double *", options: "SolverOptions") -> "int *":
    r"""
    ncp_newton_FBLSA(NonlinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)F, int *info, SolverOptions *options) -> None

    NCP Solver using the FB merit function and a Newton-based method with line-
    search.  

    Parameters
    ----------

    problem :  
        the formalization of the NCP problem  

    z :  
        on input, initial guess; on output the solution  

    F :  
        the value of the function at the solution  

    info :  
        0 if everything worked  

    options :  
        struct used to specify the solver parameters  

    """
    return _numerics.ncp_newton_FBLSA(problem, z, F, options)

def ncp_newton_minFBLSA(problem: "NCP", z: "double *", F: "double *", options: "SolverOptions") -> "int *":
    r"""
    ncp_newton_minFBLSA(NonlinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)F, int *info, SolverOptions *options) -> None

    NCP Solver using the min merit function (+ the FB as backup) and a Newton-based
    method with line-search.  

    Parameters
    ----------

    problem :  
        the formalization of the NCP problem  

    z :  
        on input, initial guess; on output the solution  

    F :  
        the value of the function at the solution  

    info :  
        0 if everything worked  

    options :  
        struct used to specify the solver parameters  

    """
    return _numerics.ncp_newton_minFBLSA(problem, z, F, options)

def ncp_pathsearch(problem: "NCP", z: "double *", F: "double *", options: "SolverOptions") -> "int *":
    r"""
    ncp_pathsearch(NonlinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)F, int *info, SolverOptions *options) -> None

    NCP Solver using a path search algorithm, following the work of D.  

    Ralph. M. Ferris, and many other collaborators of the latter.  

    Parameters
    ----------

    problem :  
        the formalization of the NCP problem  

    z :  
        on input, initial guess; on output the solution  

    F :  
        the value of the function at the solution  

    info :  
        0 if everything worked  

    options :  
        struct used to specify the solver parameters  

    """
    return _numerics.ncp_pathsearch(problem, z, F, options)

def ncp_path(problem: "NCP", z: "double *", F: "double *", options: "SolverOptions") -> "int *":
    r"""
    ncp_path(NonlinearComplementarityProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)F, int *info, SolverOptions *options) -> None

    NCP Solver using the PATH solver.  

    Parameters
    ----------

    problem :  
        the formalization of the NCP problem  

    z :  
        on input, initial guess; on output the solution  

    F :  
        the value of the function at the solution  

    info :  
        0 if everything worked  

    options :  
        struct used to specify the solver parameters  

    """
    return _numerics.ncp_path(problem, z, F, options)
class VI(object):
    r"""

    Attributes
    ----------
     compute_nabla_F : `ptrFunctionVI_nabla`  
        Function to compute the jacobian of F.  

     env : `None *`  
        pointer onto env object (which is self is the simplest case)  

     F : `ptrFunctionVI`  
        Function of the VI.  

     istheNormVIset : `int`  
        Boolean to know if the norm is set If not (istheNormVIset=0) it will be
        computed in the first call of variationalInequality_computeError By default,
        set istheNormVIset =0.  

     nabla_F : `NumericsMatrix *`  
        storage for FORMULA44_  

     normVI : `double`  
        Norm of the VI problem to compute relative solution.  

     ProjectionOnX : `None(*`  
        Projection on X of the VI.  

     set : `None *`  
        opaque struct that represent the set K (possibly empty)  

     size : `int`  
        size of the VI FORMULA45_  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    size = property(_numerics.VI_size_get, _numerics.VI_size_set)
    env = property(_numerics.VI_env_get, _numerics.VI_env_set)
    F = property(_numerics.VI_F_get, _numerics.VI_F_set)
    compute_nabla_F = property(_numerics.VI_compute_nabla_F_get, _numerics.VI_compute_nabla_F_set)
    ProjectionOnX = property(_numerics.VI_ProjectionOnX_get, _numerics.VI_ProjectionOnX_set)
    normVI = property(_numerics.VI_normVI_get, _numerics.VI_normVI_set)
    istheNormVIset = property(_numerics.VI_istheNormVIset_get, _numerics.VI_istheNormVIset_set)
    set = property(_numerics.VI_set_get, _numerics.VI_set_set)
    nabla_F = property(_numerics.VI_nabla_F_get, _numerics.VI_nabla_F_set)

    @staticmethod
    def call_compute_F(problem: "void *", n: "int", z: "double *", F: "double *") -> "void":
        return _numerics.VI_call_compute_F(problem, n, z, F)

    @staticmethod
    def call_compute_nabla_F(problem: "void *", n: "int", z: "double *", nabla_F: "NumericsMatrix") -> "void":
        return _numerics.VI_call_compute_nabla_F(problem, n, z, nabla_F)

    def __init__(self, *args):
        r"""

        Attributes
        ----------
         compute_nabla_F : `ptrFunctionVI_nabla`  
            Function to compute the jacobian of F.  

         env : `None *`  
            pointer onto env object (which is self is the simplest case)  

         F : `ptrFunctionVI`  
            Function of the VI.  

         istheNormVIset : `int`  
            Boolean to know if the norm is set If not (istheNormVIset=0) it will be
            computed in the first call of variationalInequality_computeError By default,
            set istheNormVIset =0.  

         nabla_F : `NumericsMatrix *`  
            storage for FORMULA44_  

         normVI : `double`  
            Norm of the VI problem to compute relative solution.  

         ProjectionOnX : `None(*`  
            Projection on X of the VI.  

         set : `None *`  
            opaque struct that represent the set K (possibly empty)  

         size : `int`  
            size of the VI FORMULA45_  

        """
        _numerics.VI_swiginit(self, _numerics.new_VI(*args))

    def set_compute_nabla_F(self, compute_nabla_F: "PyObject *") -> "void":
        return _numerics.VI_set_compute_nabla_F(self, compute_nabla_F)

    def set_box_constraints(self, box_lower_bound: "PyObject *", box_upper_bound: "PyObject *") -> "void":
        return _numerics.VI_set_box_constraints(self, box_lower_bound, box_upper_bound)

    def set_compute_F_and_nabla_F_as_C_functions(self, lib_name: "PyObject *", compute_F_name: "PyObject *", compute_nabla_F_name: "PyObject *") -> "void":
        return _numerics.VI_set_compute_F_and_nabla_F_as_C_functions(self, lib_name, compute_F_name, compute_nabla_F_name)

    def get_env_as_long(self) -> "PyObject *":
        return _numerics.VI_get_env_as_long(self)
    __swig_destroy__ = _numerics.delete_VI

# Register VI in _numerics:
_numerics.VI_swigregister(VI)

def VI_call_compute_F(problem: "void *", n: "int", z: "double *", F: "double *") -> "void":
    return _numerics.VI_call_compute_F(problem, n, z, F)

def VI_call_compute_nabla_F(problem: "void *", n: "int", z: "double *", nabla_F: "NumericsMatrix") -> "void":
    return _numerics.VI_call_compute_nabla_F(problem, n, z, nabla_F)


def variationalInequality_display(vi: "VI") -> "void":
    r"""
    variationalInequality_display(VariationalInequality *vi) -> None

    display a VariationalInequalityProblem  

    Parameters
    ----------

    vi :  
        the problem to display  

    """
    return _numerics.variationalInequality_display(vi)

def variationalInequality_printInFile(vi: "VI", file: "FILE *") -> "int":
    r"""
    variationalInequality_printInFile(VariationalInequality *vi, FILE *file) -> int

    print a VariationalInequalityProblem in a file (numerics .dat format)  

    Parameters
    ----------

    vi :  
        the problem to print out  

    file :  
        the dest file  

    Returns
    -------
    ok if successfull  

    """
    return _numerics.variationalInequality_printInFile(vi, file)

def variationalInequality_newFromFile(vi: "VI", file: "FILE *") -> "int":
    r"""
    variationalInequality_newFromFile(VariationalInequality *vi, FILE *file) -> int

    read a VariationalInequalityProblem in a file (numerics .dat format)  

    Parameters
    ----------

    vi :  
        the problem to read  

    file :  
        the target file  

    Returns
    -------
    ok if successfull  

    """
    return _numerics.variationalInequality_newFromFile(vi, file)

def freeVariationalInequalityProblem(vi: "VI") -> "void":
    r"""
    freeVariationalInequalityProblem(VariationalInequality *vi) -> None

    free a VariationalInequalityProblem  

    Parameters
    ----------

    vi :  
        the problem to free  

    """
    return _numerics.freeVariationalInequalityProblem(vi)

def variationalInequality_clear(vi: "VI") -> "void":
    r"""
    variationalInequality_clear(VariationalInequality *vi) -> None

    Clear VariationalInequality structure: set all pointeurs to NULL, double and int
    to 0.  

    Parameters
    ----------

    vi :  
        the problem to clear  

    """
    return _numerics.variationalInequality_clear(vi)

def variationalInequality_new(size: "int") -> "VariationalInequality *":
    r"""
    variationalInequality_new(int size) -> VariationalInequality *

    new VariationalInequality problem  

    Parameters
    ----------

    size :  
        size of the ambient space for the VI  

    Returns
    -------
    a initialized VariationalInequality struct  

    """
    return _numerics.variationalInequality_new(size)

def newVI() -> "VariationalInequality *":
    r"""
    newVI(None) -> VariationalInequality *

    new VariationalInequality problem  

    Returns
    -------
    an empty VI  

    """
    return _numerics.newVI()

def VI_get_env(vi: "void *") -> "void *":
    r"""
    VI_get_env(None *vi) -> None *

    get the environment from the struct  

    Parameters
    ----------

    vi :  
        a VariationalInequality problem  

    Returns
    -------
    the environment from the struct  

    """
    return _numerics.VI_get_env(vi)

def variationalInequality_setDefaultSolverOptions(options: "SolverOptions", solverId: "int") -> "int":
    r"""
    variationalInequality_setDefaultSolverOptions(SolverOptions *options, int solverId) -> int

    set the default solver parameters and perform memory allocation for
    VariationalInequality  

    Parameters
    ----------

    options :  
        the pointer to the options to set  

    solverId :  
        the identifier of the solver  

    """
    return _numerics.variationalInequality_setDefaultSolverOptions(options, solverId)

def variationalInequality_ExtraGradient(problem: "VI", x: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    variationalInequality_ExtraGradient(VariationalInequality *problem, array_like (np.float64, 1D)x, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Extra Gradient solver forvariational inequality problem based on the De Saxce
    Formulation.  

    Parameters
    ----------

    problem :  
        the variational inequality problem to solve  

    x :  
        global vector (n), in-out parameter  

    w :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number iparam[1] : Choice
        of the line search 0 : Armijo rule with Khotbotov ratio (default) 1 : Armijo
        rule with Solodov.Tseng ratio iparam[2] : bool activate the update in the
        loop (0:false default choice) iparam[3] : use rho_k * tau *
        min(1.0,a2/(rho_k*a1)) to decrease rho; commented in the code  

    dparam[3] : rho parameter. If rho >0, then self-adaptive (Armijo like)
    procedure. If rho <0, then constant rho parameter (rho <-- -rho) Adaptive step-
    size parameters: Adaptive step-size parameters: dparam[4] = 2/3.0; tau dparam[5]
    = 3.0/2.0; tauinv dparam[6] = 0.9; L dparam[7] = 0.3; Lmin  

    """
    return _numerics.variationalInequality_ExtraGradient(problem, x, w, options)

def variationalInequality_ExtraGradient_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    variationalInequality_ExtraGradient_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for EG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.variationalInequality_ExtraGradient_setDefaultSolverOptions(options)

def variationalInequality_FixedPointProjection(problem: "VI", x: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    variationalInequality_FixedPointProjection(VariationalInequality *problem, array_like (np.float64, 1D)x, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Fixed Point Projection solver for variational inequality problem based on the De
    Saxce Formulation.  

    Parameters
    ----------

    problem :  
        the variational inequality problem to solve  

    x :  
        global vector (n), in-out parameter  

    w :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number iparam[1] : Choice
        of the line search 0 : Armijo rule with Khotbotov ratio (default) 1 : Armijo
        rule with Solodov.Tseng ratio 2 : Armijo rule with Han.Sun ratio iparam[2] :
        bool activate the update in the loop (0:false default choice) iparam[3] :
        use rho_k * tau * min(1.0,a2/(rho_k*a1)) to decrease rho; commented in the
        code dparam[3] : rho parameter. If rho >0, then self-adaptive (Armijo like)
        procedure. If rho <0, then constant rho parameter (rho <-- -rho) Adaptive
        step-size parameters: dparam[4] = 2/3.0; tau dparam[5] = 3.0/2.0; tauinv
        dparam[6] = 0.9; L dparam[7] = 0.3; Lmin  

    """
    return _numerics.variationalInequality_FixedPointProjection(problem, x, w, options)

def variationalInequality_FixedPointProjection_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    variationalInequality_FixedPointProjection_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for EG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.variationalInequality_FixedPointProjection_setDefaultSolverOptions(options)

def variationalInequality_HyperplaneProjection(problem: "VI", x: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    variationalInequality_HyperplaneProjection(VariationalInequality *problem, array_like (np.float64, 1D)x, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Hyperplane Projection solver for variational inequality problem based on the De
    Saxce Formulation.  

    Parameters
    ----------

    problem :  
        the variational inequality problem to solve  

    x :  
        global vector (n), in-out parameter  

    w :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho >0  

    """
    return _numerics.variationalInequality_HyperplaneProjection(problem, x, w, options)

def variationalInequality_HyperplaneProjection_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    variationalInequality_HyperplaneProjection_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for EG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.variationalInequality_HyperplaneProjection_setDefaultSolverOptions(options)

def variationalInequality_box_newton_QiLSA(problem: "VI", x: "double *", F: "double *", options: "SolverOptions") -> "int *":
    r"""
    variationalInequality_box_newton_QiLSA(VariationalInequality *problem, array_like (np.float64, 1D)x, array_like (np.float64, 1D)F, int *info, SolverOptions *options) -> None

    VI Solver based on a merit function minimization with a line-search type
    algorithm.  

    Parameters
    ----------

    problem :  
        the variational inequality problem to solve  

    x :  
        as input, the initial guess; as output the solution if the algorithm is
        successful  

    F :  
        value of the function  

    info :  
        0 if a solution is found  

    options :  
        the solver options  

    """
    return _numerics.variationalInequality_box_newton_QiLSA(problem, x, F, options)

def vi_box_AVI_LSA(problem: "VI", x: "double *", F: "double *", options: "SolverOptions") -> "int *":
    r"""
    vi_box_AVI_LSA(VariationalInequality *problem, array_like (np.float64, 1D)x, array_like (np.float64, 1D)F, int *info, SolverOptions *options) -> None

    VI Solver based on the Newton-Josephy method globalized with a line-search type
    algorithm using the Qi merit function.  

    Parameters
    ----------

    problem :  
        the variational inequality problem to solve  

    x :  
        as input, the initial guess; as output the solution if the algorithm is
        successful  

    F :  
        value of the function  

    info :  
        0 if a solution is found  

    options :  
        the solver options  

    """
    return _numerics.vi_box_AVI_LSA(problem, x, F, options)

def vi_box_AVI_extra_SolverOptions(options: "SolverOptions") -> "void":
    r"""
    vi_box_AVI_extra_SolverOptions(SolverOptions *options) -> None

    Extra SolverOptions settings.  

    Parameters
    ----------

    options :  
        the struct to modify  

    """
    return _numerics.vi_box_AVI_extra_SolverOptions(options)

def vi_box_AVI_free_solverData(options: "SolverOptions") -> "void":
    r"""
    vi_box_AVI_free_solverData(SolverOptions *options) -> None

    free the specific solverData  

    Parameters
    ----------

    options :  
        the struct to modify  

    """
    return _numerics.vi_box_AVI_free_solverData(options)

def vi_get_set(problem: "void *") -> "void *":
    r"""
    vi_get_set(None *problem) -> None *

    Get the set from the VariationalInequality.  

    Parameters
    ----------

    problem :  
        the VI  

    """
    return _numerics.vi_get_set(problem)

def vi_box_path(problem: "VI", z: "double *", F: "double *", options: "SolverOptions") -> "int *":
    r"""
    vi_box_path(VariationalInequality *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)F, int *info, SolverOptions *options) -> None

    Solver for box constrainted VI using PATH.  

    Parameters
    ----------

    problem :  
        the variational inequality problem to solve  

    z :  
        as input, the initial guess; as output the solution if the algorithm is
        successful  

    F :  
        value of the function  

    info :  
        0 if a solution is found  

    options :  
        the solver options  

    """
    return _numerics.vi_box_path(problem, z, F, options)

def variationalInequality_common_setDefaultSolverOptions(options: "SolverOptions", solverId: "int") -> "int":
    r"""
    variationalInequality_common_setDefaultSolverOptions(SolverOptions *options, int solverId) -> int

    set the default solver parameters and perform memory allocation for a VI solver  

    Parameters
    ----------

    options :  
        the SolverOptions to set  

    solverId :  
        the id of the solver  

    """
    return _numerics.variationalInequality_common_setDefaultSolverOptions(options, solverId)

def checkTrivialCase_vi(problem: "VI", x: "double *", fx: "double *", options: "SolverOptions") -> "int":
    r"""
    checkTrivialCase_vi(VariationalInequality *problem, array_like (np.float64, 1D)x, array_like (np.float64, 1D)fx, SolverOptions *options) -> int

    Check for trivial solution in the variational inequality problem.  

    Parameters
    ----------

    problem :  
        VariationalInequality* the problem  

    x :  
        global vector (n), in-out parameter  

    fx :  
        global vector (n), in-out parameters  

    options :  
        the pointer to the array of options to set  

    Returns
    -------
    info =0 if a trivial solution has been found, else = -1  

    """
    return _numerics.checkTrivialCase_vi(problem, x, fx, options)
class ConvexQP(object):
    r"""

    Attributes
    ----------
     A : `NumericsMatrix *`  
        Matrix A that defines the constraints.  

        If it is NULL, we assume that A is the identity matrix  

     b : `array_like (np.float64, 1D)`  
        vector b that defines the constant term in the constraints.  

     env : `None *`  
        pointer onto env object (which is self is the simplest case)  

     istheNormConvexQPset : `int`  
        Boolean to know if the norm is set If not (istheNormConvexQPset=0) it will
        be computed in the first call of convexQP_compute_error By default, set
        istheNormConvexQPset =0.  

     m : `int`  
        m FORMULA2_  

     M : `NumericsMatrix *`  
        Matrix M that defines the quadratic term in the cost function.  

     normConvexQP : `double`  
        Norm of the problem to compute relative solution.  

     ProjectionOnC : `None(*`  
        Projection on C  

     q : `array_like (np.float64, 1D)`  
        vector q that defines the linear term in the cost function.  

     set : `None *`  
        opaque struct that represent the set C (possibly empty)  

     size : `int`  
        size FORMULA3_  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    size = property(_numerics.ConvexQP_size_get, _numerics.ConvexQP_size_set)
    m = property(_numerics.ConvexQP_m_get, _numerics.ConvexQP_m_set)
    env = property(_numerics.ConvexQP_env_get, _numerics.ConvexQP_env_set)
    M = property(_numerics.ConvexQP_M_get, _numerics.ConvexQP_M_set)
    q = property(_numerics.ConvexQP_q_get, _numerics.ConvexQP_q_set)
    A = property(_numerics.ConvexQP_A_get, _numerics.ConvexQP_A_set)
    b = property(_numerics.ConvexQP_b_get, _numerics.ConvexQP_b_set)
    ProjectionOnC = property(_numerics.ConvexQP_ProjectionOnC_get, _numerics.ConvexQP_ProjectionOnC_set)
    normConvexQP = property(_numerics.ConvexQP_normConvexQP_get, _numerics.ConvexQP_normConvexQP_set)
    istheNormConvexQPset = property(_numerics.ConvexQP_istheNormConvexQPset_get, _numerics.ConvexQP_istheNormConvexQPset_set)
    set = property(_numerics.ConvexQP_set_get, _numerics.ConvexQP_set_set)

    def __init__(self):
        r"""

        Attributes
        ----------
         A : `NumericsMatrix *`  
            Matrix A that defines the constraints.  

            If it is NULL, we assume that A is the identity matrix  

         b : `array_like (np.float64, 1D)`  
            vector b that defines the constant term in the constraints.  

         env : `None *`  
            pointer onto env object (which is self is the simplest case)  

         istheNormConvexQPset : `int`  
            Boolean to know if the norm is set If not (istheNormConvexQPset=0) it will
            be computed in the first call of convexQP_compute_error By default, set
            istheNormConvexQPset =0.  

         m : `int`  
            m FORMULA2_  

         M : `NumericsMatrix *`  
            Matrix M that defines the quadratic term in the cost function.  

         normConvexQP : `double`  
            Norm of the problem to compute relative solution.  

         ProjectionOnC : `None(*`  
            Projection on C  

         q : `array_like (np.float64, 1D)`  
            vector q that defines the linear term in the cost function.  

         set : `None *`  
            opaque struct that represent the set C (possibly empty)  

         size : `int`  
            size FORMULA3_  

        """
        _numerics.ConvexQP_swiginit(self, _numerics.new_ConvexQP())
    __swig_destroy__ = _numerics.delete_ConvexQP

# Register ConvexQP in _numerics:
_numerics.ConvexQP_swigregister(ConvexQP)


def convexQP_display(cqp: "ConvexQP") -> "void":
    r"""
    convexQP_display(ConvexQP *cqp) -> None

    display a ConvexQPProblem  

    Parameters
    ----------

    cqp :  
        the problem to display  

    """
    return _numerics.convexQP_display(cqp)

def convexQP_printInFile(cqp: "ConvexQP", file: "FILE *") -> "int":
    r"""
    convexQP_printInFile(ConvexQP *cqp, FILE *file) -> int

    print a ConvexQPProblem in a file (numerics .dat format)  

    Parameters
    ----------

    cqp :  
        the problem to print out  

    file :  
        the dest file  

    Returns
    -------
    ok if successfull  

    """
    return _numerics.convexQP_printInFile(cqp, file)

def convexQP_newFromFile(cqp: "ConvexQP", file: "FILE *") -> "int":
    r"""
    convexQP_newFromFile(ConvexQP *cqp, FILE *file) -> int

    read a ConvexQPProblem in a file (numerics .dat format)  

    Parameters
    ----------

    cqp :  
        the problem to read  

    file :  
        the target file  

    Returns
    -------
    ok if successfull  

    """
    return _numerics.convexQP_newFromFile(cqp, file)

def convexQP_free(cqp: "ConvexQP") -> "void":
    r"""
    convexQP_free(ConvexQP *cqp) -> None

    free a ConvexQPProblem  

    Parameters
    ----------

    cqp :  
        the problem to free  

    """
    return _numerics.convexQP_free(cqp)

def convexQP_clear(cqp: "ConvexQP") -> "void":
    r"""
    convexQP_clear(ConvexQP *cqp) -> None

    Clear ConvexQP structure: set all pointeurs to NULL, double and int to 0.  

    Parameters
    ----------

    cqp :  
        the problem to clear  

    """
    return _numerics.convexQP_clear(cqp)

def convexQP_new(size: "int") -> "ConvexQP *":
    r"""
    convexQP_new(int size) -> ConvexQP *

    new ConvexQP problem  

    Parameters
    ----------

    size :  
        size of the ambient space for the CQP  

    Returns
    -------
    a initialized ConvexQP struct  

    """
    return _numerics.convexQP_new(size)

def convexQP_get_env(cqp: "void *") -> "void *":
    r"""
    convexQP_get_env(None *cqp) -> None *

    get the environment from the struct  

    Parameters
    ----------

    cqp :  
        a ConvexQP problem  

    Returns
    -------
    the environment from the struct  

    """
    return _numerics.convexQP_get_env(cqp)

def convexQP_ProjectedGradient(problem: "ConvexQP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    convexQP_ProjectedGradient(ConvexQP *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    Projected Gradient solver for Convex QP problem.  

    Parameters
    ----------

    problem :  
        the variational inequality problem to solve  

    z :  
        global vector (n), in-out parameter  

    w :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number  

    dparam[3] : rho parameter. If rho >0, then self-adaptive (Armijo like)
    procedure. If rho <0, then constant rho parameter (rho <-- -rho) Adaptive step-
    size parameters: Adaptive step-size parameters: dparam[4] = 2/3.0; tau dparam[5]
    = 3.0/2.0; tauinv dparam[6] = 0.9; L dparam[7] = 0.3; Lmin  

    """
    return _numerics.convexQP_ProjectedGradient(problem, z, w, options)

def convexQP_ProjectedGradient_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    convexQP_ProjectedGradient_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for PG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.convexQP_ProjectedGradient_setDefaultSolverOptions(options)

def convexQP_VI_solver(problem: "ConvexQP", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    convexQP_VI_solver(ConvexQP *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    """
    return _numerics.convexQP_VI_solver(problem, z, w, options)

def convexQP_VI_solver_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    convexQP_VI_solver_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.convexQP_VI_solver_setDefaultSolverOptions(options)

def convexQP_ADMM(problem: "ConvexQP", z: "double *", w: "double *", xi: "double *", u: "double *", options: "SolverOptions") -> "int *":
    r"""
    convexQP_ADMM(ConvexQP *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, array_like (np.float64, 1D)xi, array_like (np.float64, 1D)u, int *info, SolverOptions *options) -> None

    """
    return _numerics.convexQP_ADMM(problem, z, w, xi, u, options)

def convexQP_ADMM_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    convexQP_ADMM_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for PG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.convexQP_ADMM_setDefaultSolverOptions(options)

def convexQP_ADMM_init(problem: "ConvexQP", options: "SolverOptions") -> "void":
    r"""
    convexQP_ADMM_init(ConvexQP *problem, SolverOptions *options) -> None

    """
    return _numerics.convexQP_ADMM_init(problem, options)

def convexQP_ADMM_free(problem: "ConvexQP", options: "SolverOptions") -> "void":
    r"""
    convexQP_ADMM_free(ConvexQP *problem, SolverOptions *options) -> None

    """
    return _numerics.convexQP_ADMM_free(problem, options)
SICONOS_CONVEXQP_PG = _numerics.SICONOS_CONVEXQP_PG
SICONOS_CONVEXQP_VI_FPP = _numerics.SICONOS_CONVEXQP_VI_FPP
SICONOS_CONVEXQP_VI_EG = _numerics.SICONOS_CONVEXQP_VI_EG
SICONOS_CONVEXQP_ADMM = _numerics.SICONOS_CONVEXQP_ADMM
SICONOS_CONVEXQP_PGOC_LINESEARCH_MAXITER = _numerics.SICONOS_CONVEXQP_PGOC_LINESEARCH_MAXITER
SICONOS_CONVEXQP_PGOC_RHO = _numerics.SICONOS_CONVEXQP_PGOC_RHO
SICONOS_CONVEXQP_PGOC_RHOMIN = _numerics.SICONOS_CONVEXQP_PGOC_RHOMIN
SICONOS_CONVEXQP_PGOC_LINESEARCH_MU = _numerics.SICONOS_CONVEXQP_PGOC_LINESEARCH_MU
SICONOS_CONVEXQP_PGOC_LINESEARCH_TAU = _numerics.SICONOS_CONVEXQP_PGOC_LINESEARCH_TAU
SICONOS_CONVEXQP_ADMM_IPARAM_RHO_STRATEGY = _numerics.SICONOS_CONVEXQP_ADMM_IPARAM_RHO_STRATEGY
SICONOS_CONVEXQP_ADMM_IPARAM_ACCELERATION = _numerics.SICONOS_CONVEXQP_ADMM_IPARAM_ACCELERATION
SICONOS_CONVEXQP_ADMM_RHO = _numerics.SICONOS_CONVEXQP_ADMM_RHO
SICONOS_CONVEXQP_ADMM_RESTART_ETA = _numerics.SICONOS_CONVEXQP_ADMM_RESTART_ETA
SICONOS_CONVEXQP_ADMM_NO_ACCELERATION = _numerics.SICONOS_CONVEXQP_ADMM_NO_ACCELERATION
SICONOS_CONVEXQP_ADMM_ACCELERATION = _numerics.SICONOS_CONVEXQP_ADMM_ACCELERATION
SICONOS_CONVEXQP_ADMM_ACCELERATION_AND_RESTART = _numerics.SICONOS_CONVEXQP_ADMM_ACCELERATION_AND_RESTART
SICONOS_CONVEXQP_RHO_STRATEGY_CONSTANT = _numerics.SICONOS_CONVEXQP_RHO_STRATEGY_CONSTANT
SICONOS_CONVEXQP_RHO_STRATEGY_ADAPTIVE = _numerics.SICONOS_CONVEXQP_RHO_STRATEGY_ADAPTIVE
class SecondOrderConeLinearComplementarityProblem(object):
    r"""

    The structure that defines a Second Order Cone Linear Complementarity Problem.  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_SOCP_SecondOrderConeLinearComplementarityProblem.h`.


    Attributes
    ----------
     coneIndex : ` int *`  
        FORMULA27_, vector of indices of the cones ( FORMULA28_ nc)  

     M : `NumericsMatrix *`  
        FORMULA29_, a matrix with FORMULA30_ stored in NumericsMatrix structure  

     n : `int`  
        the problem dimension.  

        must be equal to FORMULA31_  

     nc : `int`  
        the number of cones FORMULA32_ in the Cartesian product  

     q : `array_like (np.float64, 1D)`  
        FORMULA33_  

     tau : `array_like (np.float64, 1D)`  
        FORMULA34_, vector of coefficients ( FORMULA35_ nc)  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    n = property(_numerics.SecondOrderConeLinearComplementarityProblem_n_get, _numerics.SecondOrderConeLinearComplementarityProblem_n_set)
    nc = property(_numerics.SecondOrderConeLinearComplementarityProblem_nc_get, _numerics.SecondOrderConeLinearComplementarityProblem_nc_set)
    M = property(_numerics.SecondOrderConeLinearComplementarityProblem_M_get, _numerics.SecondOrderConeLinearComplementarityProblem_M_set)
    q = property(_numerics.SecondOrderConeLinearComplementarityProblem_q_get, _numerics.SecondOrderConeLinearComplementarityProblem_q_set)
    coneIndex = property(_numerics.SecondOrderConeLinearComplementarityProblem_coneIndex_get, _numerics.SecondOrderConeLinearComplementarityProblem_coneIndex_set)
    tau = property(_numerics.SecondOrderConeLinearComplementarityProblem_tau_get, _numerics.SecondOrderConeLinearComplementarityProblem_tau_set)

    def __init__(self):
        r"""

        The structure that defines a Second Order Cone Linear Complementarity Problem.  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_SOCP_SecondOrderConeLinearComplementarityProblem.h`.


        Attributes
        ----------
         coneIndex : ` int *`  
            FORMULA27_, vector of indices of the cones ( FORMULA28_ nc)  

         M : `NumericsMatrix *`  
            FORMULA29_, a matrix with FORMULA30_ stored in NumericsMatrix structure  

         n : `int`  
            the problem dimension.  

            must be equal to FORMULA31_  

         nc : `int`  
            the number of cones FORMULA32_ in the Cartesian product  

         q : `array_like (np.float64, 1D)`  
            FORMULA33_  

         tau : `array_like (np.float64, 1D)`  
            FORMULA34_, vector of coefficients ( FORMULA35_ nc)  

        """
        _numerics.SecondOrderConeLinearComplementarityProblem_swiginit(self, _numerics.new_SecondOrderConeLinearComplementarityProblem())
    __swig_destroy__ = _numerics.delete_SecondOrderConeLinearComplementarityProblem

# Register SecondOrderConeLinearComplementarityProblem in _numerics:
_numerics.SecondOrderConeLinearComplementarityProblem_swigregister(SecondOrderConeLinearComplementarityProblem)
SICONOS_CONVEXQP_PG_STR = cvar.SICONOS_CONVEXQP_PG_STR
SICONOS_CONVEXQP_VI_FPP_STR = cvar.SICONOS_CONVEXQP_VI_FPP_STR
SICONOS_CONVEXQP_VI_EG_STR = cvar.SICONOS_CONVEXQP_VI_EG_STR
SICONOS_CONVEXQP_ADMM_STR = cvar.SICONOS_CONVEXQP_ADMM_STR


def secondOrderConeLinearComplementarityProblem_display(problem: "SecondOrderConeLinearComplementarityProblem") -> "void":
    r"""
    secondOrderConeLinearComplementarityProblem_display(SecondOrderConeLinearComplementarityProblem *problem) -> None

    display a SecondOrderConeLinearComplementarityProblem  

    Parameters
    ----------

    problem :  
        the problem to display  

    """
    return _numerics.secondOrderConeLinearComplementarityProblem_display(problem)

def secondOrderConeLinearComplementarityProblem_printInFile(problem: "SecondOrderConeLinearComplementarityProblem", file: "FILE *") -> "int":
    r"""
    secondOrderConeLinearComplementarityProblem_printInFile(SecondOrderConeLinearComplementarityProblem *problem, FILE *file) -> int

    print a SecondOrderConeLinearComplementarityProblem in a file (numerics .dat
    format)  

    Parameters
    ----------

    problem :  
        the problem to print out  

    file :  
        the dest file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.secondOrderConeLinearComplementarityProblem_printInFile(problem, file)

def secondOrderConeLinearComplementarityProblem_printInFilename(problem: "SecondOrderConeLinearComplementarityProblem", filename: "char *") -> "int":
    r"""
    secondOrderConeLinearComplementarityProblem_printInFilename(SecondOrderConeLinearComplementarityProblem *problem, char *filename) -> int

    print a SecondOrderConeLinearComplementarityProblem in a file (numerics .dat
    format) from its filename  

    Parameters
    ----------

    problem :  
        the problem to print out  

    filename :  
        the dest file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.secondOrderConeLinearComplementarityProblem_printInFilename(problem, filename)

def secondOrderConeLinearComplementarityProblem_newFromFile(problem: "SecondOrderConeLinearComplementarityProblem", file: "FILE *") -> "int":
    r"""
    secondOrderConeLinearComplementarityProblem_newFromFile(SecondOrderConeLinearComplementarityProblem *problem, FILE *file) -> int

    read a SecondOrderConeLinearComplementarityProblem in a file (numerics .dat
    format)  

    Parameters
    ----------

    problem :  
        the problem to read  

    file :  
        the target file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.secondOrderConeLinearComplementarityProblem_newFromFile(problem, file)

def secondOrderConeLinearComplementarityProblem_newFromFilename(problem: "SecondOrderConeLinearComplementarityProblem", filename: "char *") -> "int":
    r"""
    secondOrderConeLinearComplementarityProblem_newFromFilename(SecondOrderConeLinearComplementarityProblem *problem, char *filename) -> int

    read a SecondOrderConeLinearComplementarityProblem in a file (numerics .dat
    format) from its filename  

    Parameters
    ----------

    problem :  
        the problem to read  

    filename :  
        the name of the target file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.secondOrderConeLinearComplementarityProblem_newFromFilename(problem, filename)

def freeSecondOrderConeLinearComplementarityProblem(problem: "SecondOrderConeLinearComplementarityProblem") -> "void":
    r"""
    freeSecondOrderConeLinearComplementarityProblem(SecondOrderConeLinearComplementarityProblem *problem) -> None

    free a SecondOrderConeLinearComplementarityProblem  

    Parameters
    ----------

    problem :  
        the problem to free  

    """
    return _numerics.freeSecondOrderConeLinearComplementarityProblem(problem)

def secondOrderConeLinearComplementarityProblem_new(n: "int", nc: "int", M: "NumericsMatrix", q: "double *", coneIndex: "unsigned int *", mu: "double *") -> "SecondOrderConeLinearComplementarityProblem *":
    r"""
    secondOrderConeLinearComplementarityProblem_new(int n, int nc, NumericsMatrix *M, array_like (np.float64, 1D)q,  int *conearray_like (int, 1D), array_like (np.float64, 1D)mu) -> SecondOrderConeLinearComplementarityProblem *

    new SecondOrderConeLinearComplementarityProblem from minimal set of data  

    Parameters
    ----------

    n :  
        the size of the problem  

    nc :  
        the number of contact  

    M :  
        the NumericsMatrix  

    q :  
        the q vector  

    coneIndex :  

    mu :  
        the mu vector  

    Returns
    -------
    a pointer to a SecondOrderConeLinearComplementarityProblem structure  

    """
    return _numerics.secondOrderConeLinearComplementarityProblem_new(n, nc, M, q, coneIndex, mu)

def soclcp_setDefaultSolverOptions(options: "SolverOptions", solverId: "int") -> "int":
    r"""
    soclcp_setDefaultSolverOptions(SolverOptions *options, int solverId) -> int

    set the default solver parameters and perform memory allocation for soclcp  

    Parameters
    ----------

    options :  
        the pointer to the options to set  

    solverId :  
        the identifier of the solver  

    """
    return _numerics.soclcp_setDefaultSolverOptions(options, solverId)

def soclcp_nsgs(problem: "SecondOrderConeLinearComplementarityProblem", r: "double *", v: "double *", options: "SolverOptions") -> "int *":
    r"""
    soclcp_nsgs(SecondOrderConeLinearComplementarityProblem *problem, array_like (np.float64, 1D)r, array_like (np.float64, 1D)v, int *info, SolverOptions *options) -> None

    Non-Smooth Gauss Seidel solver for SOCLCP problem.  

    Parameters
    ----------

    problem :  
        the SOCLCP problem to solve  

    v :  
        global vector (n), in-out parameter  

    r :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : [in] iparam[0] : Maximum iteration number [in]
        iparam[1] : error computation method : 0 : Complete error computation with v
        computation 1: Light error computation with incremental values on r
        verification of absolute error at the end 2: only light error computation (v
        not computed) [out]iparam[7] = iter number of performed iterations [in]
        iparam[8] : method uses overrelaxation [in] iparam[9] : shuffle the contact
        indices in the loop  

    [in] dparam[0] user tolerance on the loop [in] dparam[8] the relaxation
    parameter omega [out] dparam[1] reached error  

    The internal (local) solver must set by the SolverOptions options[1]  

    """
    return _numerics.soclcp_nsgs(problem, r, v, options)

def soclcp_nsgs_fillMLocal(problem: "SecondOrderConeLinearComplementarityProblem", localproblem: "SecondOrderConeLinearComplementarityProblem", contact: "int") -> "void":
    r"""
    soclcp_nsgs_fillMLocal(SecondOrderConeLinearComplementarityProblem *problem, SecondOrderConeLinearComplementarityProblem *localproblem, int contact) -> None

    """
    return _numerics.soclcp_nsgs_fillMLocal(problem, localproblem, contact)

def soclcp_nsgs_computeqLocal(problem: "SecondOrderConeLinearComplementarityProblem", localproblem: "SecondOrderConeLinearComplementarityProblem", r: "double *", contact: "int", options: "SolverOptions") -> "void":
    r"""
    soclcp_nsgs_computeqLocal(SecondOrderConeLinearComplementarityProblem *problem, SecondOrderConeLinearComplementarityProblem *localproblem, array_like (np.float64, 1D)r, int contact, SolverOptions *options) -> None

    """
    return _numerics.soclcp_nsgs_computeqLocal(problem, localproblem, r, contact, options)

def soclcp_nsgs_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    soclcp_nsgs_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for NSGS  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.soclcp_nsgs_setDefaultSolverOptions(options)

def soclcp_VI_FixedPointProjection(problem: "SecondOrderConeLinearComplementarityProblem", r: "double *", v: "double *", options: "SolverOptions") -> "int *":
    r"""
    soclcp_VI_FixedPointProjection(SecondOrderConeLinearComplementarityProblem *problem, array_like (np.float64, 1D)r, array_like (np.float64, 1D)v, int *info, SolverOptions *options) -> None

    """
    return _numerics.soclcp_VI_FixedPointProjection(problem, r, v, options)

def soclcp_VI_FixedPointProjection_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    soclcp_VI_FixedPointProjection_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for DSFP  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.soclcp_VI_FixedPointProjection_setDefaultSolverOptions(options)

def soclcp_VI_ExtraGradient(problem: "SecondOrderConeLinearComplementarityProblem", r: "double *", v: "double *", options: "SolverOptions") -> "int *":
    r"""
    soclcp_VI_ExtraGradient(SecondOrderConeLinearComplementarityProblem *problem, array_like (np.float64, 1D)r, array_like (np.float64, 1D)v, int *info, SolverOptions *options) -> None

    Extra Gradient solver (VI_EG) for SOCLCP problem based on a VI reformulation.  

    Parameters
    ----------

    problem :  
        the SOCLCP problem to solve  

    v :  
        global vector (n), in-out parameter  

    r :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho >0  

    """
    return _numerics.soclcp_VI_ExtraGradient(problem, r, v, options)

def soclcp_VI_ExtraGradient_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    soclcp_VI_ExtraGradient_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for VI_EG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.soclcp_VI_ExtraGradient_setDefaultSolverOptions(options)

def soclcp_checkTrivialCase(problem: "SecondOrderConeLinearComplementarityProblem", v: "double *", r: "double *", options: "SolverOptions") -> "int":
    r"""
    soclcp_checkTrivialCase(SecondOrderConeLinearComplementarityProblem *problem, array_like (np.float64, 1D)v, array_like (np.float64, 1D)r, SolverOptions *options) -> int

    Check for trivial solution in the SOCLCP problem.  

    Parameters
    ----------

    problem :  
        SecondOrderConeLinearComplementarityProblem* the problem  

    v :  
        global vector (n), in-out parameter  

    r :  
        global vector (n), in-out parameters  

    options :  
        the pointer to the array of options to set  

    Returns
    -------
    info =0 if a trivial solution has been found, else = -1  

    """
    return _numerics.soclcp_checkTrivialCase(problem, v, r, options)
SICONOS_SOCLCP_NSGS = _numerics.SICONOS_SOCLCP_NSGS
SICONOS_SOCLCP_VI_FPP = _numerics.SICONOS_SOCLCP_VI_FPP
SICONOS_SOCLCP_VI_EG = _numerics.SICONOS_SOCLCP_VI_EG
SICONOS_SOCLCP_ProjectionOnCone = _numerics.SICONOS_SOCLCP_ProjectionOnCone
SICONOS_SOCLCP_ProjectionOnConeWithLocalIteration = _numerics.SICONOS_SOCLCP_ProjectionOnConeWithLocalIteration
SICONOS_SOCLCP_projectionOnConeWithRegularization = _numerics.SICONOS_SOCLCP_projectionOnConeWithRegularization
class FrictionContactProblem(object):
    r"""

    The structure that defines a (reduced or dual) Friction-Contact (3D or 2D)
    problem.  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_FrictionContact_FrictionContactProblem.h`.


    Attributes
    ----------
     dimension : `int`  
        dimension of the contact space (3D or 2D )  

     M : `NumericsMatrix *`  
        FORMULA89_, a matrix with FORMULA90_ stored in NumericsMatrix structure  

     mu : `array_like (np.float64, 1D)`  
        FORMULA91_, vector of friction coefficients ( FORMULA92_ numberOfContacts)  

     numberOfContacts : `int`  
        the number of contacts FORMULA93_  

     q : `array_like (np.float64, 1D)`  
        FORMULA94_  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    dimension = property(_numerics.FrictionContactProblem_dimension_get, _numerics.FrictionContactProblem_dimension_set)
    numberOfContacts = property(_numerics.FrictionContactProblem_numberOfContacts_get, _numerics.FrictionContactProblem_numberOfContacts_set)
    M = property(_numerics.FrictionContactProblem_M_get, _numerics.FrictionContactProblem_M_set)
    q = property(_numerics.FrictionContactProblem_q_get, _numerics.FrictionContactProblem_q_set)
    mu = property(_numerics.FrictionContactProblem_mu_get, _numerics.FrictionContactProblem_mu_set)

    def __init__(self, *args):
        r"""

        The structure that defines a (reduced or dual) Friction-Contact (3D or 2D)
        problem.  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_FrictionContact_FrictionContactProblem.h`.


        Attributes
        ----------
         dimension : `int`  
            dimension of the contact space (3D or 2D )  

         M : `NumericsMatrix *`  
            FORMULA89_, a matrix with FORMULA90_ stored in NumericsMatrix structure  

         mu : `array_like (np.float64, 1D)`  
            FORMULA91_, vector of friction coefficients ( FORMULA92_ numberOfContacts)  

         numberOfContacts : `int`  
            the number of contacts FORMULA93_  

         q : `array_like (np.float64, 1D)`  
            FORMULA94_  

        """
        _numerics.FrictionContactProblem_swiginit(self, _numerics.new_FrictionContactProblem(*args))
    __swig_destroy__ = _numerics.delete_FrictionContactProblem

# Register FrictionContactProblem in _numerics:
_numerics.FrictionContactProblem_swigregister(FrictionContactProblem)
SICONOS_SOCLCP_NSGS_STR = cvar.SICONOS_SOCLCP_NSGS_STR
SICONOS_SOCLCP_NSGSV_STR = cvar.SICONOS_SOCLCP_NSGSV_STR
SICONOS_SOCLCP_PROX_STR = cvar.SICONOS_SOCLCP_PROX_STR
SICONOS_SOCLCP_TFP_STR = cvar.SICONOS_SOCLCP_TFP_STR
SICONOS_SOCLCP_NSN_AC_STR = cvar.SICONOS_SOCLCP_NSN_AC_STR
SICONOS_SOCLCP_NSN_FB_STR = cvar.SICONOS_SOCLCP_NSN_FB_STR
SICONOS_SOCLCP_DSFP_STR = cvar.SICONOS_SOCLCP_DSFP_STR
SICONOS_SOCLCP_VI_EG_STR = cvar.SICONOS_SOCLCP_VI_EG_STR
SICONOS_SOCLCP_VI_FPP_STR = cvar.SICONOS_SOCLCP_VI_FPP_STR
SICONOS_SOCLCP_EG_STR = cvar.SICONOS_SOCLCP_EG_STR
SICONOS_SOCLCP_FPP_STR = cvar.SICONOS_SOCLCP_FPP_STR
SICONOS_SOCLCP_HP_STR = cvar.SICONOS_SOCLCP_HP_STR
SICONOS_SOCLCP_NCPGlockerFBFixedPoint_STR = cvar.SICONOS_SOCLCP_NCPGlockerFBFixedPoint_STR
SICONOS_SOCLCP_AlartCurnierNewton_STR = cvar.SICONOS_SOCLCP_AlartCurnierNewton_STR
SICONOS_SOCLCP_DampedAlartCurnierNewton_STR = cvar.SICONOS_SOCLCP_DampedAlartCurnierNewton_STR
SICONOS_SOCLCP_NCPGlockerFBNewton_STR = cvar.SICONOS_SOCLCP_NCPGlockerFBNewton_STR
SICONOS_SOCLCP_ProjectionOnConeWithDiagonalization_STR = cvar.SICONOS_SOCLCP_ProjectionOnConeWithDiagonalization_STR
SICONOS_SOCLCP_ProjectionOnCone_STR = cvar.SICONOS_SOCLCP_ProjectionOnCone_STR
SICONOS_SOCLCP_ProjectionOnConeWithLocalIteration_STR = cvar.SICONOS_SOCLCP_ProjectionOnConeWithLocalIteration_STR
SICONOS_SOCLCP_projectionOnConeWithRegularization_STR = cvar.SICONOS_SOCLCP_projectionOnConeWithRegularization_STR
SICONOS_SOCLCP_NCPGlockerFBPATH_STR = cvar.SICONOS_SOCLCP_NCPGlockerFBPATH_STR
SICONOS_SOCLCP_projectionOnCylinder_STR = cvar.SICONOS_SOCLCP_projectionOnCylinder_STR
SICONOS_SOCLCP_ProjectionOnCone_velocity_STR = cvar.SICONOS_SOCLCP_ProjectionOnCone_velocity_STR
SICONOS_SOCLCP_PGoC_STR = cvar.SICONOS_SOCLCP_PGoC_STR
SICONOS_SOCLCP_DeSaxceFixedPoint_STR = cvar.SICONOS_SOCLCP_DeSaxceFixedPoint_STR
SICONOS_SOCLCP_QUARTIC_STR = cvar.SICONOS_SOCLCP_QUARTIC_STR
SICONOS_SOCLCP_QUARTIC_NU_STR = cvar.SICONOS_SOCLCP_QUARTIC_NU_STR

class SplittedFrictionContactProblem(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    fc3d = property(_numerics.SplittedFrictionContactProblem_fc3d_get, _numerics.SplittedFrictionContactProblem_fc3d_set)
    M_nn = property(_numerics.SplittedFrictionContactProblem_M_nn_get, _numerics.SplittedFrictionContactProblem_M_nn_set)
    M_tn = property(_numerics.SplittedFrictionContactProblem_M_tn_get, _numerics.SplittedFrictionContactProblem_M_tn_set)
    M_nt = property(_numerics.SplittedFrictionContactProblem_M_nt_get, _numerics.SplittedFrictionContactProblem_M_nt_set)
    M_tt = property(_numerics.SplittedFrictionContactProblem_M_tt_get, _numerics.SplittedFrictionContactProblem_M_tt_set)
    q_n = property(_numerics.SplittedFrictionContactProblem_q_n_get, _numerics.SplittedFrictionContactProblem_q_n_set)
    q_t = property(_numerics.SplittedFrictionContactProblem_q_t_get, _numerics.SplittedFrictionContactProblem_q_t_set)

    def __init__(self):
        _numerics.SplittedFrictionContactProblem_swiginit(self, _numerics.new_SplittedFrictionContactProblem())
    __swig_destroy__ = _numerics.delete_SplittedFrictionContactProblem

# Register SplittedFrictionContactProblem in _numerics:
_numerics.SplittedFrictionContactProblem_swigregister(SplittedFrictionContactProblem)


def frictionContactProblem_new_with_data(dim: "int", nc: "int", M: "NumericsMatrix", q: "double *", mu: "double *") -> "FrictionContactProblem *":
    r"""
    frictionContactProblem_new_with_data(int dim, int nc, NumericsMatrix *M, array_like (np.float64, 1D)q, array_like (np.float64, 1D)mu) -> FrictionContactProblem *

    new FrictionContactProblem from minimal set of data  

    Parameters
    ----------

    dim :  
        the problem dimension  

    nc :  
        the number of contact  

    M :  
        the NumericsMatrix  

    q :  
        the q vector  

    mu :  
        the mu vector  

    Returns
    -------
    a pointer to a FrictionContactProblem structure  

    """
    return _numerics.frictionContactProblem_new_with_data(dim, nc, M, q, mu)

def frictionContactProblem_free(problem: "FrictionContactProblem") -> "void":
    r"""
    frictionContactProblem_free(FrictionContactProblem *problem) -> None

    free a FrictionContactProblem  

    Parameters
    ----------

    problem :  
        the problem to free  

    """
    return _numerics.frictionContactProblem_free(problem)

def frictionContact_display(problem: "FrictionContactProblem") -> "void":
    r"""
    frictionContact_display(FrictionContactProblem *problem) -> None

    display a FrictionContactProblem  

    Parameters
    ----------

    problem :  
        the problem to display  

    """
    return _numerics.frictionContact_display(problem)

def frictionContact_printInFile(problem: "FrictionContactProblem", file: "FILE *") -> "int":
    r"""
    frictionContact_printInFile(FrictionContactProblem *problem, FILE *file) -> int

    print a FrictionContactProblem in a file (numerics .dat format)  

    Parameters
    ----------

    problem :  
        the problem to print out  

    file :  
        the dest file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.frictionContact_printInFile(problem, file)

def frictionContact_printInFilename(problem: "FrictionContactProblem", filename: "char *") -> "int":
    r"""
    frictionContact_printInFilename(FrictionContactProblem *problem, char *filename) -> int

    print a FrictionContactProblem in a file (numerics .dat format) from its
    filename  

    Parameters
    ----------

    problem :  
        the problem to print out  

    filename :  
        the dest file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.frictionContact_printInFilename(problem, filename)

def frictionContact_newFromFile(problem: "FrictionContactProblem", file: "FILE *") -> "int":
    r"""
    frictionContact_newFromFile(FrictionContactProblem *problem, FILE *file) -> int

    read a FrictionContactProblem in a file (numerics .dat format)  

    Parameters
    ----------

    problem :  
        the problem to read  

    file :  
        the target file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.frictionContact_newFromFile(problem, file)

def frictionContact_newFromFilename(problem: "FrictionContactProblem", filename: "char *") -> "int":
    r"""
    frictionContact_newFromFilename(FrictionContactProblem *problem, char *filename) -> int

    read a FrictionContactProblem in a file (numerics .dat format) from its filename  

    Parameters
    ----------

    problem :  
        the problem to read  

    filename :  
        the name of the target file  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.frictionContact_newFromFilename(problem, filename)

def createSplittedFrictionContactProblem(problem: "FrictionContactProblem", splitted_problem: "SplittedFrictionContactProblem") -> "void":
    r"""
    createSplittedFrictionContactProblem(FrictionContactProblem *problem, SplittedFrictionContactProblem *splitted_problem) -> None

    """
    return _numerics.createSplittedFrictionContactProblem(problem, splitted_problem)

def frictionContactProblem_compute_statistics(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", tol: "double", do_print: "int") -> "void":
    r"""
    frictionContactProblem_compute_statistics(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, double tol, int do_print) -> None

    """
    return _numerics.frictionContactProblem_compute_statistics(problem, reaction, velocity, tol, do_print)

def from_fclib_local(fclib_problem: "struct fclib_local const *") -> "FrictionContactProblem *":
    r"""
    from_fclib_local( struct fclib_local *fclib_problem) -> FrictionContactProblem *

    """
    return _numerics.from_fclib_local(fclib_problem)

def frictionContact_fclib_read(path: "char const *") -> "FrictionContactProblem *":
    r"""
    frictionContact_fclib_read( char *path) -> FrictionContactProblem *

    """
    return _numerics.frictionContact_fclib_read(path)

def frictionContact_fclib_write(problem: "FrictionContactProblem", title: "char *", description: "char *", mathInfo: "char *", path: "char const *", ndof: "int") -> "int":
    r"""
    frictionContact_fclib_write(FrictionContactProblem *problem, char *title, char *description, char *mathInfo,  char *path, int ndof) -> int

    """
    return _numerics.frictionContact_fclib_write(problem, title, description, mathInfo, path, ndof)

def frictionContact_fclib_write_guess(reaction: "double *", velocity: "double *", path: "char const *") -> "int":
    r"""
    frictionContact_fclib_write_guess(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity,  char *path) -> int

    """
    return _numerics.frictionContact_fclib_write_guess(reaction, velocity, path)

def from_fclib_global(fclib_problem: "struct fclib_global const *") -> "GlobalFrictionContactProblem *":
    r"""
    from_fclib_global( struct fclib_global *fclib_problem) -> GlobalFrictionContactProblem *

    """
    return _numerics.from_fclib_global(fclib_problem)

def globalFrictionContact_fclib_read(path: "char const *") -> "GlobalFrictionContactProblem *":
    r"""
    globalFrictionContact_fclib_read( char *path) -> GlobalFrictionContactProblem *

    """
    return _numerics.globalFrictionContact_fclib_read(path)

def globalFrictionContact_fclib_write(problem: "GlobalFrictionContactProblem", title: "char *", description: "char *", mathInfo: "char *", path: "char const *") -> "int":
    r"""
    globalFrictionContact_fclib_write(GlobalFrictionContactProblem *problem, char *title, char *description, char *mathInfo,  char *path) -> int

    """
    return _numerics.globalFrictionContact_fclib_write(problem, title, description, mathInfo, path)

def compute_rho_split_spectral_norm_cond(localproblem: "FrictionContactProblem", rho: "double *") -> "void":
    r"""
    compute_rho_split_spectral_norm_cond(FrictionContactProblem *localproblem, array_like (np.float64, 1D)rho) -> None

    """
    return _numerics.compute_rho_split_spectral_norm_cond(localproblem, rho)

def compute_rho_split_spectral_norm(localproblem: "FrictionContactProblem", rho: "double *") -> "void":
    r"""
    compute_rho_split_spectral_norm(FrictionContactProblem *localproblem, array_like (np.float64, 1D)rho) -> None

    """
    return _numerics.compute_rho_split_spectral_norm(localproblem, rho)

def compute_rho_spectral_norm(localproblem: "FrictionContactProblem", rho: "double *") -> "void":
    r"""
    compute_rho_spectral_norm(FrictionContactProblem *localproblem, array_like (np.float64, 1D)rho) -> None

    """
    return _numerics.compute_rho_spectral_norm(localproblem, rho)

def computeAlartCurnierSTD(reaction: "double [3]", velocity: "double [3]", mu: "double", rho: "double [3]") -> "double [3], double [9], double [9]":
    r"""
    computeAlartCurnierSTD(double reaction[3], double velocity[3], double mu, double rho[3], double result[3], double A[9], double B[9]) -> None

    """
    return _numerics.computeAlartCurnierSTD(reaction, velocity, mu, rho)

def computeAlartCurnierJeanMoreau(reaction: "double [3]", velocity: "double [3]", mu: "double", rho: "double [3]") -> "double [3], double [9], double [9]":
    r"""
    computeAlartCurnierJeanMoreau(double reaction[3], double velocity[3], double mu, double rho[3], double result[3], double A[9], double B[9]) -> None

    """
    return _numerics.computeAlartCurnierJeanMoreau(reaction, velocity, mu, rho)
class AlartCurnierParams(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    computeACFun3x3 = property(_numerics.AlartCurnierParams_computeACFun3x3_get, _numerics.AlartCurnierParams_computeACFun3x3_set)

    def __init__(self):
        _numerics.AlartCurnierParams_swiginit(self, _numerics.new_AlartCurnierParams())
    __swig_destroy__ = _numerics.delete_AlartCurnierParams

# Register AlartCurnierParams in _numerics:
_numerics.AlartCurnierParams_swigregister(AlartCurnierParams)


def nonsmoothEqnAlartCurnierFun(arg: "void *", reaction: "double *", velocity: "double *", mu: "double *", rho: "double *", A: "double *", B: "double *") -> "double *":
    r"""
    nonsmoothEqnAlartCurnierFun(None *arg,  int problemSize, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)mu, array_like (np.float64, 1D)rho, array_like (np.float64, 1D)result, array_like (np.float64, 1D)A, array_like (np.float64, 1D)B) -> None

    """
    return _numerics.nonsmoothEqnAlartCurnierFun(arg, reaction, velocity, mu, rho, A, B)

def fc3d_nonsmooth_Newton_AlartCurnier(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_nonsmooth_Newton_AlartCurnier(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Nonsmooth Newton solver based on the Alart--Curnier function for the local
    (reduced) frictional contact problem in the dense form.  

    Parameters
    ----------

    problem :  
        the problem to solve in dense form  

    reaction :  
        solution and initial guess for reaction  

    velocity :  
        solution and initial guess for velocity  

    info :  
        returned info  

    options :  
        the solver options  

    """
    return _numerics.fc3d_nonsmooth_Newton_AlartCurnier(problem, reaction, velocity, options)

def fc3d_nonsmooth_Newton_AlartCurnier_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_nonsmooth_Newton_AlartCurnier_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.fc3d_nonsmooth_Newton_AlartCurnier_setDefaultSolverOptions(options)

def fc3d_AlartCurnierFunction(reaction3D: "double *", velocity3D: "double *", mu: "double *", rho3D: "double *") -> "double *, double *, double *":
    r"""
    fc3d_AlartCurnierFunction( int problemSize, AlartCurnierFun3x3Ptr computeACFun3x3, array_like (np.float64, 1D)reaction3D, array_like (np.float64, 1D)velocity3D, array_like (np.float64, 1D)mu, array_like (np.float64, 1D)rho3D, array_like (np.float64, 1D)output_blocklist3, array_like (np.float64, 1D)output_blocklist3x3_1, array_like (np.float64, 1D)output_blocklist3x3_2) -> None

    The Alart & Curnier function for several contacts.  

    On each contact, the specified Alart Curnier function in iparam[9] is called.  

    Parameters
    ----------

    problemSize :  
        the number of contacts.  

    computeACFun3x3 :  
        the block 3x3 Alart & Curnier function.  

    reaction3D :  
        the reactions at each contact (size: 3 x problemSize)  

    velocity3D :  
        the velocities at each contact (size: 3 x problemSize)  

    mu :  
        the mu parameter (size : problemSize)  

    rho3D :  
        the rho parameters (size : 3 x problemSize)  

    output_blocklist3 :  
        the computed Alart & Curnier function (size : 3 x problemSize)  

    output_blocklist3x3_1 :  
        the computed A part of gradient (size : 9 x problemSize)  

    output_blocklist3x3_2 :  
        the computed B part of gradient (size : 9 x problemSize)  

    """
    return _numerics.fc3d_AlartCurnierFunction(reaction3D, velocity3D, mu, rho3D)

def fc3d_nonsmooth_Newton_FischerBurmeister(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_nonsmooth_Newton_FischerBurmeister(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Nonsmooth Newton solver based on the Fischer--Burmeister function for the local
    (reduced) frictional contact problem in the dense form.  

    Parameters
    ----------

    problem :  
        the problem to solve in dense or sparse block form  

    reaction :  
        solution and initial guess for reaction  

    velocity :  
        solution and initial guess for velocity  

    info :  
        returned info  

    options :  
        the solver options  

    """
    return _numerics.fc3d_nonsmooth_Newton_FischerBurmeister(problem, reaction, velocity, options)

def fc3d_FischerBurmeisterFunction(reaction3D: "double *", velocity3D: "double *", mu: "double *", rho3D: "double *") -> "double *, double *, double *":
    r"""
    fc3d_FischerBurmeisterFunction( int problemSize, FischerBurmeisterFun3x3Ptr computeACFun3x3, array_like (np.float64, 1D)reaction3D, array_like (np.float64, 1D)velocity3D, array_like (np.float64, 1D)mu, array_like (np.float64, 1D)rho3D, array_like (np.float64, 1D)output_blocklist3, array_like (np.float64, 1D)output_blocklist3x3_1, array_like (np.float64, 1D)output_blocklist3x3_2) -> None

    The Fischer & Burmeister function for several contacts.  

    On each contact, the specified Fischer Burmeister function in iparam[9] is
    called.  

    Parameters
    ----------

    problemSize :  
        the number of contacts.  

    computeACFun3x3 :  
        the block 3x3 Fischer & Burmeister function.  

    reaction3D :  
        the reactions at each contact (size: 3 x problemSize)  

    velocity3D :  
        the velocities at each contact (size: 3 x problemSize)  

    mu :  
        the mu parameter (size : problemSize)  

    rho3D :  
        the rho parameters (size : 3 x problemSize)  

    output_blocklist3 :  
        the computed Fischer & Burmeister function (size : 3 x problemSize)  

    output_blocklist3x3_1 :  
        the computed A part of gradient (size : 9 x problemSize)  

    output_blocklist3x3_2 :  
        the computed B param of gradient (size : 9 x problemSize)  

    """
    return _numerics.fc3d_FischerBurmeisterFunction(reaction3D, velocity3D, mu, rho3D)

def fc3d_nonsmooth_Newton_FischerBurmeister_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_nonsmooth_Newton_FischerBurmeister_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.fc3d_nonsmooth_Newton_FischerBurmeister_setDefaultSolverOptions(options)

def fc3d_nonsmooth_Newton_FischerBurmeister_compute_error(problem: "FrictionContactProblem", z: "double *", w: "double *", tolerance: "double", options: "SolverOptions") -> "double *":
    r"""
    fc3d_nonsmooth_Newton_FischerBurmeister_compute_error(FrictionContactProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, double tolerance, SolverOptions *options, array_like (np.float64, 1D)error) -> int

    """
    return _numerics.fc3d_nonsmooth_Newton_FischerBurmeister_compute_error(problem, z, w, tolerance, options)

def fc3d_nonsmooth_Newton_NaturalMap(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_nonsmooth_Newton_NaturalMap(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Nonsmooth Newton solver based on the Natural--Map function for the local
    (reduced) frictional contact problem in the dense form.  

    Parameters
    ----------

    problem :  
        the problem to solve in dense or sparse block form  

    reaction :  
        solution and initial guess for reaction  

    velocity :  
        solution and initial guess for velocity  

    info :  
        returned info  

    options :  
        the solver options  

    """
    return _numerics.fc3d_nonsmooth_Newton_NaturalMap(problem, reaction, velocity, options)

def fc3d_NaturalMapFunction(reaction3D: "double *", velocity3D: "double *", mu: "double *", rho3D: "double *") -> "double *, double *, double *":
    r"""
    fc3d_NaturalMapFunction( int problemSize, NaturalMapFun3x3Ptr computeACFun3x3, array_like (np.float64, 1D)reaction3D, array_like (np.float64, 1D)velocity3D, array_like (np.float64, 1D)mu, array_like (np.float64, 1D)rho3D, array_like (np.float64, 1D)output_blocklist3, array_like (np.float64, 1D)output_blocklist3x3_1, array_like (np.float64, 1D)output_blocklist3x3_2) -> None

    The natural map function for several contacts.  

    On each contact, the specified natural map function in iparam[9] is called.  

    Parameters
    ----------

    problemSize :  
        the number of contacts.  

    computeACFun3x3 :  
        the block 3x3 natural map function.  

    reaction3D :  
        the reactions at each contact (size: 3 x problemSize)  

    velocity3D :  
        the velocities at each contact (size: 3 x problemSize)  

    mu :  
        the mu parameter (size : problemSize)  

    rho3D :  
        the rho parameters (size : 3 x problemSize)  

    output_blocklist3 :  
        the computed natural map function (size : 3 x problemSize)  

    output_blocklist3x3_1 :  
        the computed A part of gradient (size : 9 x problemSize)  

    output_blocklist3x3_2 :  
        the computed B param of gradient (size : 9 x problemSize)  

    """
    return _numerics.fc3d_NaturalMapFunction(reaction3D, velocity3D, mu, rho3D)

def fc3d_nonsmooth_Newton_NaturalMap_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_nonsmooth_Newton_NaturalMap_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.fc3d_nonsmooth_Newton_NaturalMap_setDefaultSolverOptions(options)

def fc3d_nonsmooth_Newton_NaturalMap_compute_error(problem: "FrictionContactProblem", z: "double *", w: "double *", tolerance: "double", options: "SolverOptions") -> "double *":
    r"""
    fc3d_nonsmooth_Newton_NaturalMap_compute_error(FrictionContactProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, double tolerance, SolverOptions *options, array_like (np.float64, 1D)error) -> int

    """
    return _numerics.fc3d_nonsmooth_Newton_NaturalMap_compute_error(problem, z, w, tolerance, options)

def fc3d_AlartCurnierFunctionGenerated(reaction: "double *", velocity: "double *", mu: "double", rho: "double *", f: "double *", A: "double *", B: "double *") -> "void":
    r"""
    fc3d_AlartCurnierFunctionGenerated(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, double mu, array_like (np.float64, 1D)rho, array_like (np.float64, 1D)f, array_like (np.float64, 1D)A, array_like (np.float64, 1D)B) -> None

    """
    return _numerics.fc3d_AlartCurnierFunctionGenerated(reaction, velocity, mu, rho, f, A, B)

def fc3d_AlartCurnierJeanMoreauFunctionGenerated(reaction: "double *", velocity: "double *", mu: "double", rho: "double *", f: "double *", A: "double *", B: "double *") -> "void":
    r"""
    fc3d_AlartCurnierJeanMoreauFunctionGenerated(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, double mu, array_like (np.float64, 1D)rho, array_like (np.float64, 1D)f, array_like (np.float64, 1D)A, array_like (np.float64, 1D)B) -> None

    """
    return _numerics.fc3d_AlartCurnierJeanMoreauFunctionGenerated(reaction, velocity, mu, rho, f, A, B)

def fc3d_FischerBurmeisterFABGenerated(rn: "double", rt1: "double", rt2: "double", un: "double", ut1: "double", ut2: "double", mu: "double", rhon: "double", rhot1: "double", rhot2: "double") -> "double *":
    r"""
    fc3d_FischerBurmeisterFABGenerated(double rn, double rt1, double rt2, double un, double ut1, double ut2, double mu, double rhon, double rhot1, double rhot2, array_like (np.float64, 1D)result) -> None

    """
    return _numerics.fc3d_FischerBurmeisterFABGenerated(rn, rt1, rt2, un, ut1, ut2, mu, rhon, rhot1, rhot2)

def fc3d_FischerBurmeisterFGenerated(rn: "double", rt1: "double", rt2: "double", un: "double", ut1: "double", ut2: "double", mu: "double", rhon: "double", rhot1: "double", rhot2: "double") -> "double *":
    r"""
    fc3d_FischerBurmeisterFGenerated(double rn, double rt1, double rt2, double un, double ut1, double ut2, double mu, double rhon, double rhot1, double rhot2, array_like (np.float64, 1D)result) -> None

    """
    return _numerics.fc3d_FischerBurmeisterFGenerated(rn, rt1, rt2, un, ut1, ut2, mu, rhon, rhot1, rhot2)

def fc3d_FischerBurmeisterABGenerated(rn: "double", rt1: "double", rt2: "double", un: "double", ut1: "double", ut2: "double", mu: "double", rhon: "double", rhot1: "double", rhot2: "double") -> "double *":
    r"""
    fc3d_FischerBurmeisterABGenerated(double rn, double rt1, double rt2, double un, double ut1, double ut2, double mu, double rhon, double rhot1, double rhot2, array_like (np.float64, 1D)result) -> None

    """
    return _numerics.fc3d_FischerBurmeisterABGenerated(rn, rt1, rt2, un, ut1, ut2, mu, rhon, rhot1, rhot2)

def fc3d_FischerBurmeisterFunctionGenerated(reaction: "double *", velocity: "double *", mu: "double", rho: "double *", f: "double *", A: "double *", B: "double *") -> "void":
    r"""
    fc3d_FischerBurmeisterFunctionGenerated(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, double mu, array_like (np.float64, 1D)rho, array_like (np.float64, 1D)f, array_like (np.float64, 1D)A, array_like (np.float64, 1D)B) -> None

    """
    return _numerics.fc3d_FischerBurmeisterFunctionGenerated(reaction, velocity, mu, rho, f, A, B)

def fc3d_FischerBurmeisterFMeritGenerated(rn: "double", rt1: "double", rt2: "double", un: "double", ut1: "double", ut2: "double", mu: "double", rhon: "double", rhot1: "double", rhot2: "double") -> "double *":
    r"""
    fc3d_FischerBurmeisterFMeritGenerated(double rn, double rt1, double rt2, double un, double ut1, double ut2, double mu, double rhon, double rhot1, double rhot2, array_like (np.float64, 1D)result) -> None

    """
    return _numerics.fc3d_FischerBurmeisterFMeritGenerated(rn, rt1, rt2, un, ut1, ut2, mu, rhon, rhot1, rhot2)

def fc3d_FischerBurmeisterGradFMeritGenerated(rn: "double", rt1: "double", rt2: "double", un: "double", ut1: "double", ut2: "double", mu: "double", rhon: "double", rhot1: "double", rhot2: "double") -> "double *":
    r"""
    fc3d_FischerBurmeisterGradFMeritGenerated(double rn, double rt1, double rt2, double un, double ut1, double ut2, double mu, double rhon, double rhot1, double rhot2, array_like (np.float64, 1D)result) -> None

    """
    return _numerics.fc3d_FischerBurmeisterGradFMeritGenerated(rn, rt1, rt2, un, ut1, ut2, mu, rhon, rhot1, rhot2)

def fc3d_FischerBurmeisterGradMeritFunctionGenerated(reaction: "double *", velocity: "double *", mu: "double", rho: "double *", gf: "double *") -> "void":
    r"""
    fc3d_FischerBurmeisterGradMeritFunctionGenerated(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, double mu, array_like (np.float64, 1D)rho, array_like (np.float64, 1D)gf) -> None

    """
    return _numerics.fc3d_FischerBurmeisterGradMeritFunctionGenerated(reaction, velocity, mu, rho, gf)

def fc3d_NaturalMapFunctionGenerated(reaction: "double *", velocity: "double *", mu: "double", rho: "double *", f: "double *", A: "double *", B: "double *") -> "void":
    r"""
    fc3d_NaturalMapFunctionGenerated(array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, double mu, array_like (np.float64, 1D)rho, array_like (np.float64, 1D)f, array_like (np.float64, 1D)A, array_like (np.float64, 1D)B) -> None

    """
    return _numerics.fc3d_NaturalMapFunctionGenerated(reaction, velocity, mu, rho, f, A, B)

def fc3d_setDefaultSolverOptions(options: "SolverOptions", solverId: "int") -> "int":
    r"""
    fc3d_setDefaultSolverOptions(SolverOptions *options, int solverId) -> int

    set the default solver parameters and perform memory allocation for fc3d  

    Parameters
    ----------

    options :  
        the pointer to the options to set  

    solverId :  
        the identifier of the solver  

    """
    return _numerics.fc3d_setDefaultSolverOptions(options, solverId)

def fc3d_nsgs(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_nsgs(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Non-Smooth Gauss Seidel solver for friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : [in] iparam[0] : Maximum iteration number  

    [in] iparam[SICONOS_FRICTION_3D_IPARAM_ERROR_EVALUATION (7)] : error computation
    method : SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_FULL (0) : Full error
    computation with velocity computation
    SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_LIGHT_WITH_FULL_FINAL (1) : Light
    error computation with incremental values on reaction verification of absolute
    error at the end SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_LIGHT (2) : only
    light error computation (velocity not computed)
    SICONOS_FRICTION_3D_NSGS_ERROR_EVALUATION_ADAPTIVE (3) : we adapt the frequency
    of the full erro evaluation.  

    [in] iparam[SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION(14)] : filter local
    solution if the local error is greater than 1.0
    SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION_FALSE (0) the filter is not
    applied SICONOS_FRICTION_3D_NSGS_FILTER_LOCAL_SOLUTION_TRUE (1) the filter is
    applied  

    [in] iparam[SICONOS_FRICTION_3D_NSGS_RELAXATION(4)] : method uses overrelaxation
    SICONOS_FRICTION_3D_NSGS_RELAXATION_FALSE (0) relaxation is not used,
    SICONOS_FRICTION_3D_NSGS_RELAXATION_TRUE (1) relaxation is used with parameter
    dparam[8],  

    [in] iparam[SICONOS_FRICTION_3D_NSGS_SHUFFLE(5)] : shuffle the contact indices
    in the loop SICONOS_FRICTION_3D_NSGS_SHUFFLE_FALSE (0) : no shuffle
    SICONOS_FRICTION_3D_NSGS_SHUFFLE_TRUE (1) : shuffle only at the beginning
    SICONOS_FRICTION_3D_NSGS_SHUFFLE_TRUE_EACH_LOOP (2) : shuffle in each iteration  

    [in] iparam[SICONOS_FRICTION_3D_NSGS_SHUFFLE_SEED(6)] : seed for the random
    generator in shuffling contacts  

    [out] iparam[SICONOS_IPARAM_ITER_DONE(1)] = iter number of performed iterations  

    [in] iparam[8] = error computation frequency  

    [in] dparam[SICONOS_DPARAM_TOL(0)] user tolerance on the loop [in] dparam[8] the
    relaxation parameter omega [out] dparam[SICONOS_DPARAM_RESIDU(1)] reached error  

    The internal (local) solver must set by the SolverOptions options[1]  

    """
    return _numerics.fc3d_nsgs(problem, reaction, velocity, options)

def fc3d_nsgs_initialize_local_solver(solve: "SolverPtr *", update: "UpdatePtr *", freeSolver: "FreeSolverNSGSPtr *", computeError: "ComputeErrorPtr *", problem: "FrictionContactProblem", localproblem: "FrictionContactProblem", options: "SolverOptions") -> "void":
    r"""
    fc3d_nsgs_initialize_local_solver(SolverPtr *solve, UpdatePtr *update, FreeSolverNSGSPtr *freeSolver, ComputeErrorPtr *computeError, FrictionContactProblem *problem, FrictionContactProblem *localproblem, SolverOptions *options) -> None

    """
    return _numerics.fc3d_nsgs_initialize_local_solver(solve, update, freeSolver, computeError, problem, localproblem, options)

def fc3d_nsgs_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_nsgs_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for NSGS  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_nsgs_setDefaultSolverOptions(options)

def fc3d_admm(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_admm(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.fc3d_admm(problem, reaction, velocity, options)

def fc3d_admm_init(problem: "FrictionContactProblem", options: "SolverOptions") -> "void":
    r"""
    fc3d_admm_init(FrictionContactProblem *problem, SolverOptions *options) -> None

    """
    return _numerics.fc3d_admm_init(problem, options)

def fc3d_admm_free(problem: "FrictionContactProblem", options: "SolverOptions") -> "void":
    r"""
    fc3d_admm_free(FrictionContactProblem *problem, SolverOptions *options) -> None

    """
    return _numerics.fc3d_admm_free(problem, options)

def fc3d_admm_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_admm_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.fc3d_admm_setDefaultSolverOptions(options)

def fc3d_nsgs_velocity(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_nsgs_velocity(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Non-Smooth Gauss Seidel in velocity solver for friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number The internal
        (local) solver must set by the SolverOptions options[1]  

    """
    return _numerics.fc3d_nsgs_velocity(problem, reaction, velocity, options)

def fc3d_nsgs_velocity_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_nsgs_velocity_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for NSGSV  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_nsgs_velocity_setDefaultSolverOptions(options)

def fc3d_proximal(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_proximal(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Proximal point solver for friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number The internal
        (local) solver must set by the SolverOptions options[1]  

    """
    return _numerics.fc3d_proximal(problem, reaction, velocity, options)

def fc3d_proximal_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_proximal_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for PROX  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_proximal_setDefaultSolverOptions(options)

def fc3d_set_internalsolver_tolerance(problem: "FrictionContactProblem", options: "SolverOptions", internalsolver_options: "SolverOptions", error: "double") -> "void":
    r"""
    fc3d_set_internalsolver_tolerance(FrictionContactProblem *problem, SolverOptions *options, SolverOptions *internalsolver_options, double error) -> None

    """
    return _numerics.fc3d_set_internalsolver_tolerance(problem, options, internalsolver_options, error)

def fc3d_TrescaFixedPoint(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_TrescaFixedPoint(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Fixed point solver for friction-contact 3D problem based on the Tresca problem
    with fixed friction threshold.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number The internal
        (local) solver must set by the SolverOptions options[1] : possible internal
        solvers is NSGS.  

    """
    return _numerics.fc3d_TrescaFixedPoint(problem, reaction, velocity, options)

def fc3d_TrescaFixedPoint_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_TrescaFixedPoint_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for TFP  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_TrescaFixedPoint_setDefaultSolverOptions(options)

def fc3d_Panagiotopoulos_FixedPoint(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_Panagiotopoulos_FixedPoint(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Fixed point solver for friction-contact 3D problem based on the Panagiotopoulos
    method based on an alternative technique between the normal problem and the
    tangential one.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number The internal
        (local) solver must set by the SolverOptions options[1] : possible internal
        solvers is NSGS.  

    """
    return _numerics.fc3d_Panagiotopoulos_FixedPoint(problem, reaction, velocity, options)

def fc3d_Panagiotopoulos_FixedPoint_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_Panagiotopoulos_FixedPoint_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for PFP  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_Panagiotopoulos_FixedPoint_setDefaultSolverOptions(options)

def fc3d_SOCLCP_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_SOCLCP_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for SOCLCP  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_SOCLCP_setDefaultSolverOptions(options)

def fc3d_SOCLCP(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_SOCLCP(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.fc3d_SOCLCP(problem, reaction, velocity, options)

def fc3d_ACLMFixedPoint(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_ACLMFixedPoint(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Fixed point solver for friction-contact 3D problem based on the ACLM.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number The internal
        (local) solver must set by the SolverOptions options[1] : possible internal
        solvers is NSGS.  

    """
    return _numerics.fc3d_ACLMFixedPoint(problem, reaction, velocity, options)

def fc3d_ACLMFixedPoint_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_ACLMFixedPoint_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for ACLM  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_ACLMFixedPoint_setDefaultSolverOptions(options)

def fc3d_ConvexQP_ProjectedGradient_Cylinder(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_ConvexQP_ProjectedGradient_Cylinder(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Projected Gradient on Cylinder solver for Friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number if dparam[3] >0 =
        rho if dparam[3] <= 0 then a line-search is performed. iparam[2] is the
        maximum number of iteration is the line--search. The internal (local) solver
        must set by the SolverOptions options->internalsolvers.  

    """
    return _numerics.fc3d_ConvexQP_ProjectedGradient_Cylinder(problem, reaction, velocity, options)

def fc3d_ConvexQP_ProjectedGradient_Cylinder_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_ConvexQP_ProjectedGradient_Cylinder_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for NSGS  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_ConvexQP_ProjectedGradient_Cylinder_setDefaultSolverOptions(options)

def fc3d_DeSaxceFixedPoint(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_DeSaxceFixedPoint(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Fixed Point solver for friction-contact 3D problem based on the De Saxce
    Formulation.  

    Parameters
    ----------

    problem :  
        : the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho .
        if dparam[3] >0 then rho=dparam[3] otherwise a computataion of rho is
        assumed.  

    """
    return _numerics.fc3d_DeSaxceFixedPoint(problem, reaction, velocity, options)

def fc3d_DeSaxceFixedPoint_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_DeSaxceFixedPoint_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for DSFP  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_DeSaxceFixedPoint_setDefaultSolverOptions(options)

def fc3d_fixedPointProjection(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_fixedPointProjection(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Fixed Point Projection solver for friction-contact 3D problem based on the De
    Saxce Formulation.  

    Parameters
    ----------

    problem :  
        : the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho .
        if dparam[3] >0 then rho=dparam[3] otherwise a computataion of rho is
        assumed.  

    """
    return _numerics.fc3d_fixedPointProjection(problem, reaction, velocity, options)

def fc3d_fixedPointProjection_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_fixedPointProjection_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for DSFP  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_fixedPointProjection_setDefaultSolverOptions(options)

def fc3d_VI_FixedPointProjection(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_VI_FixedPointProjection(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Fixed Point solver for friction-contact 3D problem based on the VI
    reformulation.  

    Parameters
    ----------

    problem :  
        : the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho .
        if dparam[3] >0 then rho=dparam[3] otherwise a computataion of rho is
        assumed.  

    """
    return _numerics.fc3d_VI_FixedPointProjection(problem, reaction, velocity, options)

def fc3d_VI_FixedPointProjection_Cylinder(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_VI_FixedPointProjection_Cylinder(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.fc3d_VI_FixedPointProjection_Cylinder(problem, reaction, velocity, options)

def fc3d_VI_FixedPointProjection_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_VI_FixedPointProjection_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for DSFP  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_VI_FixedPointProjection_setDefaultSolverOptions(options)

def fc3d_VI_FixedPointProjection_Cylinder_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_VI_FixedPointProjection_Cylinder_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.fc3d_VI_FixedPointProjection_Cylinder_setDefaultSolverOptions(options)

def fc3d_ExtraGradient(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_ExtraGradient(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Extra Gradient solver for friction-contact 3D problem based on the De Saxce
    Formulation.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho >0  

    """
    return _numerics.fc3d_ExtraGradient(problem, reaction, velocity, options)

def fc3d_ExtraGradient_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_ExtraGradient_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for EG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_ExtraGradient_setDefaultSolverOptions(options)

def fc3d_VI_ExtraGradient(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_VI_ExtraGradient(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Extra Gradient solver (VI_EG) for friction-contact 3D problem based on a VI
    reformulation.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho >0  

    """
    return _numerics.fc3d_VI_ExtraGradient(problem, reaction, velocity, options)

def fc3d_VI_ExtraGradient_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_VI_ExtraGradient_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for VI_EG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_VI_ExtraGradient_setDefaultSolverOptions(options)

def fc3d_HyperplaneProjection(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_HyperplaneProjection(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Hyperplane Projection solver for friction-contact 3D problem based on the De
    Saxce Formulation.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[3] : rho >0  

    """
    return _numerics.fc3d_HyperplaneProjection(problem, reaction, velocity, options)

def fc3d_AVI_gams_path(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_AVI_gams_path(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    solver using PATH (via GAMS) for friction-contact 3D problem based on an AVI
    reformulation  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options  

    """
    return _numerics.fc3d_AVI_gams_path(problem, reaction, velocity, options)

def fc3d_AVI_gams_pathvi(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_AVI_gams_pathvi(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    solver using PATHVI (via GAMS) for friction-contact 3D problem based on an AVI
    reformulation  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options  

    """
    return _numerics.fc3d_AVI_gams_pathvi(problem, reaction, velocity, options)

def fc3d_lcp_gams_path(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_lcp_gams_path(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    solver using PATH (via GAMS) for friction-contact 3D problem based on an AVI
    reformulation  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options  

    """
    return _numerics.fc3d_lcp_gams_path(problem, reaction, velocity, options)

def fc3d_lcp_gams_pathvi(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_lcp_gams_pathvi(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    solver using PATHVI (via GAMS) for friction-contact 3D problem based on an AVI
    reformulation  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options  

    """
    return _numerics.fc3d_lcp_gams_pathvi(problem, reaction, velocity, options)

def fc3d_HyperplaneProjection_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_HyperplaneProjection_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for EG  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    """
    return _numerics.fc3d_HyperplaneProjection_setDefaultSolverOptions(options)

def fc3d_checkTrivialCase(problem: "FrictionContactProblem", velocity: "double *", reaction: "double *", options: "SolverOptions") -> "int":
    r"""
    fc3d_checkTrivialCase(FrictionContactProblem *problem, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)reaction, SolverOptions *options) -> int

    Check for trivial solution in the friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        FrictionContactProblem* the problem  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    options :  
        the pointer to the array of options to set  

    Returns
    -------
    info =0 if a trivial solution has been found, else = -1  

    """
    return _numerics.fc3d_checkTrivialCase(problem, velocity, reaction, options)

def fc3d_nonsmooth_Newton_AlartCurnier2(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_nonsmooth_Newton_AlartCurnier2(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.fc3d_nonsmooth_Newton_AlartCurnier2(problem, reaction, velocity, options)

def fc3d_unitary_enumerative_free(problem: "FrictionContactProblem") -> "void":
    r"""
    fc3d_unitary_enumerative_free(FrictionContactProblem *problem) -> None

    """
    return _numerics.fc3d_unitary_enumerative_free(problem)

def fc3d_unitary_enumerative_initialize(problem: "FrictionContactProblem") -> "void":
    r"""
    fc3d_unitary_enumerative_initialize(FrictionContactProblem *problem) -> None

    """
    return _numerics.fc3d_unitary_enumerative_initialize(problem)

def fc3d_unitary_enumerative_solve(problem: "FrictionContactProblem", reaction: "double *", options: "SolverOptions") -> "int":
    r"""
    fc3d_unitary_enumerative_solve(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, SolverOptions *options) -> int

    """
    return _numerics.fc3d_unitary_enumerative_solve(problem, reaction, options)

def fc3d_unitary_enumerative_solve_sliding(problem: "FrictionContactProblem", reaction: "double *", options: "SolverOptions") -> "int":
    r"""
    fc3d_unitary_enumerative_solve_sliding(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, SolverOptions *options) -> int

    """
    return _numerics.fc3d_unitary_enumerative_solve_sliding(problem, reaction, options)

def fc3d_unitary_enumerative_test_non_sliding(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int":
    r"""
    fc3d_unitary_enumerative_test_non_sliding(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, SolverOptions *options) -> int

    """
    return _numerics.fc3d_unitary_enumerative_test_non_sliding(problem, reaction, velocity, options)

def fc3d_unitary_enumerative(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc3d_unitary_enumerative(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> int

    """
    return _numerics.fc3d_unitary_enumerative(problem, reaction, velocity, options)

def fc3d_unitary_enumerative_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc3d_unitary_enumerative_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.fc3d_unitary_enumerative_setDefaultSolverOptions(options)

def fc3d_unitary_enumerative_solve_poly_nu_sliding(problem: "FrictionContactProblem", reaction: "double *", options: "SolverOptions") -> "int":
    r"""
    fc3d_unitary_enumerative_solve_poly_nu_sliding(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, SolverOptions *options) -> int

    """
    return _numerics.fc3d_unitary_enumerative_solve_poly_nu_sliding(problem, reaction, options)

def fc2d_setDefaultSolverOptions(options: "SolverOptions", solverId: "int") -> "int":
    r"""
    fc2d_setDefaultSolverOptions(SolverOptions *options, int solverId) -> int

    set the default solver parameters and perform memory allocation for fc3d  

    Parameters
    ----------

    options :  
        the pointer to the options to set  

    solverId :  
        the identifier of the solver  

    """
    return _numerics.fc2d_setDefaultSolverOptions(options, solverId)

def fc2d_cpg(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc2d_cpg(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    cpg (conjugated projected gradient) solver for global contact problems with
    friction (2D)  

    Parameters
    ----------

    problem :  
        the friction-contact problem  

    reaction :  
        vector  

    velocity :  
        vector  

    info :  
        termination value  

    options :  
        structure for options  

    """
    return _numerics.fc2d_cpg(problem, reaction, velocity, options)

def fc2d_cpg_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc2d_cpg_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for CPG  

    Parameters
    ----------

    options :  
        SolverOptions * the pointer to the options to set  

    """
    return _numerics.fc2d_cpg_setDefaultSolverOptions(options)

def fc2d_nsgs(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc2d_nsgs(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    Non Linear Gauss Seidel solver for global contact problem with friction in 2D
    case.  

    Parameters
    ----------

    problem :  
        the friction-contact problem  

    reaction :  
        vector  

    velocity :  
        vector  

    info :  
        termination value  

    options :  
        structure  

    """
    return _numerics.fc2d_nsgs(problem, reaction, velocity, options)

def fc2d_nsgs_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc2d_nsgs_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for LATIN  

    Parameters
    ----------

    options :  
        the pointer to the options to set  

    """
    return _numerics.fc2d_nsgs_setDefaultSolverOptions(options)

def fc2d_latin(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc2d_latin(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    latin solver for global contact problem with friction in the 2D case.  

    Parameters
    ----------

    problem :  
        the friction-contact problem  

    reaction :  
        global vector  

    velocity :  
        global vector  

    info :  
        termination value  

    options :  
        SolverOptions structure  

    """
    return _numerics.fc2d_latin(problem, reaction, velocity, options)

def fc2d_latin_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc2d_latin_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for LATIN  

    Parameters
    ----------

    options :  
        the pointer to the options to set  

    """
    return _numerics.fc2d_latin_setDefaultSolverOptions(options)

def fc2d_projc(xi: "double []", n: "int *", statusi: "int []", p: "double []", fric: "double []", reaction: "double *", status: "int *") -> "void":
    r"""
    fc2d_projc(double xi[], int *n, int statusi[], double p[], double fric[], array_like (np.float64, 1D)reaction, int *status) -> None

    fc2d_projc is a specific projection operator related to CPG (conjugated
    projected gradient) algorithm for global contact problem with friction.  

    Parameters
    ----------

    xi :  
        the intermediate iterate which goes to be projected (projc1).  

    n :  
        the dimension of the system.  

    statusi :  
        a vector which contains the initial status.  

    p :  
        a vector which contains the components of the descent direction.  

    fric :  
        a vector which contains the friction coefficient.  

    reaction :  
        the corrected iterate.  

    status :  
        the new status.  

    """
    return _numerics.fc2d_projc(xi, n, statusi, p, fric, reaction, status)

def fc2d_projf(etat: "int []", n: "int *", y: "double []", fric: "double []", projf1: "double []") -> "void":
    r"""
    fc2d_projf(int etat[], int *n, double y[], double fric[], double projf1[]) -> None

    fc2d_projf is a specific projection operator related to CPG (conjugated
    projected gradient) algorithm for global contact problem with friction.  

    Parameters
    ----------

    etat :  
        parameter which represents the status vector.  

    n :  
        parameter which represents the dimension of the system.  

    y :  
        parameter which contains the components of the residue or descent direction
        vector.  

    fric :  
        parameter which contains the friction coefficient.  

    projf1 :  
        parameter which contains the projected residue or descent direction.  

    """
    return _numerics.fc2d_projf(etat, n, y, fric, projf1)

def fc2d_sparse_nsgs(problem: "FrictionContactProblem", z: "double *", w: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc2d_sparse_nsgs(FrictionContactProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, int *info, SolverOptions *options) -> None

    """
    return _numerics.fc2d_sparse_nsgs(problem, z, w, options)

def fc2d_sparse_nsgs_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc2d_sparse_nsgs_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for NSGS  

    Parameters
    ----------

    options :  
        the pointer to the options to set  

    """
    return _numerics.fc2d_sparse_nsgs_setDefaultSolverOptions(options)

def fc2d_lexicolemke(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc2d_lexicolemke(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    fc2d_lexicolemke is a Lemke solver for frictionContact2D problems.  

    Parameters
    ----------

    problem :  
        structure that represents the fc2d (M, q...)  

    reaction :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    velocity :  
        a n-vector of doubles which returns the solution of the problem.  

    options :  

    info :  
        an integer which returns the termination value: 0 = convergence, 1 = no
        convergence, 2 = Null diagonal term  

    """
    return _numerics.fc2d_lexicolemke(problem, reaction, velocity, options)

def fc2d_lexicolemke_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc2d_lexicolemke_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for Lemke  

    Parameters
    ----------

    options :  
        the pointer to options to set  

    """
    return _numerics.fc2d_lexicolemke_setDefaultSolverOptions(options)

def fc2d_tolcp(problem: "FrictionContactProblem", lcp_problem: "LCP") -> "int":
    r"""
    fc2d_tolcp(FrictionContactProblem *problem, LinearComplementarityProblem *lcp_problem) -> int

    This function transform a FrictionContactProblem (2D) into a
    LinearComplementarityProblem.  

    Parameters
    ----------

    problem :  
        A pointer to a FrictionContactProblem to transform  

    lcp_problem :  
        A pointer to a LinearComplementarity_problem resulting from the
        reformulation  

    """
    return _numerics.fc2d_tolcp(problem, lcp_problem)

def fc2d_enum_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    fc2d_enum_setDefaultSolverOptions(SolverOptions *options) -> int

    set the default solver parameters and perform memory allocation for enum solver  

    Parameters
    ----------

    options :  
        the pointer to options to set  

    """
    return _numerics.fc2d_enum_setDefaultSolverOptions(options)

def fc2d_enum(problem: "FrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    fc2d_enum(FrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    fc2d_enum solver for frictionContact2D problems.  

    Parameters
    ----------

    problem :  
        structure that represents the fc2d (M, q...)  

    reaction :  
        a n-vector of doubles which contains the initial solution and returns the
        solution of the problem.  

    velocity :  
        a n-vector of doubles which returns the solution of the problem.  

    options :  

    info :  
        an integer which returns the termination value: 0 = convergence, 1 = no
        convergence, 2 = Null diagonal term  

    """
    return _numerics.fc2d_enum(problem, reaction, velocity, options)

def fc3d_compute_error(problem: "FrictionContactProblem", z: "double *", w: "double *", tolerance: "double", options: "SolverOptions", norm: "double") -> "double *":
    r"""
    fc3d_compute_error(FrictionContactProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, double tolerance, SolverOptions *options, double norm, array_like (np.float64, 1D)error) -> int

    Error computation (using the normal map residual) for friction-contact 3D
    problem.  

    Parameters
    ----------

    problem :  
        the structure which defines the friction-contact problem  

    z :  
        vector  

    w :  
        vector  

    tolerance :  
        value for error computation  

    options :  

    norm :  
        norm of a vector (problem->q) for relative error  

    error :  
        value  

    Returns
    -------
    0 if ok  

    """
    return _numerics.fc3d_compute_error(problem, z, w, tolerance, options, norm)

def fc3d_unitary_compute_and_add_error(r: "double [3]", u: "double [3]", mu: "double", worktmp: "double *") -> "double *":
    r"""
    fc3d_unitary_compute_and_add_error(double r[3], double u[3], double mu, array_like (np.float64, 1D)error, array_like (np.float64, 1D)worktmp) -> None

    Error computation (using the normal map residual) for one friction-contact 3D
    problem.  

    Parameters
    ----------

    r :  
        the reaction force  

    u :  
        the local velocity  

    mu :  
        coeficient of friction  

    worktmp :  
        work vector  

    error :  
        value  

    """
    return _numerics.fc3d_unitary_compute_and_add_error(r, u, mu, worktmp)

def fc3d_compute_error_velocity(problem: "FrictionContactProblem", z: "double *", w: "double *", tolerance: "double", options: "SolverOptions") -> "double *":
    r"""
    fc3d_compute_error_velocity(FrictionContactProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, double tolerance, SolverOptions *options, array_like (np.float64, 1D)error) -> int

    Error computation for a friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the structure which defines the friction-contact problem  

    z :  
        vector  

    w :  
        vector  

    options :  

    tolerance :  
        value for error computation  

    error :  
        value  

    Returns
    -------
    0 if ok  

    """
    return _numerics.fc3d_compute_error_velocity(problem, z, w, tolerance, options)

def fc3d_Tresca_unitary_compute_and_add_error(z: "double [3]", w: "double [3]", R: "double", worktmp: "double *") -> "double *":
    r"""
    fc3d_Tresca_unitary_compute_and_add_error(double z[3], double w[3], double R, array_like (np.float64, 1D)error, array_like (np.float64, 1D)worktmp) -> None

    Error computation for one friction-contact 3D problem.  

    Parameters
    ----------

    z :  
        vector  

    w :  
        vector  

    R :  
        radius of the cylinder  

    worktmp :  
        work vector  

    error :  
        value  

    """
    return _numerics.fc3d_Tresca_unitary_compute_and_add_error(z, w, R, worktmp)

def fc3d_Tresca_compute_error(problem: "FrictionContactProblem", z: "double *", w: "double *", tolerance: "double", options: "SolverOptions", norm: "double") -> "double *":
    r"""
    fc3d_Tresca_compute_error(FrictionContactProblem *problem, array_like (np.float64, 1D)z, array_like (np.float64, 1D)w, double tolerance, SolverOptions *options, double norm, array_like (np.float64, 1D)error) -> int

    Error computation for friction-contact 3D problem with Tresca Friction.  

    Parameters
    ----------

    problem :  
        the structure which defines the friction-contact problem  

    z :  
        vector  

    w :  
        vector  

    tolerance :  
        value for error computation  

    options :  

    norm :  
        normalisation coeff  

    error :  
        value  

    Returns
    -------
    0 if ok  

    """
    return _numerics.fc3d_Tresca_compute_error(problem, z, w, tolerance, options, norm)

def frictionContactProblemFromFile(filename: "char const *") -> "FrictionContactProblem *":
    return _numerics.frictionContactProblemFromFile(filename)
GAMS_OPT_GENERAL = _numerics.GAMS_OPT_GENERAL
GAMS_OPT_SOLVER = _numerics.GAMS_OPT_SOLVER
class GAMS_opt_bool(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_numerics.GAMS_opt_bool_name_get, _numerics.GAMS_opt_bool_name_set)
    value = property(_numerics.GAMS_opt_bool_value_get, _numerics.GAMS_opt_bool_value_set)
    type = property(_numerics.GAMS_opt_bool_type_get, _numerics.GAMS_opt_bool_type_set)
    next_opt = property(_numerics.GAMS_opt_bool_next_opt_get, _numerics.GAMS_opt_bool_next_opt_set)

    def __init__(self):
        _numerics.GAMS_opt_bool_swiginit(self, _numerics.new_GAMS_opt_bool())
    __swig_destroy__ = _numerics.delete_GAMS_opt_bool

# Register GAMS_opt_bool in _numerics:
_numerics.GAMS_opt_bool_swigregister(GAMS_opt_bool)

class GAMS_opt_int(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_numerics.GAMS_opt_int_name_get, _numerics.GAMS_opt_int_name_set)
    value = property(_numerics.GAMS_opt_int_value_get, _numerics.GAMS_opt_int_value_set)
    type = property(_numerics.GAMS_opt_int_type_get, _numerics.GAMS_opt_int_type_set)
    next_opt = property(_numerics.GAMS_opt_int_next_opt_get, _numerics.GAMS_opt_int_next_opt_set)

    def __init__(self):
        _numerics.GAMS_opt_int_swiginit(self, _numerics.new_GAMS_opt_int())
    __swig_destroy__ = _numerics.delete_GAMS_opt_int

# Register GAMS_opt_int in _numerics:
_numerics.GAMS_opt_int_swigregister(GAMS_opt_int)

class GAMS_opt_double(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_numerics.GAMS_opt_double_name_get, _numerics.GAMS_opt_double_name_set)
    value = property(_numerics.GAMS_opt_double_value_get, _numerics.GAMS_opt_double_value_set)
    type = property(_numerics.GAMS_opt_double_type_get, _numerics.GAMS_opt_double_type_set)
    next_opt = property(_numerics.GAMS_opt_double_next_opt_get, _numerics.GAMS_opt_double_next_opt_set)

    def __init__(self):
        _numerics.GAMS_opt_double_swiginit(self, _numerics.new_GAMS_opt_double())
    __swig_destroy__ = _numerics.delete_GAMS_opt_double

# Register GAMS_opt_double in _numerics:
_numerics.GAMS_opt_double_swigregister(GAMS_opt_double)

class GAMS_opt_str(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_numerics.GAMS_opt_str_name_get, _numerics.GAMS_opt_str_name_set)
    value = property(_numerics.GAMS_opt_str_value_get, _numerics.GAMS_opt_str_value_set)
    type = property(_numerics.GAMS_opt_str_type_get, _numerics.GAMS_opt_str_type_set)
    next_opt = property(_numerics.GAMS_opt_str_next_opt_get, _numerics.GAMS_opt_str_next_opt_set)

    def __init__(self):
        _numerics.GAMS_opt_str_swiginit(self, _numerics.new_GAMS_opt_str())
    __swig_destroy__ = _numerics.delete_GAMS_opt_str

# Register GAMS_opt_str in _numerics:
_numerics.GAMS_opt_str_swigregister(GAMS_opt_str)

class SN_GAMSparams(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    model_dir = property(_numerics.SN_GAMSparams_model_dir_get, _numerics.SN_GAMSparams_model_dir_set)
    gams_dir = property(_numerics.SN_GAMSparams_gams_dir_get, _numerics.SN_GAMSparams_gams_dir_set)
    filename = property(_numerics.SN_GAMSparams_filename_get, _numerics.SN_GAMSparams_filename_set)
    filename_suffix = property(_numerics.SN_GAMSparams_filename_suffix_get, _numerics.SN_GAMSparams_filename_suffix_set)
    opt_str_list = property(_numerics.SN_GAMSparams_opt_str_list_get, _numerics.SN_GAMSparams_opt_str_list_set)
    opt_bool_list = property(_numerics.SN_GAMSparams_opt_bool_list_get, _numerics.SN_GAMSparams_opt_bool_list_set)
    opt_int_list = property(_numerics.SN_GAMSparams_opt_int_list_get, _numerics.SN_GAMSparams_opt_int_list_set)
    opt_double_list = property(_numerics.SN_GAMSparams_opt_double_list_get, _numerics.SN_GAMSparams_opt_double_list_set)

    def __init__(self, SO: "SolverOptions"):
        _numerics.SN_GAMSparams_swiginit(self, _numerics.new_SN_GAMSparams(SO))

    def gamsdir_set(self, strobj: "PyObject *") -> "void":
        return _numerics.SN_GAMSparams_gamsdir_set(self, strobj)

    def modeldir_set(self, strobj: "PyObject *") -> "void":
        return _numerics.SN_GAMSparams_modeldir_set(self, strobj)
    __swig_destroy__ = _numerics.delete_SN_GAMSparams

# Register SN_GAMSparams in _numerics:
_numerics.SN_GAMSparams_swigregister(SN_GAMSparams)

class SN_GAMS_NM_gdx(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    mat = property(_numerics.SN_GAMS_NM_gdx_mat_get, _numerics.SN_GAMS_NM_gdx_mat_set)
    name = property(_numerics.SN_GAMS_NM_gdx_name_get, _numerics.SN_GAMS_NM_gdx_name_set)
    next = property(_numerics.SN_GAMS_NM_gdx_next_get, _numerics.SN_GAMS_NM_gdx_next_set)

    def __init__(self):
        _numerics.SN_GAMS_NM_gdx_swiginit(self, _numerics.new_SN_GAMS_NM_gdx())
    __swig_destroy__ = _numerics.delete_SN_GAMS_NM_gdx

# Register SN_GAMS_NM_gdx in _numerics:
_numerics.SN_GAMS_NM_gdx_swigregister(SN_GAMS_NM_gdx)

class SN_GAMS_NV_gdx(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    vec = property(_numerics.SN_GAMS_NV_gdx_vec_get, _numerics.SN_GAMS_NV_gdx_vec_set)
    name = property(_numerics.SN_GAMS_NV_gdx_name_get, _numerics.SN_GAMS_NV_gdx_name_set)
    size = property(_numerics.SN_GAMS_NV_gdx_size_get, _numerics.SN_GAMS_NV_gdx_size_set)
    next = property(_numerics.SN_GAMS_NV_gdx_next_get, _numerics.SN_GAMS_NV_gdx_next_set)

    def __init__(self):
        _numerics.SN_GAMS_NV_gdx_swiginit(self, _numerics.new_SN_GAMS_NV_gdx())
    __swig_destroy__ = _numerics.delete_SN_GAMS_NV_gdx

# Register SN_GAMS_NV_gdx in _numerics:
_numerics.SN_GAMS_NV_gdx_swigregister(SN_GAMS_NV_gdx)

class SN_GAMS_gdx(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    mat_for_gdx = property(_numerics.SN_GAMS_gdx_mat_for_gdx_get, _numerics.SN_GAMS_gdx_mat_for_gdx_set)
    vec_for_gdx = property(_numerics.SN_GAMS_gdx_vec_for_gdx_get, _numerics.SN_GAMS_gdx_vec_for_gdx_set)
    vec_from_gdx = property(_numerics.SN_GAMS_gdx_vec_from_gdx_get, _numerics.SN_GAMS_gdx_vec_from_gdx_set)

    def __init__(self):
        _numerics.SN_GAMS_gdx_swiginit(self, _numerics.new_SN_GAMS_gdx())
    __swig_destroy__ = _numerics.delete_SN_GAMS_gdx

# Register SN_GAMS_gdx in _numerics:
_numerics.SN_GAMS_gdx_swigregister(SN_GAMS_gdx)


def GAMSP_get_filename(GP: "void const *") -> "char const *":
    r"""
    GAMSP_get_filename( None *GP) ->  char *

    """
    return _numerics.GAMSP_get_filename(GP)

def GAMSP_set_filename(GP: "void *", filename: "char *") -> "void":
    r"""
    GAMSP_set_filename(None *GP, char *filename) -> None

    """
    return _numerics.GAMSP_set_filename(GP, filename)

def GAMSP_get_filename_suffix(GP: "void const *") -> "char const *":
    r"""
    GAMSP_get_filename_suffix( None *GP) ->  char *

    """
    return _numerics.GAMSP_get_filename_suffix(GP)

def GAMSP_set_filename_suffix(GP: "void *", filename_suffix: "char *") -> "void":
    r"""
    GAMSP_set_filename_suffix(None *GP, char *filename_suffix) -> None

    """
    return _numerics.GAMSP_set_filename_suffix(GP, filename_suffix)

def SN_free_SN_GAMS_gdx(gdx_data: "SN_GAMS_gdx") -> "void":
    r"""
    SN_free_SN_GAMS_gdx(SN_GAMS_gdx *gdx_data) -> None

    """
    return _numerics.SN_free_SN_GAMS_gdx(gdx_data)

def SN_GAMS_add_NM_to_gdx(gdx_data: "SN_GAMS_gdx", M: "NumericsMatrix", name: "char *") -> "void":
    r"""
    SN_GAMS_add_NM_to_gdx(SN_GAMS_gdx *gdx_data, NumericsMatrix *M, char *name) -> None

    """
    return _numerics.SN_GAMS_add_NM_to_gdx(gdx_data, M, name)

def SN_GAMS_add_NV_to_gdx(gdx_data: "SN_GAMS_gdx", vec: "double *", name: "char *", size: "unsigned int") -> "void":
    r"""
    SN_GAMS_add_NV_to_gdx(SN_GAMS_gdx *gdx_data, array_like (np.float64, 1D)vec, char *name,  size) -> None

    """
    return _numerics.SN_GAMS_add_NV_to_gdx(gdx_data, vec, name, size)

def SN_GAMS_add_NV_from_gdx(gdx_data: "SN_GAMS_gdx", vec: "double *", name: "char *", size: "unsigned int") -> "void":
    r"""
    SN_GAMS_add_NV_from_gdx(SN_GAMS_gdx *gdx_data, array_like (np.float64, 1D)vec, char *name,  size) -> None

    """
    return _numerics.SN_GAMS_add_NV_from_gdx(gdx_data, vec, name, size)
class GlobalFrictionContactProblem(object):
    r"""

    The structure that defines a Friction-Contact (3D or 2D ) problem  

    Details in :ref:`global_fc_problem`  

    FORMULA98_ such that  

    FORMULA99_  

    and the set FORMULA100_ is its dual.  

    Generated class (swig), based on C++ header :ref:`pgm_numerics_src_FrictionContact_GlobalFrictionContactProblem.h`.


    Attributes
    ----------
     b : `array_like (np.float64, 1D)`  
        FORMULA101_  

     dimension : `int`  
        dimension FORMULA102_ or FORMULA103_ of the contact space (3D or 2D )  

     env : `None *`  
        opaque environment, solver specific  

     H : `NumericsMatrix *`  
        FORMULA104_, a matrix with FORMULA105_ stored in NumericsMatrix structure  

     M : `NumericsMatrix *`  
        FORMULA106_, a matrix with FORMULA107_ stored in NumericsMatrix structure  

     mu : `array_like (np.float64, 1D)`  
        mu FORMULA108_, vector of friction coefficients ( FORMULA109_
        numberOfContacts)  

     numberOfContacts : `int`  
        the number of contacts FORMULA110_  

     q : `array_like (np.float64, 1D)`  
        FORMULA111_  

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    dimension = property(_numerics.GlobalFrictionContactProblem_dimension_get, _numerics.GlobalFrictionContactProblem_dimension_set)
    numberOfContacts = property(_numerics.GlobalFrictionContactProblem_numberOfContacts_get, _numerics.GlobalFrictionContactProblem_numberOfContacts_set)
    M = property(_numerics.GlobalFrictionContactProblem_M_get, _numerics.GlobalFrictionContactProblem_M_set)
    H = property(_numerics.GlobalFrictionContactProblem_H_get, _numerics.GlobalFrictionContactProblem_H_set)
    q = property(_numerics.GlobalFrictionContactProblem_q_get, _numerics.GlobalFrictionContactProblem_q_set)
    b = property(_numerics.GlobalFrictionContactProblem_b_get, _numerics.GlobalFrictionContactProblem_b_set)
    mu = property(_numerics.GlobalFrictionContactProblem_mu_get, _numerics.GlobalFrictionContactProblem_mu_set)
    env = property(_numerics.GlobalFrictionContactProblem_env_get, _numerics.GlobalFrictionContactProblem_env_set)

    def __init__(self, *args):
        r"""

        The structure that defines a Friction-Contact (3D or 2D ) problem  

        Details in :ref:`global_fc_problem`  

        FORMULA98_ such that  

        FORMULA99_  

        and the set FORMULA100_ is its dual.  

        Generated class (swig), based on C++ header :ref:`pgm_numerics_src_FrictionContact_GlobalFrictionContactProblem.h`.


        Attributes
        ----------
         b : `array_like (np.float64, 1D)`  
            FORMULA101_  

         dimension : `int`  
            dimension FORMULA102_ or FORMULA103_ of the contact space (3D or 2D )  

         env : `None *`  
            opaque environment, solver specific  

         H : `NumericsMatrix *`  
            FORMULA104_, a matrix with FORMULA105_ stored in NumericsMatrix structure  

         M : `NumericsMatrix *`  
            FORMULA106_, a matrix with FORMULA107_ stored in NumericsMatrix structure  

         mu : `array_like (np.float64, 1D)`  
            mu FORMULA108_, vector of friction coefficients ( FORMULA109_
            numberOfContacts)  

         numberOfContacts : `int`  
            the number of contacts FORMULA110_  

         q : `array_like (np.float64, 1D)`  
            FORMULA111_  

        """
        _numerics.GlobalFrictionContactProblem_swiginit(self, _numerics.new_GlobalFrictionContactProblem(*args))
    __swig_destroy__ = _numerics.delete_GlobalFrictionContactProblem

# Register GlobalFrictionContactProblem in _numerics:
_numerics.GlobalFrictionContactProblem_swigregister(GlobalFrictionContactProblem)


def globalFrictionContact_display(problem: "GlobalFrictionContactProblem") -> "void":
    r"""
    globalFrictionContact_display(GlobalFrictionContactProblem *problem) -> None

    """
    return _numerics.globalFrictionContact_display(problem)

def globalFrictionContact_printInFile(problem: "GlobalFrictionContactProblem", file: "FILE *") -> "int":
    r"""
    globalFrictionContact_printInFile(GlobalFrictionContactProblem *problem, FILE *file) -> int

    """
    return _numerics.globalFrictionContact_printInFile(problem, file)

def globalFrictionContact_newFromFile(problem: "GlobalFrictionContactProblem", file: "FILE *") -> "int":
    r"""
    globalFrictionContact_newFromFile(GlobalFrictionContactProblem *problem, FILE *file) -> int

    """
    return _numerics.globalFrictionContact_newFromFile(problem, file)

def globalFrictionContact_null(problem: "GlobalFrictionContactProblem") -> "void":
    r"""
    globalFrictionContact_null(GlobalFrictionContactProblem *problem) -> None

    """
    return _numerics.globalFrictionContact_null(problem)

def freeGlobalFrictionContactProblem(problem: "GlobalFrictionContactProblem") -> "void":
    r"""
    freeGlobalFrictionContactProblem(GlobalFrictionContactProblem *problem) -> None

    """
    return _numerics.freeGlobalFrictionContactProblem(problem)

def gfc3d_setDefaultSolverOptions(options: "SolverOptions", solverId: "int") -> "int":
    r"""
    gfc3d_setDefaultSolverOptions(SolverOptions *options, int solverId) -> int

    set the default solver parameters and perform memory allocation for gfc3d  

    Parameters
    ----------

    options :  
        the pointer to the array of options to set  

    solverId :  
        int identifier of the solver  

    """
    return _numerics.gfc3d_setDefaultSolverOptions(options, solverId)

def gfc3d_set_internalsolver_tolerance(problem: "GlobalFrictionContactProblem", options: "SolverOptions", internalsolver_options: "SolverOptions", error: "double") -> "void":
    r"""
    gfc3d_set_internalsolver_tolerance(GlobalFrictionContactProblem *problem, SolverOptions *options, SolverOptions *internalsolver_options, double error) -> None

    """
    return _numerics.gfc3d_set_internalsolver_tolerance(problem, options, internalsolver_options, error)

def gfc3d_checkTrivialCaseGlobal(dim: "int", q: "double *", velocity: "double *", reaction: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int":
    r"""
    gfc3d_checkTrivialCaseGlobal(int dim, array_like (np.float64, 1D)q, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)globalVelocity, SolverOptions *options) -> int

    Check for trivial solution in the friction-contact 3D problem.  

    Parameters
    ----------

    dim :  
        of the problem  

    q :  
        global vector (n)  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        the velocity in global coordinates  

    options :  
        the pointer to the array of options to set  

    Returns
    -------
    int =0 if a trivial solution has been found, else = -1  

    """
    return _numerics.gfc3d_checkTrivialCaseGlobal(dim, q, velocity, reaction, globalVelocity, options)

def gfc3d_nsgs_wr(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_nsgs_wr(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    Non-Smooth Gauss Seidel solver with reformulation for friction-contact 3D
    problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        global vector (m), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number iparam[4] :
        localsolver choice 0: projection on Cone, 1: Newton/AlartCurnier, 2:
        projection on Cone with local iteration, 2: projection on Disk with
        diagonalization, dparam[0] : tolerance dparam[2] : localtolerance dparam[1]
        : (out) error  

    """
    return _numerics.gfc3d_nsgs_wr(problem, reaction, velocity, globalVelocity, options)

def gfc3d_nsgs_wr_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_nsgs_wr_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_nsgs_wr_setDefaultSolverOptions(options)

def gfc3d_admm_wr(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_admm_wr(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_admm_wr(problem, reaction, velocity, globalVelocity, options)

def gfc3d_admm_wr_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_admm_wr_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_admm_wr_setDefaultSolverOptions(options)

def gfc3d_nonsmooth_Newton_AlartCurnier_wr_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_nonsmooth_Newton_AlartCurnier_wr_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_nonsmooth_Newton_AlartCurnier_wr_setDefaultSolverOptions(options)

def gfc3d_nonsmooth_Newton_AlartCurnier_wr(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_nonsmooth_Newton_AlartCurnier_wr(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_nonsmooth_Newton_AlartCurnier_wr(problem, reaction, velocity, globalVelocity, options)

def gfc3d_proximal_wr(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_proximal_wr(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    Proximal point solver with reformulation for friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        global vector (m), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number iparam[4] :
        localsolver choice 0: projection on Cone, 1: Newton/AlartCurnier, 2:
        projection on Cone with local iteration, 2: projection on Disk with
        diagonalization, dparam[0] : tolerance dparam[2] : localtolerance dparam[1]
        : (out) error  

    """
    return _numerics.gfc3d_proximal_wr(problem, reaction, velocity, globalVelocity, options)

def gfc3d_proximal_wr_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_proximal_wr_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_proximal_wr_setDefaultSolverOptions(options)

def gfc3d_DeSaxceFixedPoint_wr(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_DeSaxceFixedPoint_wr(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    Fixed Point iteration on De Saxe formulation solver with reformulation for
    friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        global vector (m), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[0] :
        tolerance dparam[2] : localtolerance dparam[1] : (out) error  

    """
    return _numerics.gfc3d_DeSaxceFixedPoint_wr(problem, reaction, velocity, globalVelocity, options)

def gfc3d_DeSaxceFixedPoint_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_DeSaxceFixedPoint_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_DeSaxceFixedPoint_setDefaultSolverOptions(options)

def gfc3d_TrescaFixedPoint_wr(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_TrescaFixedPoint_wr(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    Fied Point iteration on Tresca Friction Cylinder with reformulation for
    friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        global vector (m), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[0] :
        tolerance dparam[2] : localtolerance dparam[1] : (out) error  

    """
    return _numerics.gfc3d_TrescaFixedPoint_wr(problem, reaction, velocity, globalVelocity, options)

def gfc3d_TrescaFixedPoint_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_TrescaFixedPoint_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_TrescaFixedPoint_setDefaultSolverOptions(options)

def gfc3d_nsgs_velocity_wr(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_nsgs_velocity_wr(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    Non-Smooth Gauss Seidel solver for friction-contact 3D problem with iteration on
    velocities.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        global vector (m), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number dparam[0] :
        tolerance dparam[2] : localtolerance dparam[1] : (out) error  

    """
    return _numerics.gfc3d_nsgs_velocity_wr(problem, reaction, velocity, globalVelocity, options)

def gfc3d_nsgs_velocity_wr_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_nsgs_velocity_wr_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_nsgs_velocity_wr_setDefaultSolverOptions(options)

def gfc3d_nsgs(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_nsgs(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    Non-Smooth Gauss Seidel solver for friction-contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        global vector (m), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number iparam[4] ; local
        strategy dparam[0] : tolerance dparam[2] : localtolerance dparam[1] : (out)
        error  

    """
    return _numerics.gfc3d_nsgs(problem, reaction, velocity, globalVelocity, options)

def gfc3d_ACLMFixedPoint(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_ACLMFixedPoint(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    Solver based on the fixed-point iteration proposed by Cadoux for friction-
    contact 3D problem.  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    globalVelocity :  
        global vector (m), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options : iparam[0] : Maximum iteration number iparam[4] ; local
        strategy dparam[0] : tolerance dparam[2] : localtolerance dparam[1] : (out)
        error  

    """
    return _numerics.gfc3d_ACLMFixedPoint(problem, reaction, velocity, globalVelocity, options)

def gfc3d_ACLMFixedPoint_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_ACLMFixedPoint_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_ACLMFixedPoint_setDefaultSolverOptions(options)

def gfc3d_AVI_gams_path(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_AVI_gams_path(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    solver using PATH (via GAMS) for friction-contact 3D problem based on an AVI
    reformulation  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options  

    """
    return _numerics.gfc3d_AVI_gams_path(problem, reaction, velocity, options)

def gfc3d_AVI_gams_pathvi(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_AVI_gams_pathvi(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, int *info, SolverOptions *options) -> None

    solver using PATHVI (via GAMS) for friction-contact 3D problem based on an AVI
    reformulation  

    Parameters
    ----------

    problem :  
        the friction-contact 3D problem to solve  

    velocity :  
        global vector (n), in-out parameter  

    reaction :  
        global vector (n), in-out parameters  

    info :  
        return 0 if the solution is found  

    options :  
        the solver options  

    """
    return _numerics.gfc3d_AVI_gams_pathvi(problem, reaction, velocity, options)

def gfc3d_nonsmooth_Newton_AlartCurnier(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_nonsmooth_Newton_AlartCurnier(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_nonsmooth_Newton_AlartCurnier(problem, reaction, velocity, globalVelocity, options)

def gfc3d_VI_ExtraGradient(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_VI_ExtraGradient(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_VI_ExtraGradient(problem, reaction, velocity, globalVelocity, options)

def gfc3d_VI_ExtraGradient_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_VI_ExtraGradient_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_VI_ExtraGradient_setDefaultSolverOptions(options)

def gfc3d_VI_FixedPointProjection(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_VI_FixedPointProjection(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_VI_FixedPointProjection(problem, reaction, velocity, globalVelocity, options)

def gfc3d_VI_FixedPointProjection_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_VI_FixedPointProjection_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_VI_FixedPointProjection_setDefaultSolverOptions(options)

def gfc3d_ADMM(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", options: "SolverOptions") -> "int *":
    r"""
    gfc3d_ADMM(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, int *info, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_ADMM(problem, reaction, velocity, globalVelocity, options)

def gfc3d_ADMM_init(problem: "GlobalFrictionContactProblem", options: "SolverOptions") -> "void":
    r"""
    gfc3d_ADMM_init(GlobalFrictionContactProblem *problem, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_ADMM_init(problem, options)

def gfc3d_ADMM_free(problem: "GlobalFrictionContactProblem", options: "SolverOptions") -> "void":
    r"""
    gfc3d_ADMM_free(GlobalFrictionContactProblem *problem, SolverOptions *options) -> None

    """
    return _numerics.gfc3d_ADMM_free(problem, options)

def gfc3d_ADMM_setDefaultSolverOptions(options: "SolverOptions") -> "int":
    r"""
    gfc3d_ADMM_setDefaultSolverOptions(SolverOptions *options) -> int

    """
    return _numerics.gfc3d_ADMM_setDefaultSolverOptions(options)

def gfc3d_compute_error(problem: "GlobalFrictionContactProblem", reaction: "double *", velocity: "double *", globalVelocity: "double *", tolerance: "double", options: "SolverOptions", norm: "double") -> "double *":
    r"""
    gfc3d_compute_error(GlobalFrictionContactProblem *problem, array_like (np.float64, 1D)reaction, array_like (np.float64, 1D)velocity, array_like (np.float64, 1D)globalVelocity, double tolerance, SolverOptions *options, double norm, array_like (np.float64, 1D)error) -> int

    Error computation for global friction-contact 3D problem The computation of the
    error uses as input the reaction (reaction) and the global velocity
    (globalVelocity) The value of the local velocity (velocity) is recomputed.  

    Parameters
    ----------

    problem :  
        the structure which defines the friction-contact problem  

    reaction :  

    velocity :  

    globalVelocity :  

    tolerance :  
        value for error computation  

    options :  
        pointer to SolverOptions  

    norm :  
        normalisation coeff  

    error :  
        value  

    Returns
    -------
    0 if successfull  

    """
    return _numerics.gfc3d_compute_error(problem, reaction, velocity, globalVelocity, tolerance, options, norm)


